drop procedure if exists SP_SET_POSTS_AUTHOR_CLONE;
create
    definer = skoiypp@`%` procedure SP_SET_POSTS_AUTHOR_CLONE(IN _id_author int)
BEGIN

    DECLARE p_last_id INT UNSIGNED;

-- ###########################
#     DECLARE exit handler for sqlexception
#         BEGIN
#             -- ERROR
#             SELECT -1 as return_code;
#             rollback;
#         END;
-- ###########################

    SET p_last_id = 0;

    START TRANSACTION;

    IF (SELECT count(1) FROM posts_authors WHERE id_author = _id_author)
    THEN
        INSERT INTO posts_authors(register_date) VALUES(now());
        SET p_last_id = last_insert_id();
        INSERT into posts_authors_l10n(id_author,name,email,iso_language,role,description,biography,image,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,register_date)
        SELECT p_last_id,CONCAT('Copy of ',name),email,iso_language,role,description,biography,image,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,now() FROM posts_authors_l10n WHERE id_author = _id_author;

        CALL SP_SET_POSTS_AUTHORS_CLONE_L10N(p_last_id,_id_author);
        SELECT id_author_l10n,id_author,name,email,iso_language,role,description,biography,image,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,register_date FROM posts_authors_l10n WHERE id_author = p_last_id;
    ELSE
        SELECT -2 as return_code;
    END IF;

    COMMIT;

END;

