create
    definer = skoiypp@`%` function FN_GET_ASSETS_SEARCH_BY(_id INT(10), _field VARCHAR(255), _query VARCHAR(255)) returns int(10)
BEGIN

DECLARE _total int(10);

CASE
WHEN _field = 'CORE_CONTENT' THEN 
SELECT count(1) into _total FROM assets_iptc_core_content WHERE id_asset = _id AND (Headline like _query OR Description like _query OR Keywords like _query OR SubjectCode like _query OR DescriptionWriter like _query);
WHEN _field = 'CORE_STATUS' THEN 
SELECT count(1) into _total FROM assets_iptc_core_status WHERE id_asset = _id AND (Title like _query OR JobID like _query OR Instructions like _query OR Credit like _query OR Source like _query OR CopyrightNotice like _query OR RightsUsageTerms like _query);
WHEN _field = 'CORE_IMAGE' THEN 
SELECT count(1) into _total FROM assets_iptc_core_image WHERE id_asset = _id AND (IntellectualGenre like _query OR Scene like _query OR Location like _query OR City like _query OR ProvinceState like _query OR Country like _query OR CountryCode like _query);
WHEN _field = 'CORE_CONTACT' THEN 
SELECT count(1) into _total FROM assets_iptc_core_contact WHERE id_asset = _id AND (Creator like _query OR CreatorJobtitle like _query OR CiAdrExtadr like _query OR CiAdrCity like _query OR CiAdrRegion like _query OR CiAdrPcode like _query OR CiAdrCtry like _query OR CiTelWork like _query OR CiEmailWork like _query OR CiUrlWork like _query);

WHEN _field = 'EXT_LOCATION_CREATED' THEN 
SELECT count(1) into _total FROM assets_iptc_extension_location_created WHERE id_asset = _id AND (PersonInImage like _query OR LocationCreatedSublocation like _query OR LocationCreatedCity like _query OR LocationCreatedProvinceState like _query OR LocationCreatedCountryName like _query OR LocationCreatedCountryCode like _query OR LocationCreatedWorldRegion like _query);

WHEN _field = 'EXT_LOCATION_SHOWN' THEN 
SELECT count(1) into _total FROM assets_iptc_extension_location_shown WHERE id_asset = _id AND (LocationShownSublocation like _query OR LocationShownCity like _query OR LocationShownProvinceState like _query OR LocationShownCountryName like _query OR LocationShownCountryCode like _query OR LocationShownWorldRegion like _query);

WHEN _field = 'EXT_ORGANISATION' THEN 
SELECT count(1) into _total FROM assets_iptc_extension_organisation WHERE id_asset = _id AND (OrganisationInImageName like _query OR OrganisationInImageCode like _query OR Event like _query);

WHEN _field = 'EXT_ARTWORK' THEN 
SELECT count(1) into _total FROM assets_iptc_extension_artwork WHERE id_asset = _id AND (ArtworkOrObject like _query OR ArtworkOrObjectAOTitle like _query OR ArtworkOrObjectAODateCreated like _query OR ArtworkOrObjectAOCreator like _query OR ArtworkOrObjectAOSource like _query OR ArtworkOrObjectAOSourceInvNo like _query OR ArtworkOrObjectAOCopyrightNotice like _query);

WHEN _field = 'EXT_MODELS_IMAGE' THEN 
SELECT count(1) into _total FROM assets_iptc_extension_models_image WHERE id_asset = _id AND (AddlModelInfo like _query OR ModelAge like _query OR ModelReleaseID like _query);

WHEN _field = 'EXT_ADMIN_INFO' THEN 
SELECT count(1) into _total FROM assets_iptc_extension_administrative_information WHERE id_asset = _id AND (ImageSupplier like _query OR ImageSupplierID like _query OR ImageSupplierImageID like _query OR RegistryID like _query OR RegistryIDRegOrgID like _query OR RegistryIDRegItemID like _query OR MaxAvailWidth like _query OR MaxAvailHeight like _query OR DigitalSourceType like _query);

WHEN _field = 'EXT_RIGHTS_RELATED' THEN 
SELECT count(1) into _total FROM assets_iptc_extension_rights_related WHERE id_asset = _id AND (ImageCreatorName like _query OR ImageCreatorID like _query OR CopyrightOwnerName like _query OR CopyrightOwnerID like _query OR LicensorName like _query OR LicensorID like _query OR LicensorTelephone1 like _query OR LicensorTelephone2 like _query OR LicensorEmail like _query OR PropertyReleaseID like _query);

ELSE SET _total = 0;
END CASE;

RETURN _total;

END;

