create
    definer = skoiypp@`%` procedure SP_DEL_POSTS_FROM_DOSSIERS(IN _id_dossier INT, IN _id_post INT)
BEGIN

DECLARE num_posts INT;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_post FROM posts_l10n WHERE id_post = _id_post) AND EXISTS (SELECT id_dossier FROM dossiers WHERE id_dossier = _id_dossier)
THEN

	SELECT FN_SP_SET_PUBLISH_POSTS_SYNC_UPDATE(41,_id_dossier) into _empty;
	SELECT FN_SP_SET_PUBLISH_POSTS_SYNC_UPDATE(410,_id_post) into _empty;

	DELETE FROM posts_dossiers_related WHERE id_dossier = _id_dossier AND id_post = _id_post;
	SELECT count(1) into num_posts FROM posts_dossiers_related WHERE id_post = _id_post;
	IF(num_posts = 0)
	THEN
		UPDATE posts_l10n SET state = 3 WHERE id_post = _id_post;			
	END IF;
	
	SET @rownum=0;
    UPDATE posts_dossiers_related p, (SELECT @rownum:=@rownum+1 rownum, posts_dossiers_related.* FROM posts_dossiers_related WHERE id_dossier = _id_dossier ORDER BY position,update_date desc) r 
    SET p.position = r.rownum
    WHERE (p.id_post = r.id_post);
    SELECT FN_SP_SET_PUBLISH_POSTS_SYNC_UPDATE(62,_id_dossier) into _empty;

    SELECT 0 as return_code;
ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

