create
    definer = skoiypp@`%` procedure SP_DEL_VIDEO_COMPOSED_FROM_PLAYLIST(IN _id_playlist INT, IN _id_composed INT)
BEGIN

DECLARE num_composes INT;
DECLARE profile_state INT;
DECLARE video_state INT;

DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_composed FROM video_composed WHERE id_composed = _id_composed) AND EXISTS (SELECT id_playlist FROM playlists WHERE id_playlist = _id_playlist)
THEN

	SELECT FN_SP_SET_PUBLISH_VIDEO_SYNC_UPDATE(41,_id_playlist) into _empty;
	SELECT FN_SP_SET_PUBLISH_VIDEO_SYNC_UPDATE(410,_id_composed) into _empty;

	DELETE FROM video_composed_playlists_related WHERE id_playlist = _id_playlist AND id_composed = _id_composed;
	SELECT count(1) into num_composes FROM video_composed_playlists_related WHERE id_composed = _id_composed;
	IF(num_composes = 0)
	THEN
		UPDATE video_composed SET state = 3 WHERE id_composed = _id_composed;
		
		SELECT max(vc.state) into video_state FROM videos v, video_composed vc WHERE v.id_video = vc.id_video
		AND v.id_video in (SELECT id_video FROM video_composed WHERE id_composed = _id_composed);
		SELECT max(vc.state) into profile_state FROM video_profiles vp, video_composed vc WHERE vp.id_profile = vc.id_profile
		AND vp.id_profile in (SELECT id_profile FROM video_composed WHERE id_composed = _id_composed);
			
		UPDATE videos set state = video_state
		WHERE id_video in (SELECT id_video FROM video_composed WHERE id_composed = _id_composed);

		UPDATE video_profiles_l10n set state = profile_state
		WHERE id_profile in (SELECT id_profile FROM video_composed WHERE id_composed = _id_composed);

	END IF;
	
	SET @rownum=0;
    UPDATE video_composed_playlists_related p, (SELECT @rownum:=@rownum+1 rownum, video_composed_playlists_related.* FROM video_composed_playlists_related WHERE id_playlist = _id_playlist ORDER BY position,update_date desc) r 
    SET p.position = r.rownum
    WHERE (p.id_composed = r.id_composed);
    SELECT FN_SP_SET_PUBLISH_VIDEO_SYNC_UPDATE(62,_id_playlist) into _empty;

    SELECT 0 as return_code;
ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

