create
    definer = skoiy@`%` procedure SP_GET_ACCOUNT_USERS_SERVICES(IN _id_account int, IN _id_user int)
BEGIN

    DECLARE _id_role INT UNSIGNED;
    DECLARE _role VARCHAR(192);


    DECLARE exit handler for sqlexception
        BEGIN
            
            SELECT -1 as return_code;
            rollback;
        END;


    START TRANSACTION;

    SELECT id_role into _id_role FROM users_accounts WHERE id_account = _id_account AND id_user = _id_user;
    SELECT description into _role FROM roles WHERE id_role = _id_role;


    IF(_id_role = 1)
    THEN
        SELECT id_service,_id_role as id_role,_role as role,  name,description, FN_GET_SERVICES(_id_account,id_service) as enabled, FN_GET_SERVICES_ACCOUNT_PATH(_id_account,id_service) as service_path FROM services ORDER BY enabled desc,name asc;
    ELSE
        SELECT id_service,_id_role as id_role,_role as role, name, description,FN_GET_USER_SERVICES(_id_user,_id_account,id_service) as enabled, FN_GET_SERVICES_ACCOUNT_PATH(_id_account,id_service) as service_path
        FROM services WHERE id_service in (SELECT id_service FROM accounts_services WHERE id_account = _id_account) ORDER BY enabled desc,name asc;
    END IF;

    COMMIT;

END;

