create
    definer = skoiypp@`%` procedure SP_GET_ADS_EXTERNAL_AD_TAGS_COUNT(IN _field int(10), IN _query varchar(192), IN _filter varchar(192))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;


SET @_name = CONCAT("%",_query,"%");
SET @_id_campaign = _filter;
SET @_id_external_ad_tag = _filter;
SET @_num_x = _filter;


SET sqlcommand = "SELECT count(1) as total FROM ads_external_ad_tags aext ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE name like @_name ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE active = 1 AND name like @_name ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE active = 0 AND name like @_name ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_external_ad_tag in (SELECT distinct id_external_ad_tag FROM ads_campaigns_groups_external_ad_tags) AND name like @_name ");
WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_external_ad_tag in (SELECT distinct id_external_ad_tag FROM ads_campaigns_groups_external_ad_tags WHERE id_campaign_group in (SELECT id_campaign_group FROM ads_campaigns_groups WHERE id_campaign = @_id_campaign) AND name like @_name ");
WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_external_ad_tag = @_id_external_ad_tag ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt;    
   
COMMIT;

END;

