create
    definer = skoiypp@`%` procedure SP_GET_ARCHIVE_TAGS(IN _field int(10), IN _query varchar(192),
                                                        IN _filter varchar(192), IN _limit_a int, IN _limit_b int)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM archive_tags;
END IF;

SET @_name = CONCAT("%",_query,"%");
SET @_id_video = _filter;
SET @_id_clip = _filter;
SET @_num_x = _filter;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = "SELECT id_tag, name,name_stripped, public, FN_GET_ARCHIVE_TAGS_TOTAL_VIDEOS(id_tag) as total_videos,FN_GET_ARCHIVE_TAGS_TOTAL_SEGMENTS(id_tag) as total_segments,FN_GET_ARCHIVE_TAGS_TOTAL_CLIPS(id_tag) as total_clips FROM archive_tags pt ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE name like @_name ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE public = 1 AND name like @_name ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE public = 0 AND name like @_name ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_tag in (SELECT distinct id_tag FROM archive_videos_tags_related) AND name like @_name ");
WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_tag in (SELECT distinct id_tag FROM archive_clips_tags_related) AND name like @_name ");
WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_tag in (SELECT distinct id_tag FROM archive_videos_tags_related WHERE id_video = @_id_video) AND name like @_name ");
WHEN _field = 7 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_tag in (SELECT distinct id_tag FROM archive_clips_tags_related WHERE id_clip = @_id_clip) AND name like @_name ");
WHEN _field = 8 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_tag in (SELECT distinct id_tag FROM archive_videos_segment_tags_related) AND name like @_name ");
WHEN _field = 9 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE name_stripped in (SELECT name_stripped FROM (SELECT count(1) as total,name_stripped FROM archive_tags GROUP BY name_stripped) as tt WHERE total > 1) AND name like @_name ");
WHEN _field = 10 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE (FN_GET_ARCHIVE_TAGS_TOTAL_VIDEOS(id_tag) + FN_GET_ARCHIVE_TAGS_TOTAL_SEGMENTS(id_tag) + FN_GET_ARCHIVE_TAGS_TOTAL_CLIPS(id_tag)) = @_num_x AND name like @_name ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name LIMIT ?,?");
SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;    
   
COMMIT;

END;

