create
    definer = skoiypp@`%` procedure SP_GET_ARCHIVE_TAGS_COUNT(IN _field int(10), IN _id_group int(10),
                                                              IN _query varchar(192), IN _filter varchar(192))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_name = CONCAT("%",_query,"%");
SET @_id_group = _id_group;
SET @_id_video = _filter;
SET @_id_clip = _filter;
SET @_id_key = _filter;
SET @_num_x = _filter;

SET sqlcommand = "SELECT count(1) as total FROM archive_tags pt WHERE 1=1 ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND name like @_name ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND public = 1 AND name like @_name ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND public = 0 AND name like @_name ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_tag in (SELECT distinct id_tag FROM archive_videos_tags_related) AND name like @_name ");
WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_tag in (SELECT distinct id_tag FROM archive_clips_tags_related) AND name like @_name ");
WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_tag in (SELECT distinct id_tag FROM archive_videos_tags_related WHERE id_video = @_id_video) AND name like @_name ");
WHEN _field = 7 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_tag in (SELECT distinct id_tag FROM archive_clips_tags_related WHERE id_clip = @_id_clip) AND name like @_name ");
WHEN _field = 8 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_tag in (SELECT distinct id_tag FROM archive_videos_segment_tags_related) AND name like @_name ");
WHEN _field = 9 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND name_stripped in (SELECT name_stripped FROM (SELECT count(1) as total,name_stripped FROM archive_tags GROUP BY name_stripped) as tt WHERE total > 1) AND name like @_name ");
WHEN _field = 10 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (FN_GET_ARCHIVE_TAGS_TOTAL_VIDEOS(id_tag) + FN_GET_ARCHIVE_TAGS_TOTAL_SEGMENTS(id_tag) + FN_GET_ARCHIVE_TAGS_TOTAL_CLIPS(id_tag)) = @_num_x AND name like @_name ");

WHEN _field = 11 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_tag in (SELECT distinct id_tag FROM archive_tags_variants_related WHERE id_key = @_id_key) AND name like @_name ");
WHEN _field = 12 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_tag in (SELECT id_tag FROM archive_tags_variants_related) AND name like @_name ");
WHEN _field = 13 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_tag = _id_tag AND name like @_name ");

ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

	IF (_id_group > 0)
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," AND id_group = @_id_group ");
	END IF;

SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt;    
   
COMMIT;

END;

