create
    definer = skoiypp@`%` procedure SP_GET_ARCHIVE_VIDEOS_SEGMENT_TAGS_RELATED(IN _field INT, IN _filter varchar(192),
                                                                               IN _limit_a INT, IN _limit_b INT)
BEGIN

DECLARE _id_video INT(10);
DECLARE _id_tag INT(10);
DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
	SELECT count(1) into _limit_b FROM archive_videos_segment_tags_related;
END IF;

SET _id_video = _filter;
SET _id_tag = _filter;
SET @_tags_group = CONCAT("%",_filter,"%");
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

IF(_field = 1)
THEN
	IF EXISTS(SELECT id_video FROM archive_videos_segment_tags_related WHERE id_video = _id_video)
	THEN
		SELECT vt.id_tag,vt.name as tag_name,name_stripped, public,av.id_video,av.name as video_name,av.filename,avp.filename as preview_filename, avp.bitrate,av.mime_type,av.width,av.height,av.ratio,seconds,av.size, seconds_in,seconds_out,av.register_date FROM archive_videos_segment_tags_related vvstr, archive_tags vt, archive_videos av, archive_videos_previews avp WHERE avp.id_video = av.id_video AND vt.id_tag = vvstr.id_tag AND av.id_video = vvstr.id_video AND av.deleted = 0 AND vvstr.id_video = _id_video;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;

IF(_field = 2)
THEN
	IF EXISTS(SELECT id_video FROM archive_videos_segment_tags_related WHERE id_tag = _id_tag)
	THEN
		SELECT vt.id_tag,vt.name as tag_name,name_stripped, public,av.id_video,av.name as video_name,av.filename,avp.filename as preview_filename, avp.bitrate,av.mime_type,av.width,av.height,av.ratio,seconds,av.size, seconds_in,seconds_out,av.register_date FROM archive_videos_segment_tags_related vvstr, archive_tags vt, archive_videos av, archive_videos_previews avp WHERE avp.id_video = av.id_video AND vt.id_tag = vvstr.id_tag AND av.id_video = vvstr.id_video AND av.deleted = 0 AND vvstr.id_tag = _id_tag;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;

IF(_field = 3)
THEN
	SET sqlcommand = "SELECT FN_GET_ARCHIVE_VIDEOS_INSTREAM_TAGS_GROUPED(vvstr.id_video,vvstr.seconds_in,vvstr.seconds_out,2) as id_tag,FN_GET_ARCHIVE_VIDEOS_INSTREAM_TAGS_GROUPED(vvstr.id_video,vvstr.seconds_in,vvstr.seconds_out,3) as tag_name,FN_GET_ARCHIVE_VIDEOS_INSTREAM_TAGS_GROUPED(vvstr.id_video,vvstr.seconds_in,vvstr.seconds_out,1) as name_stripped, public,av.id_video,av.name as video_name,av.filename,avp.filename as preview_filename, avp.bitrate,av.mime_type,av.width,av.height,av.ratio,seconds,av.size, seconds_in,seconds_out,av.register_date 
	FROM archive_videos_segment_tags_related vvstr, archive_tags vt, archive_videos av, archive_videos_previews avp WHERE avp.id_video = av.id_video AND vt.id_tag = vvstr.id_tag AND av.id_video = vvstr.id_video AND av.deleted = 0 
	AND FN_GET_ARCHIVE_VIDEOS_INSTREAM_TAGS_GROUPED(vvstr.id_video,vvstr.seconds_in,vvstr.seconds_out,2) like @_tags_group GROUP by vvstr.id_video,vvstr.seconds_in,vvstr.seconds_out LIMIT ?,?";
	SET @sqlcommand = sqlcommand;
	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt USING @_limit_a,@_limit_b;
END IF;
        
COMMIT;

END;

