create
    definer = skoiypp@`%` procedure SP_GET_ARCHIVE_VIDEOS_TAGS_RELATED(IN _room varchar(5), IN _id_user int(10),
                                                                       IN _id_video int, IN _id_directory int,
                                                                       IN _field int(10), IN _field_snd int(10),
                                                                       IN _field_trd int(10), IN _query varchar(192),
                                                                       IN _filter varchar(192),
                                                                       IN _filter_snd varchar(192),
                                                                       IN _filter_trd varchar(192),
                                                                       IN _limit_sys_a bigint, IN _limit_sys_b bigint)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;



START TRANSACTION;

SET @room = _room;
SET @id_user = _id_user;
SET @_room = _filter_snd;

SET @_id_video = _id_video;
SET @_id_video = @_filter_snd;
SET @_name = CONCAT("%",_query,"%");
SET @_cfilter = _filter;
SET @_filter = CONCAT("%",_filter,"%");

SET @_limit_sys_a = _limit_sys_a;
SET @_limit_sys_b = _limit_sys_b;
SET @_id_directory = _id_directory;

IF(_id_video < 1)
THEN
	SET sqlcommand = "SELECT vt.id_tag,vt.name,name_stripped, public, (SELECT count(1) FROM archive_videos_tags_related avtr_sub WHERE id_tag = vt.id_tag AND avtr_sub.id_video in (SELECT id_video FROM archive_videos av WHERE av.deleted = 0  ";
	
	IF (_room <> '')
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," AND FN_GET_ARCHIVE_VIDEO_IN_ROOM(av.id_video,@id_user,@room) = 1 ");
	END IF;

	IF (_id_directory > 0)
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," AND av.id_directory = @_id_directory ");
	END IF;

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (av.id_video = @_id_video ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (av.id_video in (SELECT distinct id_video FROM archive_clips) ) ");
			WHEN _field_snd = 102 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (av.id_video in (SELECT distinct id_video FROM archive_transfers_videos_related) ) ");
			WHEN _field_snd = 103 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (av.id_video in (SELECT distinct id_video FROM archive_videos_segment_tags_related) ) ");
			WHEN _field_snd = 104 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (av.id_video in (SELECT distinct id_video FROM archive_rooms_related) ) ");
			WHEN _field_snd = 105 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (av.id_video in (SELECT distinct id_video FROM archive_rooms_related AND room = @_room) ) ");			
		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;

	CASE
	WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND av.name like @_name ");
	WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (av.state = @_cfilter) AND (av.name like @_name) ");
	WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (av.height like @_filter) AND (av.name like @_name) ");
	WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (av.ratio like @_filter) AND (av.name like @_name) ");
	WHEN _field = 7 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (av.mime_type like @_filter) AND (av.name like @_name) ");
	WHEN _field = 8 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (av.size BETWEEN @_limit_sys_a AND @_limit_sys_b) AND (av.name like @_name ) ");
	WHEN _field = 9 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (av.seconds BETWEEN @_limit_sys_a AND @_limit_sys_b) AND (av.name like @_name ) ");
	WHEN _field = 10 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (av.bitrate BETWEEN @_limit_sys_a AND @_limit_sys_b) AND (av.name like @_name ) ");
	ELSE SET sqlcommand = CONCAT(sqlcommand, " ");
	END CASE;

	SET sqlcommand = CONCAT(sqlcommand," )) as total_videos FROM archive_videos_tags_related vvtr, archive_tags vt, archive_videos av2 WHERE vt.id_tag = vvtr.id_tag AND av2.id_video = vvtr.id_video AND av2.deleted = 0 GROUP BY id_tag ORDER by name ");

	SET @sqlcommand = sqlcommand;
	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt;
ELSE
	IF EXISTS(SELECT id_video FROM archive_videos_tags_related WHERE id_video = _id_video)
	THEN
		SELECT vt.id_tag,vt.name,name_stripped, public, (SELECT count(1) FROM archive_videos_tags_related WHERE id_tag = vt.id_tag) as total_videos FROM archive_videos_tags_related vvtr, archive_tags vt, archive_videos av WHERE vt.id_tag = vvtr.id_tag AND av.id_video = vvtr.id_video AND av.deleted = 0 AND vvtr.id_video = _id_video;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;
        
COMMIT;

END;

