create
    definer = skoiypp@`%` procedure SP_GET_ASSETS_COUNT(IN _room varchar(5), IN _id_user int(10),
                                                        IN _id_directory int(10), IN _field int(10),
                                                        IN _field_snd int(10), IN _field_trd int(10),
                                                        IN _query varchar(192), IN _filter varchar(192),
                                                        IN _filter_snd varchar(192), IN _filter_trd varchar(192),
                                                        IN _limit_size_a bigint, IN _limit_size_b bigint)
BEGIN

DECLARE sqlcommand text;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

SET @room = _room;
SET @id_user = _id_user;

SET @room = _room;
SET @id_user = _id_user;

SET @_name = CONCAT("%",_query,"%");
SET @_description = CONCAT("%",_query,"%");
SET @_cfilter = _filter;
SET @_filter = CONCAT("%",_filter,"%");
SET @_filename = CONCAT("%",_filter_snd,"%");

SET @_tags_stripped = CONCAT("%",_query,"%");
-- SET @_tags_group = CONCAT("%",_filter_trd,"%");
SET @_tags_group = REPLACE(_filter_trd,'%','');

SET @_filterTypes = _filter_trd;
SET @_id_asset = _filter_snd;
SET @_id_post = _filter_snd;
SET @_id_album = _filter_snd;
SET @_room = _filter_snd;

SET @_limit_size_a = _limit_size_a;
SET @_limit_size_b = _limit_size_b;
SET @_id_directory = _id_directory;
SET @label = _filter_snd;
SET @id_label = _filter_snd;

SET @_year = year(_filter);
SET @_month = month(_filter);
SET @_day = day(_filter);


IF(_id_directory = -1)
THEN
	SET sqlcommand = "SELECT count(1) as total FROM assets a WHERE id_directory is null AND deleted = 0 ";
	
	IF (_room <> '')
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," AND FN_GET_ASSETS_ASSET_IN_ROOM(id_asset,@id_user,@room) = 1 ");
	END IF;

	SET @sqlcommand = sqlcommand;
	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt;
ELSE
	IF (_id_directory = 0) OR (SELECT count(1) FROM assets_directories WHERE id_directory = _id_directory)
	THEN

	SET sqlcommand = "SELECT count(1) as total FROM assets a WHERE deleted = 0 ";
	
	IF (_room <> '')
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," AND FN_GET_ASSETS_ASSET_IN_ROOM(id_asset,@id_user,@room) = 1 ");
	END IF;

	IF (_id_directory > 0 AND _field <> 14)
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," AND id_directory = @_id_directory ");
	END IF;
    
	IF (_field = 14)
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," AND 0=1 ");
	END IF;

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_asset = @_id_asset ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_asset in (SELECT distinct id_asset FROM assets_albums_related) ) ");
			WHEN _field_snd = 102 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_asset in (SELECT distinct id_asset FROM assets_transfers_related) ) ");
			WHEN _field_snd = 103 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_asset in (SELECT distinct id_asset FROM assets_rooms_related) ) ");
			WHEN _field_snd = 104 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_asset in (SELECT distinct id_asset FROM assets_rooms_related AND room = @_room) ) ");
			WHEN _field_snd = 105 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_asset in (SELECT distinct id_asset FROM assets_albums_related WHERE id_album = @_id_album) ) ");	
			WHEN _field_snd = 106 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND filename like @_filename ");
			
            WHEN _field_snd = 107 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_asset in (SELECT id_asset FROM assets_labels_related) ) ");
			WHEN _field_snd = 108 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_asset in (SELECT id_asset FROM assets_labels_related WHERE (id_label = @id_label OR id_label in (SELECT id_label FROM assets_labels WHERE name_stripped = @label)) )) ");

			WHEN _field_snd = 113 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND FN_GET_ASSETS_IS_FILE_TYPE(id_asset,@_filterTypes) = 1 ");
			WHEN _field_snd = 114 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_asset in (SELECT distinct id_asset FROM posts_l10n_photos) ) ");
			WHEN _field_snd = 115 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_asset in (SELECT distinct id_asset FROM posts_l10n_photos WHERE id_l10n in (SELECT id_l10n FROM posts_l10n WHERE id_post = @_id_post)) OR filename in (SELECT image FROM posts_l10n WHERE id_post = @_id_post)) ");      
	ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;

	-- 	 SET sqlcommand =  CONCAT(sqlcommand, " AND (SELECT FN_MATCH_ASSETS_TAGS_GROUPED(a.id_asset) like @_tags_group ) ");

	IF (_field_trd > 0)
	THEN
		CASE
			WHEN _field_trd = 1000 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_asset in (SELECT id_asset FROM assets_tags_related WHERE FIND_IN_SET(id_tag,@_tags_group) ) ");
			WHEN _field_trd = 1001 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND FN_GET_ASSETS_IS_FILE_TYPE(id_asset,@_filterTypes) = 1 ");
			WHEN _field_trd = 2000 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND FN_GET_ASSETS_IS_FILE_TYPE(id_asset,'IMAGE') = 1 AND id_asset in (SELECT id_asset FROM assets_tags_related WHERE FIND_IN_SET(id_tag,@_tags_group) ) ");
			WHEN _field_trd = 2001 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND FN_GET_ASSETS_IS_FILE_TYPE(id_asset,'AUDIO') = 1 AND id_asset in (SELECT id_asset FROM assets_tags_related WHERE FIND_IN_SET(id_tag,@_tags_group) ) ");
			WHEN _field_trd = 2002 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND FN_GET_ASSETS_IS_FILE_TYPE(id_asset,'DOC,COMPRESS') = 1 AND id_asset in (SELECT id_asset FROM assets_tags_related WHERE FIND_IN_SET(id_tag,@_tags_group) ) ");
		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;    

	CASE
	WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (name like @_name OR description like @_description OR FN_GET_ASSETS_SEARCH(id_asset,@_name) = 1 OR ((SELECT count(1) FROM assets_tags at, assets_tags_related atr WHERE at.id_tag = atr.id_tag AND atr.id_asset = a.id_asset AND name_stripped like @_tags_stripped) > 0)) ");
	WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND name like @_name ");
	WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND description like @_description ");
	WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_asset in (SELECT id_asset FROM assets_tags_related WHERE FIND_IN_SET(id_tag,@_cfilter) )) AND (name like @_name OR description like @_description) ");
	WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(created_date) = @_year AND month(created_date) = @_month) AND (name like @_name OR description like @_description) ");
	WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(created_date) = @_year) AND (name like @_name OR description like @_description) ");
	WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (state = @_cfilter) AND (name like @_name OR description like @_description) ");
	WHEN _field = 7 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (mime_type like @_filter) AND (name like @_name OR description like @_description) ");
	WHEN _field = 8 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (CONCAT(width,'x',height) like @_filter) AND (name like @_name OR description like @_description) ");
	WHEN _field = 9 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (size BETWEEN @_limit_size_a AND @_limit_size_b) AND (name like @_name OR description like @_description) ");

	WHEN _field = 11 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = @_year AND month(register_date) = @_month) AND day(register_date) = @_day) ");
	WHEN _field = 12 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = @_year AND month(register_date) = @_month) ");
	WHEN _field = 13 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = @_year) ");

	ELSE SET sqlcommand = CONCAT(sqlcommand, " ");
	END CASE;

	SET @sqlcommand = sqlcommand;

	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt; 

	ELSE
	    SELECT -2 as return_code;
	END IF;
END IF;	

COMMIT;

END;

