create
    definer = skoiypp@`%` procedure SP_GET_ASSETS_EMBED_ASSETS_RELATED(IN _field int(10), IN _filter varchar(192))
BEGIN
-- call SP_GET_ASSETS_EMBED_ASSETS_RELATED(1,1)
DECLARE sqlcommand text;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

SET @_id = _filter;

IF EXISTS (SELECT id FROM assets_embeds WHERE id = _filter )
THEN

	SET sqlcommand = "SELECT id,ae.id_asset,filename,position,ae.headline,ae.title,ae.description,ae.action_name,ae.link,ae.register_date FROM assets_embeds_assets_related ae, assets a WHERE ae.id_asset = a.id_asset AND id = @_id AND FN_GET_ASSETS_IS_DELETED(ae.id_asset) = 0 ORDER by position";

	SET @sqlcommand = sqlcommand;

	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt; 

	ELSE
	    SELECT -2 as return_code;
	END IF;

COMMIT;

END;

