create
    definer = skoiypp@`%` procedure SP_GET_ASSETS_SYSTEM_TAGS(IN _room varchar(5), IN _id_user int(10),
                                                              IN _id_directory int(10), IN _field int(10),
                                                              IN _field_snd int(10), IN _field_trd int(10),
                                                              IN _query varchar(192), IN _filter varchar(192),
                                                              IN _filter_snd varchar(192), IN _filter_trd varchar(192),
                                                              IN _limit_sys_a bigint, IN _limit_sys_b bigint)
BEGIN

DECLARE sqlcommand text;
DECLARE sqlcommand_mime_type text;
DECLARE sqlcommand_height text;
DECLARE sqlcommand_size text;

DECLARE sqlcommand_1_1 text;
DECLARE sqlcommand_dir text;
DECLARE sqlcommand_room text;
DECLARE sqlcommand_100 text;
DECLARE sqlcommand_101 text;
DECLARE sqlcommand_102 text;
DECLARE sqlcommand_103 text;
DECLARE sqlcommand_104 text;
DECLARE sqlcommand_105 text;
DECLARE sqlcommand_107 text;
DECLARE sqlcommand_108 text;
DECLARE sqlcommand_1000 text;
DECLARE sqlcommand_query text;



DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;



START TRANSACTION;

SET @room = _room;
SET @id_user = _id_user;

SET @_name = CONCAT("%",_query,"%");
SET @_description = CONCAT("%",_query,"%");
SET @_filter = CONCAT("%",_filter,"%");
SET @_cfilter = _filter;


SET @_tags_group = _filter_trd;
SET @_id_asset = _filter_snd;
SET @_id_album = _filter_snd;
SET @_room = _filter_snd;
SET @label = _filter_snd;
SET @id_label = _filter_snd;

SET @_limit_sys_a = _limit_sys_a;
SET @_limit_sys_b = _limit_sys_b;
SET @_id_directory = _id_directory;

SET sqlcommand_1_1 = " AND 1=1 ";
SET sqlcommand_dir = " AND a.id_directory = @_id_directory ";
SET sqlcommand_room = " AND FN_GET_ASSETS_ASSET_IN_ROOM(a.id_asset,@id_user,@room) = 1 ";
SET sqlcommand_100 = " AND (a.id_asset = @_id_asset ) ";
SET sqlcommand_101 = " AND (a.id_asset in (SELECT distinct id_asset FROM assets_albums_related) ) ";
SET sqlcommand_102 = " AND (a.id_asset in (SELECT distinct id_asset FROM assets_transfers_related) ) ";
SET sqlcommand_103 = " AND (a.id_asset in (SELECT distinct id_asset FROM assets_rooms_related) ) ";
SET sqlcommand_104 = " AND (a.id_asset in (SELECT distinct id_asset FROM assets_rooms_related AND room = @_room) ) ";
SET sqlcommand_105 = " AND (a.id_asset in (SELECT distinct id_asset FROM assets_albums_related WHERE id_album = @_id_album) ) ";

SET sqlcommand_107 = " AND (a.id_asset in (SELECT id_asset FROM assets_labels_related) ) ";
SET sqlcommand_108 = " AND (a.id_asset in (SELECT id_asset FROM assets_labels_related WHERE (id_label = @id_label OR id_label in (SELECT id_label FROM assets_labels WHERE name_stripped = @label)) )) ";


SET sqlcommand_1000 = " AND a.id_asset in (SELECT id_asset FROM assets_tags_related WHERE FIND_IN_SET(id_tag,@_tags_group) ) ";
SET sqlcommand_query = " AND a.name like @_name ";




SET sqlcommand_mime_type = "SELECT 1 as type,mime_type as rvalue, (SELECT count(1) FROM assets a WHERE a.deleted = 0 AND a.mime_type = a2.mime_type "; 
	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand_mime_type =  CONCAT(sqlcommand_mime_type, " ",sqlcommand_100);
			WHEN _field_snd = 101 THEN SET sqlcommand_mime_type =  CONCAT(sqlcommand_mime_type, " ",sqlcommand_101);
			WHEN _field_snd = 102 THEN SET sqlcommand_mime_type =  CONCAT(sqlcommand_mime_type, " ",sqlcommand_102);
			WHEN _field_snd = 103 THEN SET sqlcommand_mime_type =  CONCAT(sqlcommand_mime_type, " ",sqlcommand_103);
			WHEN _field_snd = 104 THEN SET sqlcommand_mime_type =  CONCAT(sqlcommand_mime_type, " ",sqlcommand_104);
			WHEN _field_snd = 105 THEN SET sqlcommand_mime_type =  CONCAT(sqlcommand_mime_type, " ",sqlcommand_105);
			WHEN _field_snd = 107 THEN SET sqlcommand_mime_type =  CONCAT(sqlcommand_mime_type, " ",sqlcommand_107);
			WHEN _field_snd = 108 THEN SET sqlcommand_mime_type =  CONCAT(sqlcommand_mime_type, " ",sqlcommand_108);
		ELSE SET sqlcommand_mime_type = CONCAT(sqlcommand_mime_type, " ",sqlcommand_1_1);
		END CASE;
	END IF;



SET sqlcommand_height = "SELECT 2,height as resolution, (SELECT count(1) FROM assets a WHERE a.deleted = 0 AND a.height = a2.height ";
	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand_height =  CONCAT(sqlcommand_height, " ",sqlcommand_100);
			WHEN _field_snd = 101 THEN SET sqlcommand_height =  CONCAT(sqlcommand_height, " ",sqlcommand_101);
			WHEN _field_snd = 102 THEN SET sqlcommand_height =  CONCAT(sqlcommand_height, " ",sqlcommand_102);
			WHEN _field_snd = 103 THEN SET sqlcommand_height =  CONCAT(sqlcommand_height, " ",sqlcommand_103);
			WHEN _field_snd = 104 THEN SET sqlcommand_height =  CONCAT(sqlcommand_height, " ",sqlcommand_104);
			WHEN _field_snd = 105 THEN SET sqlcommand_height =  CONCAT(sqlcommand_height, " ",sqlcommand_105);	
			WHEN _field_snd = 107 THEN SET sqlcommand_height =  CONCAT(sqlcommand_height, " ",sqlcommand_107);	
			WHEN _field_snd = 108 THEN SET sqlcommand_height =  CONCAT(sqlcommand_height, " ",sqlcommand_108);						
		ELSE SET sqlcommand_height = CONCAT(sqlcommand_height, " ",sqlcommand_1_1);
		END CASE;
	END IF;



SET sqlcommand_size = "SELECT 3,?,count(1) as total FROM assets a WHERE deleted = 0 AND size BETWEEN ? AND ? ";	
IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand_size =  CONCAT(sqlcommand_size, " ",sqlcommand_100);
			WHEN _field_snd = 101 THEN SET sqlcommand_size =  CONCAT(sqlcommand_size, " ",sqlcommand_101);
			WHEN _field_snd = 102 THEN SET sqlcommand_size =  CONCAT(sqlcommand_size, " ",sqlcommand_102);
			WHEN _field_snd = 103 THEN SET sqlcommand_size =  CONCAT(sqlcommand_size, " ",sqlcommand_103);
			WHEN _field_snd = 104 THEN SET sqlcommand_size =  CONCAT(sqlcommand_size, " ",sqlcommand_104);
			WHEN _field_snd = 105 THEN SET sqlcommand_size =  CONCAT(sqlcommand_size, " ",sqlcommand_105);
			WHEN _field_snd = 107 THEN SET sqlcommand_size =  CONCAT(sqlcommand_size, " ",sqlcommand_107);
			WHEN _field_snd = 108 THEN SET sqlcommand_size =  CONCAT(sqlcommand_size, " ",sqlcommand_108);									
		ELSE SET sqlcommand_size = CONCAT(sqlcommand_size, " ",sqlcommand_1_1);
		END CASE;
	END IF;




	IF(_room <> '')
	THEN
	   SET sqlcommand_mime_type = CONCAT(sqlcommand_mime_type,"",sqlcommand_room);
	   SET sqlcommand_height = CONCAT(sqlcommand_height,"",sqlcommand_room);
	   SET sqlcommand_size = CONCAT(sqlcommand_size,"",sqlcommand_room);
	END IF;

	IF(_id_directory > 0)
	THEN
	   SET sqlcommand_mime_type = CONCAT(sqlcommand_mime_type,"",sqlcommand_dir);
	   SET sqlcommand_height = CONCAT(sqlcommand_height,"",sqlcommand_dir);
	   SET sqlcommand_size = CONCAT(sqlcommand_size,"",sqlcommand_dir);
	END IF;
    
	IF (_field_trd = 1000)
	THEN
	   SET sqlcommand_mime_type = CONCAT(sqlcommand_mime_type,"",sqlcommand_1000);
	   SET sqlcommand_height = CONCAT(sqlcommand_height,"",sqlcommand_1000);
	   SET sqlcommand_size = CONCAT(sqlcommand_size,"",sqlcommand_1000);
	END IF;

	IF (_query <> '')
	THEN
	   SET sqlcommand_mime_type = CONCAT(sqlcommand_mime_type,"",sqlcommand_query);
	   SET sqlcommand_height = CONCAT(sqlcommand_height,"",sqlcommand_query);
	   SET sqlcommand_size = CONCAT(sqlcommand_size,"",sqlcommand_query);
	END IF;

	SET sqlcommand = "SELECT type,rvalue as value, total FROM (";
	SET sqlcommand =  CONCAT(sqlcommand,sqlcommand_mime_type, " ) as total FROM assets a2 WHERE a2.deleted = 0 GROUP BY mime_type  ");
	SET sqlcommand =  CONCAT(sqlcommand," UNION ",sqlcommand_height, " ) as total FROM assets a2 WHERE a2.deleted = 0 GROUP BY height  ");

	SET sqlcommand =  CONCAT(sqlcommand," UNION ",sqlcommand_size); 
	SET sqlcommand =  CONCAT(sqlcommand," UNION ",sqlcommand_size); 
	SET sqlcommand =  CONCAT(sqlcommand," UNION ",sqlcommand_size); 
	SET sqlcommand =  CONCAT(sqlcommand," UNION ",sqlcommand_size); 
	SET sqlcommand =  CONCAT(sqlcommand," UNION ",sqlcommand_size); 
	SET sqlcommand =  CONCAT(sqlcommand," UNION ",sqlcommand_size); 

	SET sqlcommand =  CONCAT(sqlcommand, " ) as tt ORDER by type,rvalue ");

	
	SET @l4_ix1 = 1; SET @l4_1a = 0; SET @l4_1b = 5*1024*1024;
	SET @l4_ix2 = 2; SET @l4_2a = 5*1024*1024; SET @l4_2b = 10*1024*1024;
	SET @l4_ix3 = 3; SET @l4_3a = 10*1024*1024; SET @l4_3b = 30*1024*1024;
	SET @l4_ix4 = 4; SET @l4_4a = 30*1024*1024; SET @l4_4b = 50*1024*1024;
	SET @l4_ix5 = 5; SET @l4_5a = 50*1024*1024; SET @l4_5b = 100*1024*1024;
	SET @l4_ix6 = 6; SET @l4_6a = 100*1024*1024; SET @l4_6b = 99999999*1024*1024;

	 SET @sqlcommand = sqlcommand;
	 PREPARE stmt FROM @sqlcommand;
	 EXECUTE stmt USING 

	 @l4_ix1,@l4_1a,@l4_1b,
	 @l4_ix2,@l4_2a,@l4_2b,
	 @l4_ix3,@l4_3a,@l4_3b,
	 @l4_ix4,@l4_4a,@l4_4b,
	 @l4_ix5,@l4_5a,@l4_5b,
	 @l4_ix6,@l4_6a,@l4_6b;
        
COMMIT;

END;

