create
    definer = skoiypp@`%` procedure SP_GET_ASSETS_TAGS_COUNT(IN _field int(10), IN _query varchar(192), IN _filter varchar(192))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_name = CONCAT("%",_query,"%");
SET @_id_asset = _filter;
SET @_id_album = _filter;
SET @_num_x = _filter;

SET sqlcommand = "SELECT count(1) as total FROM assets_tags at ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE name like @_name ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE public = 1 AND name like @_name ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE public = 0 AND name like @_name ");
WHEN _field = 4 THEN SET sqlcommand =  "SELECT atg.id_tag, name,name_stripped,public, count(1) as total FROM assets_tags atg, assets_tags_related atr WHERE atr.id_tag = atg.id_tag AND public = 1 AND atr.id_asset in (SELECT distinct a.id_asset FROM assets_albums_related aar, assets a WHERE aar.id_album = @_id_album AND aar.id_asset = a.id_asset) GROUP BY id_tag ";
WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_tag in (SELECT distinct id_tag FROM assets_tags_related) AND name like @_name ");

WHEN _field = 9 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE name_stripped in (SELECT name_stripped FROM (SELECT count(1) as total,name_stripped FROM assets_tags GROUP BY name_stripped) as tt WHERE total > 1) AND name like @_name ");
WHEN _field = 10 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE FN_GET_ASSETS_TAGS_TOTAL_ASSETS(id_tag) = @_num_x AND name like @_name ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt; 
  
        
COMMIT;

END;

