create
    definer = skoiypp@`%` procedure SP_GET_POSTS_AUTHOR(IN _id_author INT)
BEGIN

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF (SELECT count(1) FROM posts_authors_l10n WHERE id_author = _id_author)
THEN 
    SELECT id_author,id_author_l10n,public,name,email,iso_language,FN_GET_POSTS_L10N_ISO_GROUPED(4,id_author) as iso_grouped,role,description,biography,image,image_align,FN_GET_ASSETS_ID_BY_FILENAME(image) as id_asset,FN_GET_ASSETS_WIDTH_HEIGHT_BY_ID(1,FN_GET_ASSETS_ID_BY_FILENAME(image)) as image_width,FN_GET_ASSETS_WIDTH_HEIGHT_BY_ID(2,FN_GET_ASSETS_ID_BY_FILENAME(image)) as image_height,FN_GET_ASSETS_ID_BY_FILENAME(meta_image) as meta_id_asset,image_title,image_alter_text,meta_title,meta_description,meta_image,meta_url,meta_keywords,FN_GET_POSTS_AUTHORS_TOTAL_POSTS(id_author) as total,register_date FROM posts_authors_l10n WHERE id_author = _id_author; 
ELSE
    SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

