create
    definer = skoiypp@`%` procedure SP_GET_POSTS_FEEDS_EXTERNAL(IN _field int(10), IN _query varchar(192),
                                                                IN _filter varchar(192), IN _limit_a int(10),
                                                                IN _limit_b int(10), IN _order int(10),
                                                                IN _order_by int(10))
BEGIN

DECLARE sqlcommand text;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM posts_feeds_external;
END IF;

SET @_name = CONCAT("%",_query,"%");
SET @_id_feed = _filter;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = "SELECT id_feed,name,feed_url,register_date FROM posts_feeds_external ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE name like @_name ");

WHEN _field = 11 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_feed = @_id_feed AND name like @_name ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

CASE
WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name ASC");
WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date ASC");

WHEN _order_by = 11000 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name DESC");
WHEN _order_by = 11001 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date DESC");


ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name ASC");
END CASE;

SET sqlcommand = CONCAT(sqlcommand, " LIMIT ?,?");
SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;    
        
COMMIT;

END;

