create
    definer = skoiypp@`%` procedure SP_GET_POSTS_LABELS(IN _field int(10), IN _query varchar(192),
                                                        IN _filter varchar(192), IN _limit_a int(10),
                                                        IN _limit_b int(10), IN _order int(10), IN _order_by int(10))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM posts_labels;
END IF;

SET @_name = CONCAT("%",_query,"%");
SET @_id_post = _filter;
SET @_id_label = _filter;
SET @_num_x = _filter;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = "SELECT pl.id_label, name,name_stripped, public,FN_GET_POSTS_LABELS_TOTAL_POSTS(id_label) as total,register_date FROM posts_labels pl ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE name like @_name ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE public = 1 AND name like @_name ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE public = 0 AND name like @_name ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_label in (SELECT distinct id_label FROM posts_l10n_labels_related) AND name like @_name ");
WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_label not in (SELECT distinct id_label FROM posts_l10n_labels_related) AND name like @_name ");
WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_label in (SELECT distinct id_label FROM posts_l10n_labels_related WHERE id_l10n in (SELECT id_l10n FROM posts_l10n WHERE id_post = @_id_post)) AND name like @_name ");

WHEN _field = 9 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE name_stripped in (SELECT name_stripped FROM (SELECT count(1) as total,name_stripped FROM posts_labels GROUP BY name_stripped) as tt WHERE total > 1) AND name like @_name ");
WHEN _field = 10 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE FN_GET_POSTS_LABELS_TOTAL_POSTS(id_label) = @_num_x AND name like @_name ");
WHEN _field = 11 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_label = @_id_label AND name like @_name ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

CASE
WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name ASC");
WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date ASC");
WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY total ASC");

WHEN _order_by = 11000 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name DESC");
WHEN _order_by = 11001 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date DESC");
WHEN _order_by = 11002 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY total DESC");

ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name ASC");
END CASE;

SET sqlcommand = CONCAT(sqlcommand, " LIMIT ?,?");
SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;    
        
COMMIT;

END;

