create
    definer = skoiypp@`%` procedure SP_GET_POSTS_STICKER(IN _id_sticker int(10))
BEGIN

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF EXISTS(SELECT id_sticker FROM posts_stickers WHERE id_sticker = _id_sticker)
THEN
	SELECT ps.id_sticker,id_group,(SELECT name FROM posts_stickers_groups  psg WHERE psg.id_group = ps.id_group) as group_name,(SELECT sticker_type FROM posts_stickers_groups  psg WHERE psg.id_group = ps.id_group) as sticker_type,id_type,position, name,name_stripped,token,image,image_align,maximum_items,number_of_rows,display_in,id_format,
    (SELECT format FROM posts_stickers_formats WHERE id_format = ps.id_format) as format,(SELECT variant FROM posts_stickers_formats WHERE id_format = ps.id_format) as variant,
    link,auto_feed,auto_feed_order,auto_feed_type,color,active,active as state, FN_GET_POSTS_STICKERS_TOTAL_ITEMS(id_sticker) as total,FN_GET_ASSETS_ID_BY_FILENAME(image) as id_asset,FN_GET_ASSETS_WIDTH_HEIGHT_BY_ID(1,FN_GET_ASSETS_ID_BY_FILENAME(image)) as image_width,FN_GET_ASSETS_WIDTH_HEIGHT_BY_ID(2,FN_GET_ASSETS_ID_BY_FILENAME(image)) as image_height,register_date FROM posts_stickers ps WHERE ps.id_sticker = _id_sticker;
ELSE
	SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

