create
    definer = skoiypp@`%` procedure SP_GET_POSTS_STICKERS_COUNT(IN _field int(10), IN _id_group int(10),
                                                                IN _query varchar(192), IN _filter varchar(192))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_name = CONCAT("%",_query,"%");
SET @_id_group = _id_group;
SET @_id_sticker = _filter;
SET @_id_type = _filter;
SET @_token = _filter;
SET @_id_asset = _filter;
SET @_id_post = _filter;
SET @_num_x = _filter;

SET sqlcommand = "SELECT count(1) as total FROM posts_stickers pt WHERE 1=1 ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND name like @_name ");
WHEN _field = 11 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_sticker like @_id_sticker AND name like @_name ");
WHEN _field = 12 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND token like @_token AND name like @_name ");
WHEN _field = 13 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_type = @_id_type AND name like @_name ");
WHEN _field = 23 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (FN_GET_ASSETS_ID_BY_FILENAME(image) = @_id_asset) AND name like @_name ");
WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_sticker in (SELECT id_sticker FROM posts_stickers_related WHERE id_post = @_id_post) AND name like @_name ");
WHEN _field = 10 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (FN_GET_POSTS_STICKERS_TOTAL_ITEMS(id_sticker)) = @_num_x AND name like @_name ");


WHEN _field = 30 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_type = 1 AND name like @_name ");
WHEN _field = 31 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_type = 1 AND id_sticker like @_id_sticker AND name like @_name ");
WHEN _field = 32 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_type = 1 AND token like @_token AND name like @_name ");

ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

	IF (_id_group > 0)
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," AND id_group = @_id_group ");
	END IF;

SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt;    
        
COMMIT;

END;

