create
    definer = skoiypp@`%` procedure SP_GET_POSTS_STICKERS_GROUPS_COUNT(IN _type int(10), IN _field int(10),
                                                                       IN _query varchar(192), IN _filter varchar(192))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_sticker_type = _type;
SET @_name = CONCAT("%",_query,"%");
SET @_id_group = _filter;
SET @_id_sticker = _filter;
SET @_num_x = _filter;

SET sqlcommand = "SELECT count(1) as total FROM posts_stickers_groups psg WHERE sticker_type = @_sticker_type ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND name like @_name ");
WHEN _field = 11 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_group like @_id_group AND name like @_name ");
WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_group in (SELECT id_group FROM posts_stickers WHERE id_sticker = @_id_sticker) AND name like @_name ");
WHEN _field = 10 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (FN_GET_POSTS_STICKERS_NUM_ITEMS_ON_GROUP(id_group))) = @_num_x AND name like @_name ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt;   


COMMIT; 

END;

