create
    definer = skoiypp@`%` procedure SP_GET_PUBLISH_VIDEO(IN _sync_type tinyint(1))
BEGIN

DECLARE _last_publish DATETIME;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_sync_type = 1)
THEN

	IF(SELECT count(1) FROM video_publish_log WHERE sync_type = 1 AND date(end_publish_date) <> '0000-00-00')
	THEN
	SELECT end_publish_date into _last_publish FROM video_publish_log WHERE sync_type = 1 AND date(end_publish_date) <> '0000-00-00' ORDER by id_publish desc LIMIT 0,1;
	ELSE
	SET _last_publish = '0000-00-00 00:00:00';
	END IF;

	
	
	SELECT 1 as type,1 as action_type,vc.id_composed as id,FN_GET_VIDEO_IS_LIVE_COMPOSED(vc.id_composed) as is_live, id_sync,id_rev_sync, vc.update_date, vc.register_date FROM video_composed vc WHERE id_sync = '' AND state = 5 AND FN_GET_VIDEO_IS_DELETED(vc.id_video) = 0
	UNION 
	SELECT 2 as type,1 as action_type,id_playlist as id,0, id_sync,id_rev_sync, update_date, register_date FROM playlists WHERE id_sync = '' AND id_playlist in (SELECT id_playlist FROM playlists_channels_related)  AND state = 5
	UNION 
	SELECT 3 as type,1 as action_type,id_channel as id,0, id_sync,id_rev_sync, update_date, register_date FROM channels WHERE id_sync = '' AND state = 5

	
	UNION
	SELECT 2 as type,action_type,p.id_playlist as id,0, p.id_sync,p.id_rev_sync, p.update_date, p.register_date FROM playlists p, video_sync_updated psy WHERE psy.id_playlist = p.id_playlist AND p.id_sync <> '' AND sync_type = 1
	UNION
	SELECT 3 as type,action_type,c.id_channel as id,0, c.id_sync,c.id_rev_sync, c.update_date, c.register_date FROM channels c, video_sync_updated psy WHERE psy.id_channel = c.id_channel AND c.id_sync <> '' AND sync_type = 1
    UNION
	SELECT 1 as type,action_type,vc.id_composed as id,FN_GET_VIDEO_IS_LIVE_COMPOSED(vc.id_composed) as is_live, vc.id_sync,vc.id_rev_sync, vc.update_date, vc.register_date FROM video_composed vc,video_sync_updated psy WHERE psy.id_composed = vc.id_composed AND vc.id_sync <> '' AND FN_GET_VIDEO_IS_DELETED(vc.id_video) = 0 AND sync_type = 1 

	

	UNION 
	SELECT 1 as type,3 as action_type,id_composed as id,FN_GET_VIDEO_IS_LIVE_COMPOSED(id_composed) as is_live, id_sync,id_rev_sync,'','' FROM video_sync_deleted WHERE register_date > _last_publish AND id_composed > 0 AND last_sync_date = '0000-00-00 00:00:00' AND sync_type = 1
	UNION 
	SELECT 2 as type,3 as action_type,id_playlist as id,0, id_sync,id_rev_sync,'','' FROM video_sync_deleted WHERE register_date > _last_publish AND id_playlist > 0 AND last_sync_date = '0000-00-00 00:00:00' AND sync_type = 1
	UNION 
	SELECT 3 as type,3 as action_type,id_channel as id,0, id_sync,id_rev_sync,'','' FROM video_sync_deleted WHERE register_date > _last_publish AND id_channel > 0 AND last_sync_date = '0000-00-00 00:00:00' AND sync_type = 1 ORDER BY rand();
		
	UPDATE video_composed SET id_sync = '', id_rev_sync = '' WHERE id_composed in 
	(SELECT id_composed FROM video_sync_updated WHERE action_type = 3 AND sync_type = 1);

 	 DELETE FROM video_sync_updated WHERE sync_type = 1;

END IF;

IF(_sync_type = 2)
THEN
    
		IF(SELECT count(1) FROM video_publish_log WHERE sync_type = 2 AND date(end_publish_date) <> '0000-00-00')
		THEN
		SELECT end_publish_date into _last_publish FROM video_publish_log WHERE sync_type = 2 AND date(end_publish_date) <> '0000-00-00' ORDER by id_publish desc LIMIT 0,1;
		ELSE
		SET _last_publish = '0000-00-00 00:00:00';
		END IF;
                
		
		
		SELECT 10 as type,1 as action_type,vc.id_composed as id,FN_GET_VIDEO_IS_LIVE_COMPOSED(vc.id_composed) as is_live, id_sync_player,id_rev_sync_player, vc.update_date, vc.register_date FROM video_composed vc WHERE id_sync_player = '' AND state = 5 AND FN_GET_VIDEO_IS_DELETED(vc.id_video) = 0

		
		UNION
		SELECT 10 as type,action_type,vc.id_composed as id,FN_GET_VIDEO_IS_LIVE_COMPOSED(vc.id_composed) as is_live, vc.id_sync_player,vc.id_rev_sync_player, vc.update_date, vc.register_date FROM video_composed vc,video_sync_updated psy WHERE psy.id_composed = vc.id_composed AND vc.id_sync_player <> '' AND sync_type = 2 

		
		UNION 
		SELECT 10 as type,3 as action_type,id_composed as id,0, id_sync_player,id_rev_sync_player,'','' FROM video_sync_deleted WHERE register_date > _last_publish AND id_composed > 0 AND last_sync_date = '0000-00-00 00:00:00' AND sync_type = 2 ORDER BY rand();

		UPDATE video_composed SET id_sync_player = '', id_rev_sync_player = '' WHERE id_composed in 
		(SELECT id_composed FROM video_sync_updated WHERE action_type = 3 AND sync_type = 2);

	 	DELETE FROM video_sync_updated WHERE sync_type = 2;
        
END IF;

COMMIT;

END;

