create
    definer = skoiypp@`%` procedure SP_GET_PUBLISH_VIDEO_MGO(IN _limit_a int(10), IN _limit_b int(10))
BEGIN



DECLARE _last_publish DATETIME;
DECLARE t1_a text;
DECLARE t1_b text;
DECLARE t1_c text;

DECLARE sqlcommand text;

DECLARE sqlcommand_stmt_new text;
DECLARE sqlcommand_create text;
DECLARE sqlcommand_new_composes text;
DECLARE sqlcommand_new_playlists text;
DECLARE sqlcommand_new_channels text;
DECLARE sqlcommand_new_embeds text;


DECLARE sqlcommand_stmt_delete text;
DECLARE sqlcommand_delete text;
DECLARE sqlcommand_delete_composes text;
DECLARE sqlcommand_delete_playlists text;
DECLARE sqlcommand_delete_channels text;
DECLARE sqlcommand_delete_embeds text;


DECLARE sqlcommand_stmt_update text;
DECLARE sqlcommand_update text;
DECLARE sqlcommand_update_composes text;
DECLARE sqlcommand_update_playlists text;
DECLARE sqlcommand_update_channels text;
DECLARE sqlcommand_update_embeds text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(SELECT count(1) FROM video_publish_log_2 WHERE date(end_publish_date) <> '0000-00-00')
THEN
	SELECT end_publish_date into _last_publish FROM video_publish_log_2 WHERE date(end_publish_date) <> '0000-00-00' ORDER by id_publish desc LIMIT 0,1;
ELSE
	SET _last_publish = '0000-00-00 00:00:00';
END IF;

SET @_last_publish = _last_publish;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;


DROP TEMPORARY TABLE IF EXISTS video_publish_tmp_create;

SET t1_a = "CREATE TEMPORARY TABLE IF NOT EXISTS video_publish_tmp_create ";



SET sqlcommand_new_composes = "SELECT 1 as type,1 as action_type,vc.id_composed as id,FN_GET_VIDEO_IS_LIVE_COMPOSED(vc.id_composed) as is_live,0 as code, vc.update_date, vc.register_date FROM video_composed vc WHERE vc.register_date > @_last_publish AND state = 5 AND FN_GET_VIDEO_IS_DELETED(vc.id_video) = 0" ;
SET sqlcommand_new_playlists = "SELECT 2 as type,1 as action_type,id_playlist as id,0,0, update_date, register_date FROM playlists WHERE id_playlist in (SELECT id_playlist FROM playlists_channels_related) AND register_date > @_last_publish AND state = 5" ;
SET sqlcommand_new_channels = "SELECT 3 as type,1 as action_type,id_channel as id,0,0, update_date, register_date FROM channels WHERE register_date > @_last_publish AND state = 5";
SET sqlcommand_new_embeds = "SELECT 10 as type,1 as action_type,id as id,0,code, update_date, register_date FROM video_embeds WHERE register_date > @_last_publish";


SET sqlcommand_create = CONCAT(sqlcommand_new_composes," UNION ",sqlcommand_new_playlists," UNION ",sqlcommand_new_channels," UNION ",sqlcommand_new_embeds);

SET @sqlcommand_stmt_new = CONCAT(t1_a,sqlcommand_create);

PREPARE stmt_create FROM @sqlcommand_stmt_new;
EXECUTE stmt_create;




 DROP TEMPORARY TABLE IF EXISTS video_publish_tmp_update;
SET t1_c = "CREATE TEMPORARY TABLE IF NOT EXISTS video_publish_tmp_update ";

SET sqlcommand_update_composes = "SELECT 1 as type,action_type,vc.id_composed as id,FN_GET_VIDEO_IS_LIVE_COMPOSED(vc.id_composed) as is_live,0 as code, vc.update_date, vc.register_date FROM video_composed vc,video_sync_updated_2 psy WHERE psy.id_composed = vc.id_composed AND FN_GET_VIDEO_IS_DELETED(vc.id_video) = 0";
SET sqlcommand_update_playlists = "SELECT 2 as type,action_type,p.id_playlist as id,0,0, p.update_date, p.register_date FROM playlists p, video_sync_updated_2 psy WHERE psy.id_playlist = p.id_playlist";
SET sqlcommand_update_channels = "SELECT 3 as type,action_type,c.id_channel as id,0, 0,c.update_date, c.register_date FROM channels c, video_sync_updated_2 psy WHERE psy.id_channel = c.id_channel";
SET sqlcommand_update_embeds = "SELECT 10 as type,action_type,e.id as id,0,e.code, e.update_date, e.register_date FROM video_embeds e, video_sync_updated_2 psy WHERE psy.id_embed = e.id";

SET sqlcommand_update = CONCAT(sqlcommand_update_composes," UNION ",sqlcommand_update_playlists," UNION ",sqlcommand_update_channels," UNION ",sqlcommand_update_embeds);

SET @sqlcommand_stmt_update = CONCAT(t1_c,sqlcommand_update);

PREPARE stmt_update FROM @sqlcommand_stmt_update;
EXECUTE stmt_update;




DROP TEMPORARY TABLE IF EXISTS video_publish_tmp_delete;
SET t1_b = "CREATE TEMPORARY TABLE IF NOT EXISTS video_publish_tmp_delete ";


SET sqlcommand_delete_composes = "SELECT 1 as type,3 as action_type,id_composed as id,FN_GET_VIDEO_IS_LIVE_COMPOSED(id_composed) as is_live,0 as code,'' as update_date,register_date FROM video_sync_deleted_2 WHERE register_date > @_last_publish AND id_composed > 0 AND last_sync_date = '0000-00-00 00:00:00'";
SET sqlcommand_delete_playlists = "SELECT 2 as type,3 as action_type,id_playlist as id,0,0,'','' FROM video_sync_deleted_2 WHERE register_date > @_last_publish AND id_playlist > 0 AND last_sync_date = '0000-00-00 00:00:00'";
SET sqlcommand_delete_channels = "SELECT 3 as type,3 as action_type,id_channel as id,0,0,'','' FROM video_sync_deleted_2 WHERE register_date > @_last_publish AND id_channel > 0 AND last_sync_date = '0000-00-00 00:00:00'";
SET sqlcommand_delete_embeds = "SELECT 10 as type,3 as action_type,id_embed as id,0,0,'','' FROM video_sync_deleted_2 WHERE register_date > @_last_publish AND id_embed > 0 AND last_sync_date = '0000-00-00 00:00:00'";


SET sqlcommand_delete = CONCAT(sqlcommand_delete_composes," UNION ",sqlcommand_delete_playlists," UNION ",sqlcommand_delete_channels," UNION ",sqlcommand_delete_embeds);

SET @sqlcommand_stmt_delete = CONCAT(t1_b,sqlcommand_delete);

PREPARE stmt_delete FROM @sqlcommand_stmt_delete;
EXECUTE stmt_delete;

SELECT count(1) into @total FROM(
SELECT * FROM video_publish_tmp_create 
UNION
SELECT * FROM video_publish_tmp_delete 
UNION
SELECT * FROM video_publish_tmp_update) as tt;

SET sqlcommand ="
SELECT *,@total as total FROM(
SELECT * FROM video_publish_tmp_create 
UNION
SELECT * FROM video_publish_tmp_delete 
UNION
SELECT * FROM video_publish_tmp_update) as tt LIMIT ?,?";

SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;

COMMIT;

END;

