create
    definer = skoiypp@`%` procedure SP_GET_TASK_LIVE_CREATE_CLIP_QUEUE(IN _field int, IN _id_account int,
                                                                       IN _is_running int, IN _stream varchar(255))
BEGIN

DECLARE sqlcommand text;

START TRANSACTION;

SET @_id_account = _id_account;
SET @_is_running = _is_running;
SET @_stream = _stream;

IF(_field = 1)
THEN

			IF EXISTS(SELECT id_account FROM live_create_clip_queue WHERE id_account = _id_account) OR EXISTS(SELECT id_account FROM live_create_clip_completed WHERE id_account = _id_account)
			THEN
			
				 SET sqlcommand = "
                 SELECT queue, id_queue,is_running, id_account,account_token,machine,command,server,application,stream,converter_start_time,converter_end_time,converter_duration,converter_time_type,
				converter_tolerance,converter_output_filename,converter_interleave_delay,converter_debug_conversions,converter_default_file_destination,state,status_code,video_name,version,download,dvr_start_time, loader_video_state, loader_archive_state
		FROM (
                 SELECT 0 as queue,register_date,id_queue,is_running, id_account,account_token,machine,command,server,application,stream,converter_start_time,converter_end_time,converter_duration,converter_time_type,
				converter_tolerance,converter_output_filename,converter_interleave_delay,converter_debug_conversions,converter_default_file_destination,state,status_code,video_name,version,download,dvr_start_time, 0 as loader_video_state, 0 as loader_archive_state
				FROM live_create_clip_queue WHERE id_account = @_id_account
                UNION
                SELECT 1,register_date,id_queue,0, id_account,account_token,machine,command,server,application,stream,converter_start_time,converter_end_time,converter_duration,converter_time_type,
				converter_tolerance,converter_output_filename,converter_interleave_delay,converter_debug_conversions,converter_default_file_destination,'completed' as state,status_code,video_name,version,download,dvr_start_time, FN_PUSH_VIDEO_STATE(converter_output_filename,3), FN_PUSH_ARCHIVE_STATE(converter_output_filename,3)
				FROM live_create_clip_completed WHERE id_account = @_id_account AND hide = 0 
		) as tt WHERE version = '' AND 1=1 ";

			ELSE
				SELECT -2 as return_code;
			END IF; 
            
		IF(_is_running <> -1)
		THEN
			SET sqlcommand = CONCAT(sqlcommand, " AND is_running = @_is_running ");
		END IF;

		IF(_stream <> '')
		THEN
			SET sqlcommand = CONCAT(sqlcommand, " AND stream = @_stream ");
		END IF;
        
		SET sqlcommand = CONCAT(sqlcommand, " ORDER by queue, register_date desc ");


		SET @sqlcommand = sqlcommand;
		PREPARE stmt FROM @sqlcommand;
		EXECUTE stmt;
        
END IF;



IF(_field = 0)
THEN
		IF(_id_account > 0)
		THEN

			IF EXISTS(SELECT id_account FROM live_create_clip_queue WHERE id_account = _id_account)
			THEN
			
				 SET sqlcommand = "SELECT id_queue,is_running, id_account,account_token,machine,command,server,application,stream,converter_start_time,converter_end_time,converter_duration,converter_time_type,
				converter_tolerance,converter_output_filename,converter_interleave_delay,converter_debug_conversions,converter_default_file_destination,state,status_code,video_name,version,download,dvr_start_time, 0 as loader_video_state, 0 as loader_archive_state
				FROM live_create_clip_queue WHERE id_account = @_id_account ";

			ELSE
				SELECT -2 as return_code;
			END IF; 
			
		ELSE

			 SET sqlcommand = "SELECT id_queue, is_running,id_account,account_token,machine,command,server,application,stream,converter_start_time,converter_end_time,converter_duration,converter_time_type,
			converter_tolerance,converter_output_filename,converter_interleave_delay,converter_debug_conversions,converter_default_file_destination,state,status_code,video_name,version,download,dvr_start_time, 0 as loader_video_state, 0 as loader_archive_state
			FROM live_create_clip_queue WHERE 1=1 ";
							
		END IF;

		IF(_is_running <> -1)
		THEN
			SET sqlcommand = CONCAT(sqlcommand, " AND is_running = @_is_running ");
		END IF;

		IF(_stream <> '')
		THEN
			SET sqlcommand = CONCAT(sqlcommand, " AND stream = @_stream ");
		END IF;

		SET @sqlcommand = sqlcommand;
		PREPARE stmt FROM @sqlcommand;
		EXECUTE stmt;
END IF;

COMMIT;

END;

