create
    definer = skoiypp@`%` procedure SP_SET_ADS_CAMPAIGNS_GROUPS_ADS_VIDEOS(IN _id_campaign_group int(10),
                                                                           IN _id_campaign int(10), IN _id_ad int(10),
                                                                           IN _display_in tinyint(1),
                                                                           IN _begin_date datetime,
                                                                           IN _end_date datetime, IN _link varchar(255),
                                                                           IN _quantity bigint(10),
                                                                           IN _quantity_type tinyint(2),
                                                                           IN _id_action int(10),
                                                                           IN _can_skip tinyint(1), IN _skip_after int)
BEGIN

DECLARE _position INT;


DECLARE exit handler for sqlexception
  BEGIN
    
    SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_id_action = 0)
THEN
 SET _id_action = 5;
END IF;

IF EXISTS  (SELECT id_campaign FROM ads_campaigns_groups WHERE id_campaign = _id_campaign AND id_campaign_group = _id_campaign_group) AND EXISTS (SELECT id_ad FROM ads_videos WHERE id_ad = _id_ad)
THEN
	SELECT count(position)+1 into _position FROM ads_campaigns_groups_ads_videos WHERE id_campaign_group = _id_campaign_group; 

    INSERT into ads_campaigns_groups_ads_videos(id_campaign_group,id_ad,display_in,begin_date,end_date,link,quantity,quantity_type,id_action,can_skip,skip_after,position,register_date) VALUES(_id_campaign_group,_id_ad,_display_in,_begin_date,_end_date,_link,_quantity,_quantity_type,_id_action,_can_skip,_skip_after,_position,now()) ON DUPLICATE KEY UPDATE update_date = now();
	
    SELECT id,id_campaign_group,id_ad,display_in,begin_date,end_date,link,quantity,quantity_type,id_action,can_skip,skip_after,register_date FROM ads_campaigns_groups_ads_videos WHERE id_campaign_group = _id_campaign_group AND id_ad = _id_ad;
ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

