create
    definer = skoiypp@`%` procedure SP_SET_ADS_CAMPAIGN_CODE_CLONE(IN _id_code int(10), IN _id_campaign int(10), IN _code bigint)
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF EXISTS (SELECT id_campaign FROM ads_campaigns_codes WHERE id_campaign = _id_campaign AND id_code = _id_code)
THEN

	INSERT into ads_campaigns_codes(id_campaign,name,code,ratio,autoplay,start_expanded,end_collapse,register_date) 
	SELECT id_campaign,CONCAT('Copy of ',name),_code,ratio,autoplay,start_expanded,end_collapse,register_date FROM ads_campaigns_codes WHERE id_campaign = _id_campaign AND id_code = _id_code; 
	SET p_last_id = last_insert_id();
	        
	INSERT INTO ads_campaigns_code_option_related(id_code,id_option,id_campaign,option_value,register_date)
	SELECT p_last_id,id_option,id_campaign,option_value,now() FROM ads_campaigns_code_option_related WHERE id_campaign = _id_campaign AND id_code = _id_code;
	
	SELECT FN_SP_SET_PUBLISH_ADS_SYNC_UPDATE(41,_id_campaign) into _empty;
	SELECT id_code,id_campaign,name,code,ratio,autoplay,start_expanded,end_collapse,register_date FROM ads_campaigns_codes WHERE id_campaign = _id_campaign AND id_code = p_last_id;

ELSE
    SELECT -2 as return_code;
END IF;

COMMIT;

END;

