create
    definer = skoiypp@`%` procedure SP_SET_ADS_VIDEO_THUMBNAIL(IN _id_thumbnail int, IN _id_ad int,
                                                               IN _thumbnail varchar(192), IN _is_default tinyint(1),
                                                               IN _seconds float(10, 2))
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE totalThumb INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF EXISTS(SELECT id_ad FROM ads_videos WHERE id_ad = _id_ad)
THEN
	IF EXISTS(SELECT id_thumbnail FROM ads_videos_thumbnails WHERE id_thumbnail = _id_thumbnail)
	THEN
		UPDATE ads_videos_thumbnails SET is_default = _is_default WHERE id_thumbnail = _id_thumbnail AND id_ad = _id_ad;
		IF(_is_default = 1)
		THEN
			UPDATE ads_videos_thumbnails SET is_default = 0 WHERE id_ad = _id_ad AND id_thumbnail not in (_id_thumbnail);
		END IF;
		SELECT id_thumbnail,id_ad,thumbnail,is_default,seconds,register_date FROM ads_videos_thumbnails WHERE id_thumbnail = _id_thumbnail;
	ELSE
		SELECT count(1) into totalThumb FROM ads_videos_thumbnails WHERE id_ad = _id_ad;
		IF(totalThumb = 0)
		THEN
			SET _is_default = 1;
		END IF;
		INSERT into ads_videos_thumbnails(id_ad,thumbnail,is_default,duration,seconds,register_date) VALUES(_id_ad,_thumbnail,_is_default,sec_to_time(_seconds),_seconds,now());
		SET p_last_id = last_insert_id();
		SELECT id_thumbnail,id_ad,thumbnail,is_default,seconds,register_date FROM ads_videos_thumbnails WHERE id_thumbnail = p_last_id;
	END IF;
ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

