create
    definer = skoiypp@`%` procedure SP_SET_ARCHIVE_TAGS_VARIANTS(IN _id_tag int, IN _id_key int, IN _variant_value varchar(255))
BEGIN

DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_tag FROM archive_tags WHERE id_tag = _id_tag) AND EXISTS (SELECT id_key FROM archive_variants_keys WHERE id_key = _id_key)
THEN

    IF NOT EXISTS(SELECT id_tag FROM archive_tags_variants_related WHERE id_tag = _id_tag AND id_key = _id_key)
    THEN
		INSERT INTO archive_tags_variants_related(id_tag,id_key,variant_value,register_date) VALUES(_id_tag,_id_key,_variant_value,now());
    ELSE
         UPDATE archive_tags_variants_related SET variant_value = _variant_value, update_date = now() WHERE id_tag = _id_tag AND id_key = _id_key;
    END IF;
    
    SELECT id_variant, id_tag,avk.id_key, name,name_stripped, variant_value, atvr.register_date FROM archive_tags_variants_related atvr, archive_variants_keys avk
	WHERE atvr.id_key = avk.id_key AND atvr.id_tag = _id_tag AND avk.id_key = _id_key;     

ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

