create
    definer = skoiypp@`%` procedure SP_SET_ARCHIVE_VIDEO(IN _id_video int, IN _id_directory int, IN _name varchar(192),
                                                         IN _file_name varchar(192), IN _seconds float(10, 2),
                                                         IN _extension varchar(8), IN _mime_type varchar(192),
                                                         IN _size bigint, IN _codec varchar(45), IN _bitrate bigint,
                                                         IN _audio_bitrate int(10), IN _audio_codec varchar(45),
                                                         IN _framerate int(10), IN _framecount int(10),
                                                         IN _width int(10), IN _height int(10), IN _ratio varchar(8),
                                                         IN _id_storage int(10), IN _id_cdn int(10))
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
    SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF (_id_directory = 0 OR _id_directory = 1 OR _id_directory = -1)
THEN
	SET _id_directory = 1;
END IF;

IF NOT EXISTS (SELECT id_directory FROM archive_videos_directories WHERE id_directory = 1)
THEN
	INSERT INTO archive_videos_directories(id_directory,name,register_date) VALUES(1,'root',now());
END IF;

IF(_id_video = 0 OR _id_video = -1)
THEN
        INSERT into archive_videos(id_directory,id_storage,id_cdn,name,filename,duration,seconds,extension,mime_type,size,codec,bitrate,audio_bitrate,audio_codec,framerate,framecount,width,height,ratio,register_date) 
        VALUES(_id_directory,_id_storage,_id_cdn,_name,_file_name,sec_to_time(_seconds),_seconds,_extension,_mime_type,_size,_codec,_bitrate,_audio_bitrate,_audio_codec,_framerate,_framecount,_width,_height,_ratio,now());        
        SET p_last_id = last_insert_id();
        SELECT id_video,id_directory,id_storage,id_cdn,name,filename,seconds,extension,mime_type,size,codec,bitrate,audio_bitrate,audio_codec,framerate,framecount,width,height,ratio,state,register_date,FN_GET_ARCHIVE_VIDEO_HAS_CLIPS(id_video) as has_clips, FN_GET_ARCHIVE_VIDEO_IN_TRANSFER(id_video) as in_transfer,FN_GET_ARCHIVE_VIDEO_HAS_PREVIEW(id_video) has_preview,FN_GET_ARCHIVE_VIDEO_THUMBNAIL(id_video) as thumbnail FROM archive_videos WHERE id_video = p_last_id; 
ELSE       
     IF EXISTS (SELECT id_video FROM archive_videos WHERE id_video = _id_video)
     THEN
        UPDATE archive_videos SET name = _name, id_directory = _id_directory, update_date = now() WHERE id_video = _id_video; 
        SELECT id_video,id_directory,id_storage,id_cdn,name,filename,seconds,extension,mime_type,size,codec,bitrate,audio_bitrate,audio_codec,framerate,framecount,width,height,ratio,state,register_date,FN_GET_ARCHIVE_VIDEO_HAS_CLIPS(id_video) as has_clips, FN_GET_ARCHIVE_VIDEO_IN_TRANSFER(id_video) as in_transfer,FN_GET_ARCHIVE_VIDEO_HAS_PREVIEW(id_video) has_preview,FN_GET_ARCHIVE_VIDEO_THUMBNAIL(id_video) as thumbnail FROM archive_videos WHERE id_video = _id_video; 
     ELSE
        SELECT -2 as return_code;
     END IF;
END IF;
COMMIT;

END;

