create
    definer = skoiypp@`%` procedure SP_SET_ARCHIVE_VIDEOS_SEGMENT_TAGS(IN _id_tag int, IN _id_video int,
                                                                       IN _seconds_in float(10, 2),
                                                                       IN _seconds_out float(10, 2))
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
    SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF EXISTS (SELECT id_tag FROM archive_tags WHERE id_tag = _id_tag) AND EXISTS (SELECT id_video FROM archive_videos WHERE id_video = _id_video)
THEN
    IF NOT EXISTS(SELECT id_tag FROM archive_videos_segment_tags_related WHERE id_tag = _id_tag AND id_video = _id_video AND seconds_in = _seconds_in AND seconds_out = _seconds_out)
    THEN
        INSERT INTO archive_videos_segment_tags_related(id_tag,id_video,seconds_in,seconds_out,register_date) VALUES(_id_tag,_id_video,_seconds_in,_seconds_out,now());
		 SET p_last_id = last_insert_id();
		 SELECT vt.id_tag,vt.name as tag_name,name_stripped, public,av.id_video,av.name as video_name,av.filename,av.bitrate,av.mime_type,width,height,ratio,seconds,size, seconds_in,seconds_out FROM archive_videos_segment_tags_related vvstr, archive_tags vt, archive_videos av WHERE vt.id_tag = vvstr.id_tag AND av.id_video = vvstr.id_video AND av.deleted = 0 AND id_segment = p_last_id;
    ELSE
		 SELECT -3 as return_code;
    END IF;
ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

