create
    definer = skoiypp@`%` procedure SP_SET_ASSETS_ALBUM_SYNC(IN _id_album_a int(10), IN _id_album_b int(10),
                                                             IN _type tinyint(1))
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF (SELECT count(1) FROM albums WHERE id_album = _id_album_a) AND (SELECT count(1) FROM albums WHERE id_album = _id_album_b)
THEN

		IF(_type = 1)
		THEN
        
            INSERT into assets_albums_related(id_album,id_asset,position,register_date)
            SELECT _id_album_a, id_asset,position, now() FROM assets_albums_related WHERE id_album = _id_album_b AND id_asset not in
            (SELECT id_asset FROM assets_albums_related WHERE id_album = _id_album_a); 
            
    SELECT id_album, id_directory, name, description, link, random,FN_GET_ASSETS_NUM_IMAGENS_ON_ALBUMS(id_album) as total_images, FN_GET_ASSETS_LAST_IMAGE_ON_ALBUM(id_album) as cover_image, register_date FROM albums WHERE id_album = _id_album_a;
        
        END IF;
        
		IF(_type = 2)
		THEN
        
                    INSERT into assets_albums_related(id_album,id_asset,position,register_date)
            SELECT _id_album_a, id_asset,position, now() FROM assets_albums_related WHERE id_album = _id_album_b AND id_asset not in
            (SELECT id_asset FROM assets_albums_related WHERE id_album = _id_album_a); 
            
                        INSERT into assets_albums_related(id_album,id_asset,position,register_date)
            SELECT _id_album_b, id_asset,position, now() FROM assets_albums_related WHERE id_album = _id_album_a AND id_asset not in
            (SELECT id_asset FROM assets_albums_related WHERE id_album = _id_album_b); 
        
    SELECT id_album, id_directory, name, description, link, random,FN_GET_ASSETS_NUM_IMAGENS_ON_ALBUMS(id_album) as total_images, FN_GET_ASSETS_LAST_IMAGE_ON_ALBUM(id_album) as cover_image, register_date FROM albums WHERE id_album = _id_album_a;
                            
        END IF;
        
		IF(_type = 3)
		THEN
        
            INSERT into assets_albums_related(id_album,id_asset,position,register_date)
            SELECT _id_album_b, id_asset,position, now() FROM assets_albums_related WHERE id_album = _id_album_a AND id_asset not in
            (SELECT id_asset FROM assets_albums_related WHERE id_album = _id_album_b); 
            
		  SELECT id_album, id_directory, name, description, link, random,FN_GET_ASSETS_NUM_IMAGENS_ON_ALBUMS(id_album) as total_images, FN_GET_ASSETS_LAST_IMAGE_ON_ALBUM(id_album) as cover_image, register_date FROM albums WHERE id_album = _id_album_b;
        
        END IF;
        
		IF(_type not in (1,2,3))
		THEN
            SELECT -3 as return_code;
        END IF;

ELSE
    SELECT -2 as return_code;
END IF;

COMMIT;

END;

