create
    definer = skoiypp@`%` procedure SP_SET_ASSETS_IPCT_CORE_STATUS(IN _id_asset int(10), IN _Title varchar(255),
                                                                   IN _JobID varchar(255),
                                                                   IN _Instructions varchar(255),
                                                                   IN _Credit varchar(255), IN _Source varchar(255),
                                                                   IN _CopyrightNotice varchar(255),
                                                                   IN _RightsUsageTerms varchar(255))
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
    SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF EXISTS (SELECT id_asset FROM assets WHERE id_asset = _id_asset)
THEN
    IF NOT EXISTS (SELECT id_asset FROM assets_ipct_core_status WHERE id_asset = _id_asset)
    THEN
        INSERT into assets_ipct_core_status(id_asset,Title,JobID,Instructions,Credit,Source,CopyrightNotice,RightsUsageTerms,register_date)
        VALUES(_id_asset,_Title,_JobID,_Instructions,_Credit,_Source,_CopyrightNotice,_RightsUsageTerms,now());
       
        SELECT id_asset,Title,JobID,Instructions,Credit,Source,CopyrightNotice,RightsUsageTerms
        FROM assets_ipct_core_status WHERE id_asset = _id_asset;   
   ELSE
        UPDATE assets_ipct_core_status SET Title = _Title,JobID = _JobID,Instructions = _Instructions,Credit = _Credit,Source = _Source,CopyrightNotice = _CopyrightNotice,RightsUsageTerms = _RightsUsageTerms, update_date = now() WHERE id_asset = _id_asset;
        SELECT id_asset,Title,JobID,Instructions,Credit,Source,CopyrightNotice,RightsUsageTerms 
        FROM assets_ipct_core_status WHERE id_asset = _id_asset;
    END IF;
ELSE
    SELECT -2 as return_code;
END IF;

COMMIT;

END;

