create
    definer = skoiypp@`%` procedure SP_SET_ASSETS_IPTC_CORE_IMAGE(IN _id_asset INT(10), IN _DateCreated datetime,
                                                                  IN _IntellectualGenre varchar(255),
                                                                  IN _Scene varchar(255), IN _Location varchar(255),
                                                                  IN _City varchar(255), IN _ProvinceState varchar(255),
                                                                  IN _Country varchar(255),
                                                                  IN _CountryCode varchar(255))
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
    SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF EXISTS (SELECT id_asset FROM assets WHERE id_asset = _id_asset)
THEN
    IF NOT EXISTS (SELECT id_asset FROM assets_iptc_core_image WHERE id_asset = _id_asset)
    THEN
        INSERT into assets_iptc_core_image(id_asset,DateCreated,IntellectualGenre,Scene,Location,City,ProvinceState,Country,CountryCode,register_date)
        VALUES(_id_asset,_DateCreated,_IntellectualGenre,_Scene,_Location,_City,_ProvinceState,_Country,_CountryCode,now());
       
        UPDATE assets SET created_date = _DateCreated WHERE id_asset = _id_asset;

        SELECT id_asset,DateCreated,IntellectualGenre,Scene,Location,City,ProvinceState,Country,CountryCode 
        FROM assets_iptc_core_image WHERE id_asset = _id_asset;   
   ELSE
        UPDATE assets_iptc_core_image SET DateCreated = _DateCreated,IntellectualGenre = _IntellectualGenre,Scene = _Scene,Location = _Location,City = _City,ProvinceState = _ProvinceState,Country = _Country,CountryCode = _CountryCode, update_date = now() WHERE id_asset = _id_asset;
        SELECT id_asset,DateCreated,IntellectualGenre,Scene,Location,City,ProvinceState,Country,CountryCode 
        FROM assets_iptc_core_image WHERE id_asset = _id_asset;
    END IF;
ELSE
    SELECT -2 as return_code;
END IF;

COMMIT;

END;

