create
    definer = skoiypp@`%` procedure SP_SET_ASSETS_IPTC_EXTENSION_ADMINISTRATIVE_INFORMATION(IN _id_asset INT(10),
                                                                                            IN _ImageSupplier varchar(255),
                                                                                            IN _ImageSupplierID varchar(255),
                                                                                            IN _ImageSupplierImageID varchar(255),
                                                                                            IN _RegistryID varchar(255),
                                                                                            IN _RegistryIDRegOrgID varchar(255),
                                                                                            IN _RegistryIDRegItemID varchar(255),
                                                                                            IN _MaxAvailWidth varchar(255),
                                                                                            IN _MaxAvailHeight varchar(255),
                                                                                            IN _DigitalSourceType varchar(255))
BEGIN


DECLARE exit handler for sqlexception
  BEGIN
    
    SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_asset FROM assets WHERE id_asset = _id_asset)
THEN
    IF NOT EXISTS (SELECT id_asset FROM assets_iptc_extension_administrative_information WHERE id_asset = _id_asset)
    THEN
        INSERT into assets_iptc_extension_administrative_information(id_asset,ImageSupplier,ImageSupplierID,ImageSupplierImageID,RegistryID,RegistryIDRegOrgID,RegistryIDRegItemID,MaxAvailWidth,MaxAvailHeight,DigitalSourceType,register_date)
        VALUES(_id_asset,_ImageSupplier,_ImageSupplierID,_ImageSupplierImageID,_RegistryID,_RegistryIDRegOrgID,_RegistryIDRegItemID,_MaxAvailWidth,_MaxAvailHeight,_DigitalSourceType,now());
       
        SELECT id_asset,ImageSupplier,ImageSupplierID,ImageSupplierImageID,RegistryID,RegistryIDRegOrgID,RegistryIDRegItemID,MaxAvailWidth,MaxAvailHeight,DigitalSourceType
        FROM assets_iptc_extension_administrative_information WHERE id_asset = _id_asset;   
   ELSE
        UPDATE assets_iptc_extension_administrative_information SET ImageSupplier = _ImageSupplier,ImageSupplierID = _ImageSupplierID,ImageSupplierImageID = _ImageSupplierImageID,RegistryID = _RegistryID,RegistryIDRegOrgID = _RegistryIDRegOrgID,RegistryIDRegItemID = _RegistryIDRegItemID,MaxAvailWidth = _MaxAvailWidth,MaxAvailHeight = _MaxAvailHeight,DigitalSourceType = _DigitalSourceType, update_date = now() WHERE id_asset = _id_asset;
        SELECT id_asset,ImageSupplier,ImageSupplierID,ImageSupplierImageID,RegistryID,RegistryIDRegOrgID,RegistryIDRegItemID,MaxAvailWidth,MaxAvailHeight,DigitalSourceType 
        FROM assets_iptc_extension_administrative_information WHERE id_asset = _id_asset;
    END IF;
ELSE
    SELECT -2 as return_code;
END IF;

COMMIT;

END;

