create
    definer = skoiypp@`%` procedure SP_SET_ASSETS_TAGS_GROUPS(IN _id_group int, IN _parent_id_group int, IN _name varchar(192))
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF (_id_group < 1)
THEN
	IF NOT EXISTS (SELECT id_group FROM assets_tags_groups WHERE id_group = 1)
	THEN
		INSERT INTO assets_tags_groups(id_group,name,register_date) VALUES(1,'root',now());
		INSERT INTO assets_tags_groups(name,register_date) VALUES(_name,now());
		SET p_last_id = last_insert_id();
		INSERT INTO assets_tags_groups_parent_related(id_group,parent_id_group, register_date) VALUES(p_last_id,1,now()) ON DUPLICATE KEY UPDATE update_date = now();
		SELECT id_group,name FROM assets_tags_groups WHERE id_group = p_last_id;
	ELSE
		IF (_parent_id_group < 1)
		THEN
			INSERT INTO assets_tags_groups(name,register_date) VALUES(_name,now());
			SET p_last_id = last_insert_id();
			INSERT INTO assets_tags_groups_parent_related(id_group,parent_id_group, register_date) VALUES(p_last_id,1,now()) ON DUPLICATE KEY UPDATE update_date = now();
			SELECT id_group,name FROM assets_tags_groups WHERE id_group = p_last_id;
		ELSE
			IF EXISTS (SELECT id_group FROM assets_tags_groups WHERE id_group = _parent_id_group)
			THEN
				INSERT INTO assets_tags_groups(name,register_date) VALUES(_name,now());
				SET p_last_id = last_insert_id();
				INSERT INTO assets_tags_groups_parent_related(id_group,parent_id_group, register_date) VALUES(p_last_id,_parent_id_group,now()) ON DUPLICATE KEY UPDATE update_date = now();
				SELECT id_group,name FROM assets_tags_groups WHERE id_group = p_last_id;
			ELSE
				SELECT -2 as return_code;
			END IF;
		
		END IF;

	END IF;

ELSE 
	IF NOT EXISTS (SELECT id_group FROM assets_tags_groups WHERE id_group = _id_group)
	THEN
		SELECT -2 as return_code;
	ELSE
		IF (_id_group = 1)
		THEN
			SELECT id_group,name FROM assets_tags_groups WHERE id_group = _id_group;
		ELSE
			IF EXISTS (SELECT id_group FROM assets_tags_groups WHERE id_group = _parent_id_group)
			THEN
			    
				UPDATE assets_tags_groups SET name = _name, update_date = now() WHERE id_group = _id_group;
				UPDATE assets_tags_groups_parent_related SET parent_id_group = _parent_id_group WHERE id_group = _id_group;
				SELECT id_group,name FROM assets_tags_groups WHERE id_group = _id_group;
			ELSE
				SELECT -2 as return_code;
			END IF;
		END IF;	

	END IF;
END IF;

COMMIT;

END;

