create
    definer = skoiypp@`%` procedure SP_SET_LIVE_CHANNELS_L10N(IN _id_l10n int, IN _id_channel int,
                                                              IN _iso_language varchar(10), IN _name varchar(255),
                                                              IN _description text, IN _image varchar(255),
                                                              IN _meta_title varchar(255),
                                                              IN _meta_description varchar(255),
                                                              IN _meta_image varchar(255), IN _image_title varchar(255),
                                                              IN _image_alter_text varchar(255),
                                                              IN _meta_keywords varchar(255))
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
    SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_channel FROM channels WHERE id_channel = _id_channel)
THEN
	IF(_id_l10n = 0 OR _id_l10n = -1)
	THEN
		IF NOT EXISTS (SELECT id_l10n FROM channels_l10n WHERE id_channel = _id_channel AND iso_language = _iso_language)
	    THEN
		INSERT INTO channels_l10n(id_l10n,id_channel,iso_language,name,description,image,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,register_date) VALUES(_id_l10n,_id_channel,_iso_language,_name,_description,_image,_meta_title,_meta_description,_meta_image,_image_title,_image_alter_text,_meta_keywords,now());
		SET p_last_id = last_insert_id();
		SELECT id_l10n,id_channel,iso_language,name,description,image,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,register_date FROM channels_l10n WHERE id_l10n = p_last_id; 
		ELSE
	        SELECT -2 as return_code;
	    END IF;
	ELSE       
	     IF EXISTS (SELECT id_l10n FROM channels_l10n WHERE id_l10n = _id_l10n)
	     THEN
	        UPDATE channels_l10n SET name = _name, description = _description, image = _image,meta_title = _meta_title,meta_description = _meta_description,meta_image = _meta_image,image_title = _image_title,image_alter_text = _image_alter_text,meta_keywords = _meta_keywords,update_date = now() WHERE id_l10n = _id_l10n AND id_channel = _id_channel;
	        SELECT id_l10n,id_channel,iso_language,name,description,image,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,register_date FROM channels_l10n WHERE id_l10n = _id_l10n;
	     ELSE
	        SELECT -2 as return_code;
	     END IF;
	END IF;
ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

