create
    definer = skoiypp@`%` procedure SP_SET_LIVE_PLAYLISTS(IN _id_playlist int, IN _management_name varchar(192),
                                                          IN _publish_date datetime, IN _begin_date datetime,
                                                          IN _end_date datetime)
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_id_playlist = 0 OR _id_playlist = -1)
THEN
   INSERT INTO playlists(management_name,publish_date,begin_date,end_date,register_date) VALUES(_management_name,_publish_date,_begin_date,_end_date,now());
   SET p_last_id = last_insert_id();
   SELECT id_playlist,management_name, publish_date,begin_date, end_date,state,register_date FROM playlists WHERE id_playlist = p_last_id;
ELSE
	IF EXISTS (SELECT id_playlist FROM playlists WHERE id_playlist = _id_playlist)
	THEN	   
		SELECT FN_SP_SET_PUBLISH_VIDEO_SYNC_UPDATE(13,_id_playlist) into _empty;
		UPDATE playlists SET management_name = _management_name,publish_date = _publish_date,begin_date = _begin_date, end_date = _end_date, update_date = now() WHERE id_playlist = _id_playlist;
		SELECT id_playlist, management_name, begin_date, end_date,state,register_date FROM playlists WHERE id_playlist = _id_playlist;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;  
  
COMMIT;

END;

