create
    definer = skoiypp@`%` procedure SP_SET_POSTS_CUSTOM_FIELDS_KEY(IN _id_key int, IN _name varchar(192),
                                                                   IN _name_stripped varchar(192),
                                                                   IN _public tinyint(1), IN _if_exists tinyint(1))
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF(_id_key = 0 OR _id_key = -1)
THEN
    IF (((SELECT count(1) FROM posts_custom_fields_keys WHERE name_stripped = _name_stripped)>0) AND _if_exists = 1)
    THEN
            SELECT id_key,name,name_stripped,public FROM posts_custom_fields_keys WHERE name_stripped = _name_stripped LIMIT 0,1; 
    ELSE
            INSERT into posts_custom_fields_keys(name,name_stripped,public,register_date) VALUES(_name,_name_stripped,_public,now());        
            SET p_last_id = last_insert_id();
            SELECT id_key,name,name_stripped,public,regex,fixed_field,read_only,field_type, '' as default_value, 0 as mandatory, 0 as autofill FROM posts_custom_fields_keys WHERE id_key = p_last_id; 
    END IF;        
ELSE       
     IF EXISTS (SELECT id_key FROM posts_custom_fields_keys WHERE id_key = _id_key)
     THEN
        UPDATE posts_custom_fields_keys SET name = _name,name_stripped = _name_stripped,public = _public, update_date = now() WHERE id_key = _id_key;
        SELECT id_key,name,name_stripped,public,regex,fixed_field,read_only,field_type, '' as default_value, 0 as mandatory, 0 as autofill FROM posts_custom_fields_keys WHERE id_key = _id_key; 
     ELSE
        SELECT -2 as return_code;
     END IF;
END IF;
COMMIT;

END;

