create
    definer = skoiypp@`%` procedure SP_SET_POSTS_DOSSIERS_STICKER_RELATED(IN _id_sticker INT(10),
                                                                          IN _id_dossier INT(10), IN _position INT(10),
                                                                          IN _begin_date DATETIME,
                                                                          IN _end_date DATETIME, IN _color VARCHAR(255))
BEGIN

-- call SP_SET_POSTS_DOSSIERS_STICKER_RELATED(18,20,1,'','','')

DECLARE lastposition INT;
DECLARE currentposition INT;
DECLARE _empty INT;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
    SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF EXISTS (SELECT id_sticker FROM posts_stickers WHERE id_sticker = _id_sticker) AND EXISTS (SELECT id_dossier FROM dossiers WHERE id_dossier = _id_dossier)
THEN

	SELECT position into currentposition FROM dossiers_stickers_related WHERE id_sticker = _id_sticker AND id_dossier = _id_dossier;
    SELECT count(1) into lastposition FROM dossiers_stickers_related WHERE id_sticker = _id_sticker;
    
	IF(_position = 0 OR _position = -1)
	  THEN
		SET _position = lastposition+1;
	END IF;
  
    IF NOT EXISTS(SELECT id_sticker FROM dossiers_stickers_related WHERE id_sticker = _id_sticker AND id_dossier = _id_dossier)
    THEN
        INSERT INTO dossiers_stickers_related(id_sticker,id_dossier,position,begin_date,end_date,color,update_date,register_date) VALUES(_id_sticker,_id_dossier,_position,_begin_date,_end_date,_color,now(),now());
        
			SET @rownum=0;
			UPDATE dossiers_stickers_related c, (SELECT @rownum:=@rownum+1 rownum, dossiers_stickers_related.* FROM dossiers_stickers_related WHERE id_sticker = _id_sticker ORDER BY position,register_date desc) r 
			SET c.position = r.rownum
			WHERE (c.id_related = r.id_related);
			-- SELECT FN_SP_SET_PUBLISH_POSTS_SYNC_UPDATE(70,_id_dossier) into _empty;
            
    ELSE
        
		UPDATE dossiers_stickers_related SET position = _position, begin_date = _begin_date,end_date = _end_date,color = _color, update_date = now() WHERE id_sticker = _id_sticker AND id_dossier = _id_dossier;
        
		IF(_position < currentposition)
		 THEN   
         
			SET @rownum=0;
			UPDATE dossiers_stickers_related c, (SELECT @rownum:=@rownum+1 rownum, dossiers_stickers_related.* FROM dossiers_stickers_related WHERE id_sticker = _id_sticker ORDER BY position,update_date desc) r 
			SET c.position = r.rownum
			WHERE (c.id_related = r.id_related);
            
			INSERT into posts_sync_updated_2(id_dossier,action_type,register_date) SELECT _id_dossier,2,now() FROM dossiers 
        	WHERE id_dossier in (SELECT distinct id_dossier FROM dossiers_stickers_related WHERE id_sticker = _id_sticker AND position BETWEEN _position AND currentposition); 
            
		END IF;
        
        IF(_position > currentposition)
        THEN
        
			SET @rownum=0;
			UPDATE dossiers_stickers_related c, (SELECT @rownum:=@rownum+1 rownum, dossiers_stickers_related.* FROM dossiers_stickers_related WHERE id_sticker = _id_sticker ORDER BY position,update_date asc) r 
			SET c.position = r.rownum
			WHERE (c.id_related = r.id_related);
            
            INSERT into posts_sync_updated_2(id_dossier,action_type,register_date) SELECT id_dossier,2,now() FROM dossiers 
        	WHERE id_dossier in (SELECT distinct id_dossier FROM dossiers_stickers_related WHERE id_sticker = _id_sticker AND position BETWEEN currentposition AND _position); 
		END IF;
        
	END IF;
        
        SELECT 0 as return_code;

ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

