create
    definer = skoiypp@`%` procedure SP_SET_POSTS_FEEDS_INTERNAL(IN _id_feed int, IN _name varchar(255),
                                                                IN _domain varchar(255), IN _feed_length int(15),
                                                                IN _feed_type varchar(255),
                                                                IN _can_overwrite tinyint(1),
                                                                IN _tracking_parameters varchar(255),
                                                                IN _image_optimization varchar(255),
                                                                IN _feed_title varchar(255), IN _feed_description text,
                                                                IN _feed_image varchar(255),
                                                                IN _feed_copyright varchar(255),
                                                                IN _number_of_bodies int(10))
BEGIN



DECLARE p_last_id INT UNSIGNED;
DECLARE _token VARCHAR(255);
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
    SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF(_id_feed = 0 OR _id_feed = -1)
THEN

SELECT SUBSTRING(MD5(RAND()) from 1 for 10) into _token;
WHILE NOT EXISTS(SELECT count(1) FROM posts_feeds_internal WHERE token = _token)
DO
    SELECT SUBSTRING(MD5(RAND()) from 1 for 10) into _token;
END WHILE;

        INSERT into posts_feeds_internal(name,token,domain,feed_length,feed_type,can_overwrite,tracking_parameters,image_optimization,feed_title,feed_description,feed_image,feed_copyright,number_of_bodies,register_date) 
        VALUES(_name,_token,_domain,_feed_length,_feed_type,_can_overwrite,_tracking_parameters,_image_optimization,_feed_title,_feed_description,_feed_image,_feed_copyright,_number_of_bodies,now());        
        SET p_last_id = last_insert_id();
        SELECT id_feed,token,name,domain,feed_length,feed_type,can_overwrite,tracking_parameters,image_optimization,feed_title,feed_description,feed_image,feed_copyright,number_of_bodies,register_date FROM posts_feeds_internal WHERE id_feed = p_last_id; 
ELSE       
     IF EXISTS (SELECT id_feed FROM posts_feeds_internal WHERE id_feed = _id_feed)
     THEN
        UPDATE posts_feeds_internal SET name = _name,domain = _domain,feed_length = _feed_length,feed_type = _feed_type,can_overwrite = _can_overwrite,tracking_parameters = _tracking_parameters,image_optimization = _image_optimization,feed_title = _feed_title,feed_description = _feed_description,feed_image = _feed_image,feed_copyright = _feed_copyright,number_of_bodies = _number_of_bodies,update_date = now() WHERE id_feed = _id_feed;
        SELECT id_feed,token,name,domain,feed_length,feed_type,can_overwrite,tracking_parameters,image_optimization,feed_title,feed_description,feed_image,feed_copyright,number_of_bodies,register_date FROM posts_feeds_internal WHERE id_feed = _id_feed; 
     ELSE
        SELECT -2 as return_code;
     END IF;
END IF;
COMMIT;

END;

