create
    definer = skoiypp@`%` procedure SP_SET_POSTS_STICKERS_GROUPS(IN _id_group int(10), IN _name varchar(255),
                                                                 IN _name_stripped varchar(255), IN _token varchar(255),
                                                                 IN _urls text, IN _priority tinyint(1),
                                                                 IN _active tinyint(1))
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_group FROM posts_stickers_groups WHERE id_group = _id_group)
THEN
	UPDATE posts_stickers_groups SET name = _name, name_stripped = _name_stripped, urls = _urls, priority = _priority, active = _active WHERE id_group = _id_group;
	SELECT id_group, name,name_stripped,token,urls,priority,active, FN_GET_POSTS_STICKERS_NUM_ITEMS_ON_GROUP(id_group) as total_items,update_date, register_date FROM posts_stickers_groups WHERE id_group = _id_group;
ELSE

SELECT SUBSTRING(MD5(RAND()) from 1 for 10) into _token;
WHILE NOT EXISTS(SELECT count(1) FROM posts_stickers_groups WHERE token = _token)
DO
	SELECT SUBSTRING(MD5(RAND()) from 1 for 10) into _token;
END WHILE;

	INSERT into posts_stickers_groups(name,name_stripped,token,urls,priority,active,register_date)
	VALUES (_name,_name_stripped,_token,_urls,_priority,_active,now());
	SET p_last_id = last_insert_id();
	SELECT id_group, name,name_stripped,token,urls,priority,active, FN_GET_POSTS_STICKERS_NUM_ITEMS_ON_GROUP(id_group) as total_items,update_date, register_date FROM posts_stickers_groups WHERE id_group = p_last_id;
END IF;

COMMIT;

END;

