create
    definer = skoiypp@`%` procedure SP_SET_POSTS_STICKERS_GROUPS(IN _sticker_type int(10), IN _id_group INT(10),
                                                                 IN _name VARCHAR(255), IN _name_stripped VARCHAR(255),
                                                                 IN _token VARCHAR(255), IN _meta_url VARCHAR(255),
                                                                 IN _priority tinyint(1), IN _active tinyint(1))
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF EXISTS (SELECT id_group FROM posts_stickers_groups WHERE id_group = _id_group)
THEN
	UPDATE posts_stickers_groups SET name = _name, name_stripped = _name_stripped, meta_url = _meta_url, priority = _priority, active = _active WHERE id_group = _id_group;
    SELECT FN_SP_SET_PUBLISH_POSTS_SYNC_UPDATE(761,_id_group) into _empty;
	SELECT id_group, sticker_type,name,name_stripped,token,meta_url,priority,active, FN_GET_POSTS_STICKERS_NUM_ITEMS_ON_GROUP(id_group) as total_items,update_date, register_date FROM posts_stickers_groups WHERE id_group = _id_group;
ELSE

SELECT SUBSTRING(MD5(RAND()) from 1 for 10) into _token;
WHILE NOT EXISTS(SELECT count(1) FROM posts_stickers_groups WHERE token = _token)
DO
	SELECT SUBSTRING(MD5(RAND()) from 1 for 10) into _token;
END WHILE;

	INSERT into posts_stickers_groups(sticker_type,name,name_stripped,token,meta_url,priority,active,register_date)
	VALUES (_sticker_type,_name,_name_stripped,_token,_meta_url,_priority,_active,now());
	SET p_last_id = last_insert_id();
	SELECT id_group, sticker_type,name,name_stripped,token,meta_url,priority,active, FN_GET_POSTS_STICKERS_NUM_ITEMS_ON_GROUP(id_group) as total_items,update_date, register_date FROM posts_stickers_groups WHERE id_group = p_last_id;

END IF;

COMMIT;

END;

