create
    definer = skoiypp@`%` procedure SP_SET_PUBLISH_VIDEO_CHANNELS_TO_OFFLINE()
BEGIN

DECLARE no_more_rows INT DEFAULT FALSE;
DECLARE num_rows INT DEFAULT 0;
DECLARE c_id_channel INT;
DECLARE _empty INT;

DECLARE cursor_id_channel CURSOR FOR SELECT id_channel FROM channels WHERE end_date < now() AND date(end_date) NOT IN ('0000-00-00') AND state = 5;
DECLARE CONTINUE HANDLER FOR NOT FOUND SET no_more_rows = TRUE;



DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

 
   
    OPEN cursor_id_channel;
    SELECT FOUND_ROWS() into num_rows;
    
      read_loop: LOOP
        FETCH cursor_id_channel INTO c_id_channel;
    
        IF no_more_rows THEN
          LEAVE read_loop;
        END IF;
      
	
		
	SELECT FN_SP_SET_PUBLISH_VIDEO_SYNC_UPDATE(32,c_id_channel) into _empty;
        
	UPDATE channels SET state = 4 WHERE id_channel = c_id_channel; 
	UPDATE playlists SET state = 4 WHERE id_playlist in (SELECT id_playlist FROM playlists_channels_related WHERE id_channel = c_id_channel); 
	
    UPDATE video_composed SET state = 4 WHERE id_composed in (select id_composed FROM video_composed_playlists_related WHERE id_playlist in (SELECT id_playlist FROM playlists_channels_related WHERE id_channel = c_id_channel)) AND 
		(SELECT FN_GET_VIDEO_COMPOSES_ON_PLAYLISTS(id_composed)) = 1;
		
      CALL SP_PUBLISH_VIDEO_CHANGE_PROFILE_AND_VIDEO_STATE_BY_CHANNEL(c_id_channel,@result);
      IF(@result <> 0)
      THEN
        SELECT -1 as return_code;
      END IF;              
	
    
      END LOOP read_loop;

    CLOSE cursor_id_channel;
 

	SELECT 0 as return_code;

COMMIT;

END;

