create
    definer = skoiypp@`%` procedure SP_SET_PUBLISH_VIDEO_PLAYLISTS_CHANNELS_REORDER()
BEGIN

DECLARE no_more_rows INT DEFAULT FALSE;
DECLARE num_rows INT DEFAULT 0;

DECLARE c_id_channel INT;

DECLARE cursor_channel CURSOR FOR SELECT distinct id_channel FROM playlists_channels_related;
DECLARE CONTINUE HANDLER FOR NOT FOUND SET no_more_rows = TRUE;



DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

    
    OPEN cursor_channel;

    SELECT FOUND_ROWS() into num_rows;
    
      read_loop: LOOP
        FETCH cursor_channel INTO c_id_channel;
    
        IF no_more_rows THEN
          LEAVE read_loop;
        END IF;
      
	

    SET @rownum=0;
    UPDATE playlists_channels_related p, (SELECT @rownum:=@rownum+1 rownum, playlists_channels_related.* FROM playlists_channels_related WHERE id_channel = c_id_channel ORDER BY position,update_date desc) r 
    SET p.position = r.rownum
    WHERE (p.id_playlist = r.id_playlist);

	
    
      END LOOP read_loop;

    CLOSE cursor_channel;
    

	SELECT 0 as return_code;

COMMIT;

END;

