create
    definer = skoiypp@`%` procedure SP_SET_PUSH_VIDEO_PROCESSED(IN _id_queue int(10), IN _field int(10),
                                                                IN _output_video varchar(255))
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

	IF EXISTS(SELECT id_account FROM loader_video_queue WHERE id_queue = _id_queue AND is_running = 1)
	THEN
    
		INSERT into loader_video_completed(id_account,account_token,push_type,id_directory,input_path,video_name,input_video,output_video,extension,mime_type,size,started,finished,machine,requester,register_date)
	 	SELECT id_account,account_token,push_type,id_directory,input_path,video_name,video,_output_video,extension,mime_type,size,start,now(),machine,requester,now() FROM loader_video_queue WHERE id_queue = _id_queue;
		SET p_last_id = last_insert_id();
        
        INSERT into loader_video_details_completed(id_queue,id_profile,id_playlist,publish_date,begin_date,end_date,register_date)
        SELECT p_last_id, id_profile,id_playlist,publish_date,begin_date,end_date,now() FROM loader_video_details WHERE id_queue = _id_queue;
        
		INSERT into loader_video_versions_completed(id_queue,push_type,version,input_path,video_name,video,extension,mime_type,size,register_date)
        SELECT p_last_id, push_type,version,input_path,video_name,video,extension,mime_type,size,now() FROM loader_video_versions WHERE id_queue = _id_queue;
        
        DELETE FROM loader_video_queue WHERE id_queue = _id_queue;
		DELETE FROM loader_video_details WHERE id_queue = _id_queue;
		DELETE FROM loader_video_versions WHERE id_queue = _id_queue;        
        
        SELECT 0 as return_code;
	ELSE
		SELECT -2 as return_code;
	END IF; 
                
COMMIT;

END;

