create
    definer = skoiypp@`%` procedure SP_SET_VIDEO_PROFILE_CLONE_L10N(IN _id_profile int, IN _id_profile_clone int)
BEGIN

DECLARE no_more_rows INT DEFAULT FALSE;
DECLARE num_rows INT DEFAULT 0;
DECLARE c_id_l10n INT;
DECLARE c_iso_language VARCHAR(10);

DECLARE cursor_l10n CURSOR FOR SELECT id_l10n,iso_language FROM video_profiles_l10n WHERE id_profile = _id_profile;
DECLARE CONTINUE HANDLER FOR NOT FOUND SET no_more_rows = TRUE;

START TRANSACTION;

    
   
    OPEN cursor_l10n;
    IF(@result = -1)
        THEN
            SELECT -1 as return_code;
            ROLLBACK;
    END IF;
    SELECT FOUND_ROWS() into num_rows;
    
      read_loop: LOOP
        FETCH cursor_l10n INTO c_id_l10n,c_iso_language;
    
        IF no_more_rows THEN
          LEAVE read_loop;
        END IF;
      
	
                
	INSERT into video_profiles_l10n_tags_related(id_tag,id_l10n,position,register_date) 
		 SELECT id_tag,c_id_l10n,position,now() FROM video_profiles_l10n_tags_related WHERE id_l10n = (SELECT id_l10n FROM video_profiles_l10n WHERE id_profile = _id_profile_clone AND iso_language = c_iso_language);

	INSERT into video_profiles_l10n_body(id_l10n,body,register_date)
		 SELECT c_id_l10n,body,now() FROM video_profiles_l10n_body WHERE id_l10n = (SELECT id_l10n FROM video_profiles_l10n WHERE id_profile = _id_profile_clone AND iso_language = c_iso_language);

	INSERT into video_profiles_l10n_photos(id_asset,id_l10n,position,register_date) 
		 SELECT id_asset,c_id_l10n,position,now() FROM video_profiles_l10n_photos WHERE id_l10n = (SELECT id_l10n FROM video_profiles_l10n WHERE id_profile = _id_profile_clone AND iso_language = c_iso_language);

	INSERT into video_profiles_l10n_albums(id_album,id_l10n,register_date) 
		 SELECT id_album,c_id_l10n,now() FROM video_profiles_l10n_albums WHERE id_l10n = (SELECT id_l10n FROM video_profiles_l10n WHERE id_profile = _id_profile_clone AND iso_language = c_iso_language);


	
    
      END LOOP read_loop;

    CLOSE cursor_l10n;
    

COMMIT;

END;

