create
    definer = skoiypp@`%` procedure SP_SET_VIDEO_TO_PROCESSED(IN _id_account int(10), IN _account_token varchar(255),
                                                              IN _output_path_clean varchar(255), IN _id_video int(10),
                                                              IN _source varchar(255), IN _command text,
                                                              IN _versions text, IN _h264 tinyint(1),
                                                              IN _ogg tinyint(1), IN _webm tinyint(1),
                                                              IN _width int(10), IN _height int(10),
                                                              IN _seconds float(10, 2), IN _aspect_ratio varchar(255),
                                                              IN _id_storage int(10), IN _id_cdn int(10))
BEGIN

DECLARE _position INT(10) DEFAULT 1; 


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;



START TRANSACTION;

IF(_versions <> '')
THEN

	IF(_h264 = 1) THEN
		SELECT max(position)+1 INTO _position FROM video_transcoding_h264_queue WHERE id_account = _id_account;
                IF(_position is null) THEN SET _position = 1; END IF;
		INSERT into video_transcoding_h264_queue(id_account,account_token,output_path,id_video,video,command,versions,width,height,seconds,duration,aspect_ratio,position,id_storage,id_cdn,register_date) VALUES(_id_account,_account_token,_output_path_clean,_id_video,_source,_command,_versions,_width,_height,_seconds,SEC_TO_TIME(_seconds),_aspect_ratio,_position,_id_storage,_id_cdn,now());
		INSERT into video_transcoding_h264_history(id_account,account_token,output_path,id_video,video,command,versions,width,height,seconds,duration,aspect_ratio,id_storage,id_cdn,register_date) VALUES(_id_account,_account_token,_output_path_clean,_id_video,_source,_command,_versions,_width,_height,_seconds,SEC_TO_TIME(_seconds),_aspect_ratio,_id_storage,_id_cdn,now());
	END IF;
	IF(_webm = 1) THEN
		SELECT max(position)+1 FROM video_transcoding_webm_queue WHERE id_account = _id_account;
                IF(_position is null) THEN SET _position = 1; END IF;
		INSERT into video_transcoding_webm_queue(id_account,account_token,output_path,id_video,video,command,versions,width,height,seconds,duration,aspect_ratio,position,id_storage,id_cdn,register_date) VALUES(_id_account,_account_token,_output_path_clean,_id_video,_source,_command,_versions,_width,_height,_seconds,SEC_TO_TIME(_seconds),_aspect_ratio,_position,_id_storage,_id_cdn,now());
		INSERT into video_transcoding_webm_history(id_account,account_token,output_path,id_video,video,command,versions,width,height,seconds,duration,aspect_ratio,id_storage,id_cdn,register_date) VALUES(_id_account,_account_token,_output_path_clean,_id_video,_source,_command,_versions,_width,_height,_seconds,SEC_TO_TIME(_seconds),_aspect_ratio,_id_storage,_id_cdn,now());	
	END IF;
	IF(_ogg = 1) THEN
		SELECT max(position)+1 INTO _position FROM video_transcoding_ogg_queue WHERE id_account = _id_account;
                IF(_position is null) THEN SET _position = 1; END IF;
		INSERT into video_transcoding_ogg_queue(id_account,account_token,output_path,id_video,video,command,versions,width,height,seconds,duration,aspect_ratio,position,id_storage,id_cdn,register_date) VALUES(_id_account,_account_token,_output_path_clean,_id_video,_source,_command,_versions,_width,_height,_seconds,SEC_TO_TIME(_seconds),_aspect_ratio,_position,_id_storage,_id_cdn,now());
		INSERT into video_transcoding_ogg_history(id_account,account_token,output_path,id_video,video,command,versions,width,height,seconds,duration,aspect_ratio,id_storage,id_cdn,register_date) VALUES(_id_account,_account_token,_output_path_clean,_id_video,_source,_command,_versions,_width,_height,_seconds,SEC_TO_TIME(_seconds),_aspect_ratio,_id_storage,_id_cdn,now());		
	END IF;
    
	IF(_h264 = 1) THEN
	SET @rownum=0;    
	UPDATE video_transcoding_h264_queue vh264, (SELECT @rownum:=@rownum+1 rownum, id_queue FROM(    
		SELECT id_queue FROM video_transcoding_h264_queue WHERE id_account = _id_account AND versions like '%144/lm%'
		UNION
		SELECT id_queue FROM video_transcoding_h264_queue WHERE id_account = _id_account AND  versions like '%270/lm%'
		UNION
		SELECT id_queue FROM video_transcoding_h264_queue WHERE id_account = _id_account AND  versions like '%270/w%'
		UNION
		SELECT id_queue FROM video_transcoding_h264_queue WHERE id_account = _id_account AND  versions like '%360/m%'
		UNION
		SELECT id_queue FROM video_transcoding_h264_queue WHERE id_account = _id_account AND  versions like '%360/w%'
		UNION
		SELECT id_queue FROM video_transcoding_h264_queue WHERE id_account = _id_account AND  versions like '%540/m%'
		UNION
		SELECT id_queue FROM video_transcoding_h264_queue WHERE id_account = _id_account AND  versions like '%540/w%'
		UNION
		SELECT id_queue FROM video_transcoding_h264_queue WHERE id_account = _id_account AND  versions like '%720/w%'
		UNION
		SELECT id_queue FROM video_transcoding_h264_queue WHERE id_account = _id_account AND versions like '%1080/w%'
		) as tt) r  
    SET vh264.position = r.rownum
	WHERE (vh264.id_queue = r.id_queue);
	END IF;
    
	IF(_webm = 1) THEN
	SET @rownum=0;    
	UPDATE video_transcoding_webm_queue vwebm, (SELECT @rownum:=@rownum+1 rownum, id_queue FROM(    
		SELECT id_queue FROM video_transcoding_webm_queue WHERE id_account = _id_account AND versions like '%144/lm%'
		UNION
		SELECT id_queue FROM video_transcoding_webm_queue WHERE id_account = _id_account AND  versions like '%270/lm%'
		UNION
		SELECT id_queue FROM video_transcoding_webm_queue WHERE id_account = _id_account AND  versions like '%270/w%'
		UNION
		SELECT id_queue FROM video_transcoding_webm_queue WHERE id_account = _id_account AND  versions like '%360/m%'
		UNION
		SELECT id_queue FROM video_transcoding_webm_queue WHERE id_account = _id_account AND  versions like '%360/w%'
		UNION
		SELECT id_queue FROM video_transcoding_webm_queue WHERE id_account = _id_account AND  versions like '%540/m%'
		UNION
		SELECT id_queue FROM video_transcoding_webm_queue WHERE id_account = _id_account AND  versions like '%540/w%'
		UNION
		SELECT id_queue FROM video_transcoding_webm_queue WHERE id_account = _id_account AND  versions like '%720/w%'
		UNION
		SELECT id_queue FROM video_transcoding_webm_queue WHERE id_account = _id_account AND versions like '%1080/w%'
		) as tt) r  
    SET vwebm.position = r.rownum
	WHERE (vwebm.id_queue = r.id_queue);
	END IF;
    
	IF(_ogg = 1) THEN
	SET @rownum=0;    
	UPDATE video_transcoding_ogg_queue vogg, (SELECT @rownum:=@rownum+1 rownum, id_queue FROM(    
		SELECT id_queue FROM video_transcoding_ogg_queue WHERE id_account = _id_account AND versions like '%144/lm%'
		UNION
		SELECT id_queue FROM video_transcoding_ogg_queue WHERE id_account = _id_account AND  versions like '%270/lm%'
		UNION
		SELECT id_queue FROM video_transcoding_ogg_queue WHERE id_account = _id_account AND  versions like '%270/w%'
		UNION
		SELECT id_queue FROM video_transcoding_ogg_queue WHERE id_account = _id_account AND  versions like '%360/m%'
		UNION
		SELECT id_queue FROM video_transcoding_ogg_queue WHERE id_account = _id_account AND  versions like '%360/w%'
		UNION
		SELECT id_queue FROM video_transcoding_ogg_queue WHERE id_account = _id_account AND  versions like '%540/m%'
		UNION
		SELECT id_queue FROM video_transcoding_ogg_queue WHERE id_account = _id_account AND  versions like '%540/w%'
		UNION
		SELECT id_queue FROM video_transcoding_ogg_queue WHERE id_account = _id_account AND  versions like '%720/w%'
		UNION
		SELECT id_queue FROM video_transcoding_ogg_queue WHERE id_account = _id_account AND versions like '%1080/w%'
		) as tt) r  
    SET vogg.position = r.rownum
	WHERE (vogg.id_queue = r.id_queue);
	END IF;    
    
    
END IF;
                
COMMIT;

END;

