create
    definer = skoiypp@`%` procedure SP_SET_VIDEO_TRANSCODING_480BY253(IN _id_account int(10),
                                                                      IN _account_token varchar(255),
                                                                      IN _id_video int(10), IN _input_path varchar(255),
                                                                      IN _output_path varchar(255),
                                                                      IN _file_name varchar(255),
                                                                      IN _source varchar(255), IN _width int(10),
                                                                      IN _height int(10), IN _seconds int(10),
                                                                      IN _aspect_ratio varchar(255),
                                                                      IN _audio_codec varchar(255),
                                                                      IN _audio_rate varchar(255),
                                                                      IN _video_rate varchar(255), IN _h264 tinyint(1),
                                                                      IN _ogg tinyint(1), IN _webm tinyint(1),
                                                                      IN _web_version tinyint(1),
                                                                      IN _mobile_version tinyint(1),
                                                                      IN _id_storage int(10), IN _id_cdn int(10))
BEGIN

DECLARE _file_extention varchar(255);

DECLARE _command text;

DECLARE _command_mp4_lm text;
DECLARE _command_mp4__m text;
DECLARE _command_mp4__w text;
DECLARE _command_webm_w text;
DECLARE _command_ogg__w text;

DECLARE _output_path_clean varchar(255);


DECLARE _code_mp4__lm_144 text;
DECLARE _code_mp4__lm_270 text;
DECLARE _code_mp4__m__360 text;
DECLARE _code_mp4__m__540 text;

DECLARE _code_mp4__w__270 text;
DECLARE _code_mp4__w__360 text;
DECLARE _code_mp4__w__540 text;
DECLARE _code_mp4__w__720 text;
DECLARE _code_mp4__w__1080 text;

DECLARE _code_ogg__w__270 text;
DECLARE _code_ogg__w__360 text;
DECLARE _code_ogg__w__540 text;
DECLARE _code_ogg__w__720 text;
DECLARE _code_ogg__w__1080 text;

DECLARE _code_webm_w__270 text;
DECLARE _code_webm_w__360 text;
DECLARE _code_webm_w__540 text;
DECLARE _code_webm_w__720 text;
DECLARE _code_webm_w__1080 text;

DECLARE _versions_lm_144 text;
DECLARE _versions_lm_270 text;
DECLARE _versions__m_360 text;
DECLARE _versions__m_540 text;

DECLARE _versions__w_270 text;
DECLARE _versions__w_360 text;
DECLARE _versions__w_540 text;
DECLARE _versions__w_720 text;
DECLARE _versions__w_1080 text;

DECLARE _versions_m text;
DECLARE _versions_w text;



DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET _output_path_clean = _output_path;
SET _input_path = CONCAT(_input_path,'/',_account_token,'/');
SET _output_path = CONCAT(_output_path,'/',_account_token,'/');


SET _command = CONCAT_WS(' ','ffmpeg -y -threads 8 -i',(CONCAT(_input_path,_source)));



IF(_mobile_version = 1)THEN
	IF(SELECT FN_MAKE_THIS_RESOLUTION(_height,136) = 1)
	THEN

		SET _code_mp4__lm_144 = CONCAT(' \\','\n  ',FN_GET_VIDEO_TRANSCODING_CODE('lm',144,'libx264','aac','3gp',258,136,480,253,'baseline','3.0'),_output_path,'136/lm/',_file_name,'.3gp');
		SET _versions_lm_144 = '136/lm';

	END IF;

	IF(SELECT FN_MAKE_THIS_RESOLUTION(_height,272) = 1)
	THEN

		SET _code_mp4__lm_270 = CONCAT(' \\','\n  ',FN_GET_VIDEO_TRANSCODING_CODE('lm',270,'libx264','aac','3gp',516,272,480,253,'baseline','3.0'),_output_path,'272/lm/',_file_name,'.3gp');
		SET _versions_lm_270 = '272/lm';

	END IF;

	IF(SELECT FN_MAKE_THIS_RESOLUTION(_height,340) = 1)
	THEN

		SET _code_mp4__m__360 = CONCAT(' \\','\n  ',FN_GET_VIDEO_TRANSCODING_CODE('m',360,'libx264','aac','mp4',660,348,480,253,'baseline','3.0'),_output_path,'348/m/',_file_name,'.mp4');
		SET _versions__m_360 = '348/m';

	END IF;

	IF(SELECT FN_MAKE_THIS_RESOLUTION(_height,408) = 1)
	THEN

		SET _code_mp4__m__540 = CONCAT(' \\','\n  ',FN_GET_VIDEO_TRANSCODING_CODE('m',540,'libx264','aac','mp4',774,408,480,253,'baseline','3.0'),_output_path,'408/m/',_file_name,'.mp4');	
		SET _versions__m_540 = '408/m';

	END IF;

END IF;





IF(_mobile_version = 1) THEN




	IF(_seconds <= 300) 
	THEN
		SET _command_mp4__m = CONCAT_WS('',_command,_code_mp4__lm_144,_code_mp4__lm_270,_code_mp4__m__360,_code_mp4__m__540);
		SET _versions_m = CONCAT_WS(',',_versions_lm_144,_versions_lm_270,_versions__m_360,_versions__m_540);

		CALL SP_SET_VIDEO_TO_PROCESSED(_id_account,_account_token,_output_path_clean,_id_video,_source,_command_mp4__m,_versions_m,_h264,0,0,_width,_height,_seconds,_aspect_ratio,_id_storage,_id_cdn);

	END IF;




	IF(_seconds > 300) 
	THEN
		SET _command_mp4__m = CONCAT_WS('',_command,_code_mp4__lm_144,_code_mp4__lm_270);
		SET _versions_m = CONCAT_WS(',',_versions_lm_144,_versions_lm_270);

		CALL SP_SET_VIDEO_TO_PROCESSED(_id_account,_account_token,_output_path_clean,_id_video,_source,_command_mp4__m,_versions_m,_h264,0,0,_width,_height,_seconds,_aspect_ratio,_id_storage,_id_cdn);



		SET _command_mp4__m = CONCAT_WS('',_command,_code_mp4__m__360,_code_mp4__m__540);
		SET _versions_m = CONCAT_WS(',',_versions__m_360,_versions__m_540);

		CALL SP_SET_VIDEO_TO_PROCESSED(_id_account,_account_token,_output_path_clean,_id_video,_source,_command_mp4__m,_versions_m,_h264,0,0,_width,_height,_seconds,_aspect_ratio,_id_storage,_id_cdn);

	END IF;




END IF;




IF(_web_version = 1) THEN
	IF(SELECT FN_MAKE_THIS_RESOLUTION(_height,272) = 1)
	THEN
    
		SET _code_mp4__w__270 = CONCAT(' \\','\n  ',FN_GET_VIDEO_TRANSCODING_CODE('w',270,'libx264','aac','mp4',516,272,480,253,'main','3.1'),_output_path,'272/w/',_file_name,'.mp4');	
		SET _code_webm_w__270	= CONCAT(' \\','\n  ',FN_GET_VIDEO_TRANSCODING_CODE('w',270,'libvpx','libvorbis','webm',516,272,480,253,'',''),_output_path,'272/w/',_file_name,'.webm');	
		SET _code_ogg__w__270 = CONCAT(' \\','\n  ',FN_GET_VIDEO_TRANSCODING_CODE('w',270,'libtheora','libvorbis','ogg',516,272,480,253,'',''),_output_path,'272/w/',_file_name,'.ogg');	
		SET _versions__w_270 = '272/w';

	END IF;

	IF(SELECT FN_MAKE_THIS_RESOLUTION(_height,340) = 1)
	THEN

		SET _code_mp4__w__360 = CONCAT(' \\','\n  ',FN_GET_VIDEO_TRANSCODING_CODE('w',360,'libx264','aac','mp4',660,348,480,253,'main','3.1'),_output_path,'348/w/',_file_name,'.mp4');	
		SET _code_webm_w__360	= CONCAT(' \\','\n  ',FN_GET_VIDEO_TRANSCODING_CODE('w',360,'libvpx','libvorbis','webm',660,348,480,253,'',''),_output_path,'348/w/',_file_name,'.webm');	
		SET _code_ogg__w__360 = CONCAT(' \\','\n  ',FN_GET_VIDEO_TRANSCODING_CODE('w',360,'libtheora','libvorbis','ogg',660,348,480,253,'',''),_output_path,'348/w/',_file_name,'.ogg');	
		SET _versions__w_360 = '348/w';

	END IF;

	IF(SELECT FN_MAKE_THIS_RESOLUTION(_height,408) = 1)
	THEN

		SET _code_mp4__w__540 = CONCAT(' \\','\n  ',FN_GET_VIDEO_TRANSCODING_CODE('w',540,'libx264','aac','mp4',774,408,480,253,'main','3.1'),_output_path,'408/w/',_file_name,'.mp4');	
		SET _code_webm_w__540	= CONCAT(' \\','\n  ',FN_GET_VIDEO_TRANSCODING_CODE('w',540,'libvpx','libvorbis','webm',774,408,480,253,'',''),_output_path,'408/w/',_file_name,'.webm');	
		SET _code_ogg__w__540 = CONCAT(' \\','\n  ',FN_GET_VIDEO_TRANSCODING_CODE('w',540,'libtheora','libvorbis','ogg',774,408,480,253,'',''),_output_path,'408/w/',_file_name,'.ogg');	
		SET _versions__w_540 = '408/w';

	END IF;

	IF(SELECT FN_MAKE_THIS_RESOLUTION(_height,674) = 1)
	THEN

			SET _code_mp4__w__720 = CONCAT(' \\','\n  ',FN_GET_VIDEO_TRANSCODING_CODE('w',720,'libx264','aac','mp4',1280,674,480,253,'main','3.1'),_output_path,'674/w/',_file_name,'.mp4');	
			SET _code_webm_w__720	= CONCAT(' \\','\n  ',FN_GET_VIDEO_TRANSCODING_CODE('w',720,'libvpx','libvorbis','webm',1280,674,480,253,'',''),_output_path,'674/w/',_file_name,'.webm');	
			SET _code_ogg__w__720 = CONCAT(' \\','\n  ',FN_GET_VIDEO_TRANSCODING_CODE('w',720,'libtheora','libvorbis','ogg',1280,674,480,253,'',''),_output_path,'674/w/',_file_name,'.ogg');
			SET _versions__w_720 = '674/w';

	END IF;

	IF(SELECT FN_MAKE_THIS_RESOLUTION(_height,1012) = 1)
	THEN
			SET _code_mp4__w__1080 = CONCAT(' \\','\n  ',FN_GET_VIDEO_TRANSCODING_CODE('w',1080,'libx264','aac','mp4',1920,1012,480,253,'high','4.0'),_output_path,'1012/w/',_file_name,'.mp4');	
			SET _code_webm_w__1080 = CONCAT(' \\','\n  ',FN_GET_VIDEO_TRANSCODING_CODE('w',1080,'libvpx','libvorbis','webm',1920,1012,480,253,'',''),_output_path,'1012/w/',_file_name,'.webm');	
			SET _code_ogg__w__1080 = CONCAT(' \\','\n  ',FN_GET_VIDEO_TRANSCODING_CODE('w',1080,'libtheora','libvorbis','ogg',1920,1012,480,253,'',''),_output_path,'1012/w/',_file_name,'.ogg');
			SET _versions__w_1080 = '1012/w';
	END IF;

	

END IF;





IF(_web_version = 1) THEN




IF(_seconds <= 300) 
	THEN
		SET _command_mp4__w = CONCAT_WS('',_command,_code_mp4__w__270,_code_mp4__w__360,_code_mp4__w__540,_code_mp4__w__720,_code_mp4__w__1080);
		SET _command_webm_w = CONCAT_WS('',_command,_code_webm_w__270,_code_webm_w__360,_code_webm_w__540,_code_webm_w__720,_code_webm_w__1080);
		SET _command_ogg__w = CONCAT_WS('',_command,_code_ogg__w__270,_code_ogg__w__360,_code_ogg__w__540,_code_ogg__w__720,_code_ogg__w__1080);
		SET _versions_w = CONCAT_WS(',',_versions__w_270,_versions__w_360,_versions__w_540,_versions__w_720,_versions__w_1080);

		CALL SP_SET_VIDEO_TO_PROCESSED(_id_account,_account_token,_output_path_clean,_id_video,_source,_command_mp4__w,_versions_w,_h264,0,0,_width,_height,_seconds,_aspect_ratio,_id_storage,_id_cdn);
		CALL SP_SET_VIDEO_TO_PROCESSED(_id_account,_account_token,_output_path_clean,_id_video,_source,_command_webm_w,_versions_w,0,_webm,0,_width,_height,_seconds,_aspect_ratio,_id_storage,_id_cdn);
		CALL SP_SET_VIDEO_TO_PROCESSED(_id_account,_account_token,_output_path_clean,_id_video,_source,_command_ogg__w,_versions_w,0,0,_ogg,_width,_height,_seconds,_aspect_ratio,_id_storage,_id_cdn);

	END IF;




	IF(_seconds > 300 && _seconds <= 1200) 
	THEN
		SET _command_mp4__w = CONCAT_WS('',_command,_code_mp4__w__270,_code_mp4__w__360);
		SET _command_webm_w = CONCAT_WS('',_command,_code_webm_w__270,_code_webm_w__360);
		SET _command_ogg__w = CONCAT_WS('',_command,_code_ogg__w__270,_code_ogg__w__360);
		SET _versions_w = CONCAT_WS(',',_versions__w_270,_versions__w_360);

		CALL SP_SET_VIDEO_TO_PROCESSED(_id_account,_account_token,_output_path_clean,_id_video,_source,_command_mp4__w,_versions_w,_h264,0,0,_width,_height,_seconds,_aspect_ratio,_id_storage,_id_cdn);
		CALL SP_SET_VIDEO_TO_PROCESSED(_id_account,_account_token,_output_path_clean,_id_video,_source,_command_webm_w,_versions_w,0,_webm,0,_width,_height,_seconds,_aspect_ratio,_id_storage,_id_cdn);
		CALL SP_SET_VIDEO_TO_PROCESSED(_id_account,_account_token,_output_path_clean,_id_video,_source,_command_ogg__w,_versions_w,0,0,_ogg,_width,_height,_seconds,_aspect_ratio,_id_storage,_id_cdn);



		SET _command_mp4__w = CONCAT_WS('',_command,_code_mp4__w__540,_code_mp4__w__720,_code_mp4__w__1080);
		SET _command_webm_w = CONCAT_WS('',_command,_code_webm_w__540,_code_webm_w__720,_code_webm_w__1080);
		SET _command_ogg__w = CONCAT_WS('',_command,_code_ogg__w__540,_code_ogg__w__720,_code_ogg__w__1080);
		SET _versions_w = CONCAT_WS(',',_versions__w_540,_versions__w_720,_versions__w_1080);

		CALL SP_SET_VIDEO_TO_PROCESSED(_id_account,_account_token,_output_path_clean,_id_video,_source,_command_mp4__w,_versions_w,_h264,0,0,_width,_height,_seconds,_aspect_ratio,_id_storage,_id_cdn);
		CALL SP_SET_VIDEO_TO_PROCESSED(_id_account,_account_token,_output_path_clean,_id_video,_source,_command_webm_w,_versions_w,0,_webm,0,_width,_height,_seconds,_aspect_ratio,_id_storage,_id_cdn);
		CALL SP_SET_VIDEO_TO_PROCESSED(_id_account,_account_token,_output_path_clean,_id_video,_source,_command_ogg__w,_versions_w,0,0,_ogg,_width,_height,_seconds,_aspect_ratio,_id_storage,_id_cdn);

	END IF;


	IF(_seconds > 1200) 
	THEN
		SET _command_mp4__w = CONCAT_WS('',_command,_code_mp4__w__270);
		SET _command_webm_w = CONCAT_WS('',_command,_code_webm_w__270);
		SET _command_ogg__w = CONCAT_WS('',_command,_code_ogg__w__270);
		SET _versions_w = CONCAT_WS(',',_versions__w_270);

		CALL SP_SET_VIDEO_TO_PROCESSED(_id_account,_account_token,_output_path_clean,_id_video,_source,_command_mp4__w,_versions_w,_h264,0,0,_width,_height,_seconds,_aspect_ratio,_id_storage,_id_cdn);
		CALL SP_SET_VIDEO_TO_PROCESSED(_id_account,_account_token,_output_path_clean,_id_video,_source,_command_webm_w,_versions_w,0,_webm,0,_width,_height,_seconds,_aspect_ratio,_id_storage,_id_cdn);
		CALL SP_SET_VIDEO_TO_PROCESSED(_id_account,_account_token,_output_path_clean,_id_video,_source,_command_ogg__w,_versions_w,0,0,_ogg,_width,_height,_seconds,_aspect_ratio,_id_storage,_id_cdn);


		SET _command_mp4__w = CONCAT_WS('',_command,_code_mp4__w__360);
		SET _command_webm_w = CONCAT_WS('',_command,_code_webm_w__360);
		SET _command_ogg__w = CONCAT_WS('',_command,_code_ogg__w__360);
		SET _versions_w = CONCAT_WS(',',_versions__w_360);

		CALL SP_SET_VIDEO_TO_PROCESSED(_id_account,_account_token,_output_path_clean,_id_video,_source,_command_mp4__w,_versions_w,_h264,0,0,_width,_height,_seconds,_aspect_ratio,_id_storage,_id_cdn);
		CALL SP_SET_VIDEO_TO_PROCESSED(_id_account,_account_token,_output_path_clean,_id_video,_source,_command_webm_w,_versions_w,0,_webm,0,_width,_height,_seconds,_aspect_ratio,_id_storage,_id_cdn);
		CALL SP_SET_VIDEO_TO_PROCESSED(_id_account,_account_token,_output_path_clean,_id_video,_source,_command_ogg__w,_versions_w,0,0,_ogg,_width,_height,_seconds,_aspect_ratio,_id_storage,_id_cdn);


		SET _command_mp4__w = CONCAT_WS('',_command,_code_mp4__w__540);
		SET _command_webm_w = CONCAT_WS('',_command,_code_webm_w__540);
		SET _command_ogg__w = CONCAT_WS('',_command,_code_ogg__w__540);
		SET _versions_w = CONCAT_WS(',',_versions__w_540);

		CALL SP_SET_VIDEO_TO_PROCESSED(_id_account,_account_token,_output_path_clean,_id_video,_source,_command_mp4__w,_versions_w,_h264,0,0,_width,_height,_seconds,_aspect_ratio,_id_storage,_id_cdn);
		CALL SP_SET_VIDEO_TO_PROCESSED(_id_account,_account_token,_output_path_clean,_id_video,_source,_command_webm_w,_versions_w,0,_webm,0,_width,_height,_seconds,_aspect_ratio,_id_storage,_id_cdn);
		CALL SP_SET_VIDEO_TO_PROCESSED(_id_account,_account_token,_output_path_clean,_id_video,_source,_command_ogg__w,_versions_w,0,0,_ogg,_width,_height,_seconds,_aspect_ratio,_id_storage,_id_cdn);



		SET _command_mp4__w = CONCAT_WS('',_command,_code_mp4__w__720);
		SET _command_webm_w = CONCAT_WS('',_command,_code_webm_w__720);
		SET _command_ogg__w = CONCAT_WS('',_command,_code_ogg__w__720);
		SET _versions_w = CONCAT_WS(',',_versions__w_720);

		CALL SP_SET_VIDEO_TO_PROCESSED(_id_account,_account_token,_output_path_clean,_id_video,_source,_command_mp4__w,_versions_w,_h264,0,0,_width,_height,_seconds,_aspect_ratio,_id_storage,_id_cdn);
		CALL SP_SET_VIDEO_TO_PROCESSED(_id_account,_account_token,_output_path_clean,_id_video,_source,_command_webm_w,_versions_w,0,_webm,0,_width,_height,_seconds,_aspect_ratio,_id_storage,_id_cdn);
		CALL SP_SET_VIDEO_TO_PROCESSED(_id_account,_account_token,_output_path_clean,_id_video,_source,_command_ogg__w,_versions_w,0,0,_ogg,_width,_height,_seconds,_aspect_ratio,_id_storage,_id_cdn);


		SET _command_mp4__w = CONCAT_WS('',_command,_code_mp4__w__1080);
		SET _command_webm_w = CONCAT_WS('',_command,_code_webm_w__1080);
		SET _command_ogg__w = CONCAT_WS('',_command,_code_ogg__w__1080);
		SET _versions_w = CONCAT_WS(',',_versions__w_1080);

		CALL SP_SET_VIDEO_TO_PROCESSED(_id_account,_account_token,_output_path_clean,_id_video,_source,_command_mp4__w,_versions_w,_h264,0,0,_width,_height,_seconds,_aspect_ratio,_id_storage,_id_cdn);
		CALL SP_SET_VIDEO_TO_PROCESSED(_id_account,_account_token,_output_path_clean,_id_video,_source,_command_webm_w,_versions_w,0,_webm,0,_width,_height,_seconds,_aspect_ratio,_id_storage,_id_cdn);
		CALL SP_SET_VIDEO_TO_PROCESSED(_id_account,_account_token,_output_path_clean,_id_video,_source,_command_ogg__w,_versions_w,0,0,_ogg,_width,_height,_seconds,_aspect_ratio,_id_storage,_id_cdn);

	END IF;




END IF;

COMMIT;

END;

