<?php

namespace Skoiy\Mongo\TypeMaps;

use MongoDB\BSON\Unserializable;
use Illuminate\Contracts\Support\Arrayable;

class Sticker implements Unserializable, Arrayable
{
    use \Skoiy\Mongo\Traits\Unserializable;

    public function toArray(): array
    {
        return get_object_vars($this);
    }

    public function __get($key)
    {
        return isset($this->{$key}) ? $this->{$key} : null;
    }
}
