create
    definer = skoiypp@`%` procedure SP_SET_TASK_OIR(IN _id_account int(10), IN _account_token varchar(255),
                                                    IN _command varchar(255), IN _requester varchar(255))
BEGIN

    DECLARE _request text;

-- ###########################
    DECLARE exit handler for sqlexception
        BEGIN
            -- ERROR
            SELECT -1 as return_code;
            rollback;
        END;
-- ###########################

    START TRANSACTION;

    SET _request = CONCAT_WS("','","CALL SP_SET_TASK_OIR( ",_id_account,_account_token,_command,_requester,")");
    INSERT INTO oir_requests(id_account,account_token,request,register_date) VALUES(_id_account,_account_token,_request,now());

    INSERT into oir_queue(id_account,account_token,command,requester,register_date)
    VALUES(_id_account,_account_token,_command,_requester,now());

    INSERT into oir_history(id_account,account_token,command,requester,register_date)
    VALUES(_id_account,_account_token,_command,_requester,now());

    SELECT 0 as return_code;

    COMMIT;

END;

