create
    definer = skoiypp@`%` procedure SP_DEL_POSTS_DOSSIERS_FROM_COLLECTIONS(IN _id_collection int, IN _id_dossier int)
BEGIN

DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_collection FROM dossiers_collections_related WHERE id_collection = _id_collection AND id_dossier = _id_dossier)
THEN

	SELECT FN_SP_SET_PUBLISH_POSTS_SYNC_UPDATE(31,_id_dossier) into _empty;
        
    DELETE FROM dossiers_collections_related WHERE id_collection = _id_collection AND id_dossier = _id_dossier;
    UPDATE dossiers SET state = 2 WHERE id_dossier = _id_dossier AND FN_GET_POSTS_IS_DOSSIERS_ON_COLLECTION(_id_dossier) = 0;

    SET @rownum=0;
    UPDATE dossiers_collections_related p, (SELECT @rownum:=@rownum+1 rownum, dossiers_collections_related.* FROM dossiers_collections_related WHERE id_collection = _id_collection ORDER BY position,update_date desc) r 
    SET p.position = r.rownum
    WHERE (p.id_dossier = r.id_dossier);
    SELECT FN_SP_SET_PUBLISH_POSTS_SYNC_UPDATE(61,_id_collection) into _empty;

    SELECT 0 as return_code;    
ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

