create
    definer = skoiypp@`%` procedure SP_DEL_VIDEO_PLAYLISTS_FROM_CHANNELS(IN _id_channel int, IN _id_playlist int)
BEGIN

DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_channel FROM playlists_channels_related WHERE id_channel = _id_channel AND id_playlist = _id_playlist)
THEN

	SELECT FN_SP_SET_PUBLISH_VIDEO_SYNC_UPDATE(31,_id_playlist) into _empty;
        
    DELETE FROM playlists_channels_related WHERE id_channel = _id_channel AND id_playlist = _id_playlist;
    UPDATE playlists SET state = 2 WHERE id_playlist = _id_playlist AND FN_GET_VIDEO_IS_PLAYLISTS_ON_CHANNEL(_id_playlist) = 0;

    SET @rownum=0;
    UPDATE playlists_channels_related p, (SELECT @rownum:=@rownum+1 rownum, playlists_channels_related.* FROM playlists_channels_related WHERE id_channel = _id_channel ORDER BY position,update_date desc) r 
    SET p.position = r.rownum
    WHERE (p.id_playlist = r.id_playlist);
    SELECT FN_SP_SET_PUBLISH_VIDEO_SYNC_UPDATE(61,_id_channel) into _empty;

    SELECT 0 as return_code;    
ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

