create
    definer = skoiypp@`%` procedure SP_GET_ACCOUNT_APIS_new(IN _id_account int(10), IN _field int(10),
                                                            IN _query varchar(192), IN _filter varchar(192),
                                                            IN _order int(10), IN _order_by int(10),
                                                            IN _limit_a int(10), IN _limit_b int(10))
BEGIN


DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS(SELECT id_account FROM accounts WHERE id_account = _id_account)
THEN

IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM accounts_apis WHERE id_account = _id_account;
END IF;

SET @_api_key = CONCAT("%",_query,"%");
SET @_id_account = _id_account;
SET @_id_api = _filter;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = "SELECT id_api, aa.id_account, account_token, api_key,description, domains,aa.active, aa.public FROM accounts_apis aa, accounts a WHERE a.id_account = aa.id_account AND aa.id_account = @_id_account ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND api_key like @_api_key ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND aa.id_api = @_id_api ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

CASE
WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY api_key ASC");
WHEN _order_by = 11000 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY api_key DESC");

ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY api_key ASC");
END CASE;

SET sqlcommand = CONCAT(sqlcommand, " LIMIT ?,?");
SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;     

ELSE
  SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

