create
    definer = skoiypp@`%` procedure SP_GET_ADS_CAMPAIGNS(IN _field int(10), IN _field_snd int(10),
                                                         IN _field_trd int(10), IN _query varchar(192),
                                                         IN _filter varchar(192), IN _filter_snd varchar(192),
                                                         IN _filter_trd varchar(192), IN _limit_sys_a bigint,
                                                         IN _limit_sys_b bigint, IN _limit_a int, IN _limit_b int,
                                                         IN _order int(10), IN _order_by int(10))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;



START TRANSACTION;

IF(_limit_b = -1)
THEN
	SELECT count(1) into _limit_b FROM ads_campaigns;
END IF;

SET @_name = CONCAT("%",_query,"%");
SET @_cfilter = _filter;
SET @_filter = CONCAT("%",_filter,"%");

SET @_tags_stripped = CONCAT("%",_query,"%");
SET @_tags_group = CONCAT("%",_filter_trd,"%");
SET @id_campaign = _filter_snd;
SET @id_composed = _filter_snd;
SET @id_external_ad_tag = _filter_snd;
SET @id_ad = _filter_snd;
SET @code = _filter_snd;

SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;
SET @_limit_sys_a = _limit_sys_a;
SET @_limit_sys_b = _limit_sys_b;

SET @_year = year(_filter);
SET @_month = month(_filter);

	SET sqlcommand = "SELECT id_campaign,name,begin_date,end_date,state,register_date,FN_GET_ADS_CAMPAIGNS_HAS_ADS_VIDEOS(id_campaign) as has_ad_videos,FN_GET_ADS_CAMPAIGNS_HAS_EXTERNAL_AD_TAG(id_campaign) as has_external_tag FROM ads_campaigns ac WHERE 1=1 ";
	
	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_campaign = @id_campaign ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_campaign in (SELECT distinct id_campaign FROM ads_campaigns_video_composed_related WHERE id_composed = @id_composed) ");			
			WHEN _field_snd = 102 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_campaign in (SELECT distinct id_campaign FROM ads_campaigns_groups WHERE id_campaign_group in (SELECT id_campaign_group FROM ads_campaigns_groups_external_ad_tags)) ");
			WHEN _field_snd = 103 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_campaign in (SELECT distinct id_campaign FROM ads_campaigns_groups WHERE id_campaign_group in (SELECT id_campaign_group FROM ads_campaigns_groups_external_ad_tags WHERE id_external_ad_tag = @id_external_ad_tag)) ");
			WHEN _field_snd = 104 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_campaign in (SELECT distinct id_campaign FROM ads_campaigns_groups WHERE id_campaign_group in (SELECT id_campaign_group FROM ads_campaigns_groups_ads_videos)) ");
			WHEN _field_snd = 105 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_campaign in (SELECT distinct id_campaign FROM ads_campaigns_groups WHERE id_campaign_group in (SELECT id_campaign_group FROM ads_campaigns_groups_ads_videos WHERE id_ad = @id_ad))  ");
			WHEN _field_snd = 106 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_campaign in (SELECT distinct id_campaign FROM ads_campaigns_video_composed_related) ");			

			WHEN _field_snd = 107 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_campaign in (SELECT distinct id_campaign FROM ads_campaigns_codes) ");
			WHEN _field_snd = 108 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_campaign in (SELECT distinct id_campaign FROM ads_campaigns_codes WHERE code = @code) ");

		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;

	IF (_field_trd = 1000)
	THEN
		SET sqlcommand =  CONCAT(sqlcommand, " AND (SELECT FN_GET_ADS_CAMPAIGNS_TAGS_GROUPED(id_campaign) like @_tags_group ) ");
	END IF;

	CASE
	WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (name like @_name OR ((SELECT count(1) FROM ads_tags at, ads_campaigns_tags_related actr WHERE at.id_tag = actr.id_tag AND actr.id_campaign = ac.id_campaign AND name_stripped like @_tags_stripped) > 0)) ");
	WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND name like @_name ");
	WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = @_year AND month(register_date) = @_month) AND (name like @_name ) ");
	WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = @_year) AND (name like @_name) ");
	WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (state = @_cfilter) AND (name like @_name) ");
	WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (state <> @_cfilter) AND (name like @_name) ");
	ELSE SET sqlcommand = CONCAT(sqlcommand, " ");
	END CASE;

CASE

WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name ASC");
WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY ac.register_date ASC");
WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY ac.begin_date ASC");
WHEN _order_by = 11003 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY ac.end_date ASC");

WHEN _order_by = 10000 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name DESC");
WHEN _order_by = 10001 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY ac.register_date DESC");
WHEN _order_by = 10002 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY ac.begin_date DESC");
WHEN _order_by = 10003 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY ac.end_date DESC");

ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY ac.register_date DESC");
END CASE;


 SET sqlcommand = CONCAT(sqlcommand," LIMIT ?,?");

SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b; 
      
COMMIT;

END;

