create
    definer = skoiypp@`%` procedure SP_GET_ARCHIVE_CLIP(IN _field int(10), IN _query varchar(192))
BEGIN


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_field = 0)
THEN
	IF EXISTS(SELECT id_clip FROM archive_clips WHERE id_clip = _query AND deleted = 0)
	THEN 
		SELECT id_clip,id_directory,id_storage,id_cdn,id_video,name,filename,seconds,extension,mime_type,size,codec,bitrate,audio_bitrate,audio_codec,framerate,framecount,width,height,ratio,state,register_date,FN_GET_ARCHIVE_CLIP_HAS_RELATED(id_video) as has_related_clips, FN_GET_ARCHIVE_CLIP_IN_TRANSFER(id_clip) as in_transfer,FN_GET_ARCHIVE_CLIP_HAS_PREVIEW(id_clip) has_preview,FN_GET_ARCHIVE_CLIP_THUMBNAIL(id_clip) as thumbnail FROM archive_clips WHERE id_clip = _query AND deleted = 0;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;

IF(_field = 1)
THEN
	IF EXISTS(SELECT id_clip FROM archive_clips WHERE filename = _query AND deleted = 0)
	THEN 
		SELECT id_clip,id_directory,id_storage,id_cdn,id_video,name,filename,seconds,extension,mime_type,size,codec,bitrate,audio_bitrate,audio_codec,framerate,framecount,width,height,ratio,state,register_date,FN_GET_ARCHIVE_CLIP_HAS_RELATED(id_video) as has_related_clips, FN_GET_ARCHIVE_CLIP_IN_TRANSFER(id_clip) as in_transfer,FN_GET_ARCHIVE_CLIP_HAS_PREVIEW(id_clip) has_preview,FN_GET_ARCHIVE_CLIP_THUMBNAIL(id_clip) as thumbnail FROM archive_clips WHERE filename = _query AND deleted = 0;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;
        
COMMIT;

END;

