create
    definer = skoiypp@`%` procedure SP_GET_ARCHIVE_CLIPS_TAGS_RELATED(IN _id_clip int, IN _id_directory int,
                                                                      IN _field int(10), IN _field_snd int(10),
                                                                      IN _field_trd int(10), IN _query varchar(192),
                                                                      IN _filter varchar(192),
                                                                      IN _filter_snd varchar(192),
                                                                      IN _filter_trd varchar(192),
                                                                      IN _limit_sys_a bigint, IN _limit_sys_b bigint)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_id_clip = _id_clip;
SET @_id_video = @_filter_snd;
SET @_name = CONCAT("%",_query,"%");
SET @_cfilter = _filter;
SET @_cfilter_snd = _field_snd;
SET @_filter = CONCAT("%",_filter,"%");

SET @_limit_sys_a = _limit_sys_a;
SET @_limit_sys_b = _limit_sys_b;
SET @_id_directory = _id_directory;

IF(_id_clip < 1)
THEN

	SET sqlcommand = "SELECT vt.id_tag,vt.name,name_stripped, public, (SELECT count(1) FROM archive_clips_tags_related actr_sub WHERE id_tag = vt.id_tag AND actr_sub.id_clip in (SELECT id_clip FROM archive_clips ac WHERE ac.deleted = 0  ";

	IF (_id_directory > 0)
		THEN
		   SET sqlcommand = CONCAT(sqlcommand," AND ac.id_directory = @_id_directory ");
		END IF;

		IF (_field_snd > 0)
		THEN
			CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (ac.id_video = @_id_video ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (ac.id_clip = @_id_clip ) ");
			WHEN _field_snd = 102 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (ac.id_video = (SELECT id_video FROM archive_clips WHERE id_clip = @_id_clip ) ) ");
			WHEN _field_snd = 103 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (ac.id_clip in (SELECT distinct id_clip FROM archive_transfers_clips_related) ) ");
			ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
			END CASE;
		END IF;


	CASE
	WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND ac.name like @_name ");
	WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (ac.state = @_cfilter) AND (ac.name like @_name) ");
	WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (ac.height like @_filter) AND (ac.name like @_name) ");
	WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (ac.ratio like @_filter) AND (ac.name like @_name) ");
	WHEN _field = 7 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (ac.mime_type like @_filter) AND (ac.name like @_name) ");
	WHEN _field = 8 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (ac.size BETWEEN @_limit_sys_a AND @_limit_sys_b) AND (ac.name like @_name ) ");
	WHEN _field = 9 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (ac.seconds BETWEEN @_limit_sys_a AND @_limit_sys_b) AND (ac.name like @_name ) ");
	WHEN _field = 10 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (ac.bitrate BETWEEN @_limit_sys_a AND @_limit_sys_b) AND (ac.name like @_name ) ");
	ELSE SET sqlcommand = CONCAT(sqlcommand, " ");
	END CASE;

	SET sqlcommand = CONCAT(sqlcommand," )) as total_clips FROM archive_clips_tags_related actr, archive_tags vt, archive_clips ac2 WHERE vt.id_tag = actr.id_tag AND ac2.id_clip = actr.id_clip AND ac2.deleted = 0 GROUP BY id_tag ORDER by name ");



	SET @sqlcommand = sqlcommand;
	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt;
ELSE
	IF EXISTS(SELECT id_clip FROM archive_clips_tags_related WHERE id_clip = _id_clip)
	THEN
		SELECT vt.id_tag,vt.name,name_stripped, public, (SELECT count(1) FROM archive_clips_tags_related WHERE id_tag = vt.id_tag) as total_clips FROM archive_clips_tags_related vvtr, archive_tags vt, archive_clips ac WHERE vt.id_tag = vvtr.id_tag AND ac.id_clip = vvtr.id_clip AND ac.deleted = 0 AND vvtr.id_clip = _id_clip;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;
        
COMMIT;

END;

