create
    definer = skoiypp@`%` procedure SP_GET_ARCHIVE_PROJECTS_COUNT(IN _field int(10), IN _query varchar(192), IN _filter varchar(192))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;


SET @_query = CONCAT("%",_query,"%");
SET @_cfilter = _filter;

SET sqlcommand = "SELECT count(1) as total FROM archive_projects "; 

CASE
WHEN _field = 1 THEN SET sqlcommand = CONCAT(sqlcommand," WHERE (name like ? or code like ? ) ");
WHEN _field = 2 THEN SET sqlcommand = CONCAT(sqlcommand," WHERE (name like ? ) ");
WHEN _field = 3 THEN SET sqlcommand = CONCAT(sqlcommand," WHERE (code like ? ) ");
WHEN _field = 4 THEN SET sqlcommand = CONCAT(sqlcommand," WHERE (active = ? ) ");
WHEN _field = 5 THEN SET sqlcommand = CONCAT(sqlcommand, " WHERE (id_project in (SELECT id_project FROM archive_projects_videos_related WHERE id_video = ? )) ");
WHEN _field = 6 THEN SET sqlcommand = CONCAT(sqlcommand, " WHERE (id_project in (SELECT id_project FROM archive_projects_clips_related WHERE id_clip = ? )) ");

ELSE SET sqlcommand = CONCAT(sqlcommand, " ");
END CASE;

SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
 
CASE
WHEN _field = 1 THEN
EXECUTE stmt USING @_query,@_query;
WHEN _field = 2 THEN
EXECUTE stmt USING @_query;
WHEN _field = 3 THEN
EXECUTE stmt USING @_query;
WHEN _field = 4 THEN
EXECUTE stmt USING @_cfilter;
WHEN _field = 5 THEN
EXECUTE stmt USING @_cfilter;
WHEN _field = 6 THEN
EXECUTE stmt USING @_cfilter;
ELSE 
EXECUTE stmt;    
END CASE;    
        
COMMIT;

END;

