create
    definer = skoiypp@`%` procedure SP_GET_ARCHIVE_TRANSFERS(IN _field int(10), IN _query varchar(192),
                                                             IN _filter varchar(192), IN _limit_a int, IN _limit_b int)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM archive_transfers;
END IF;

SET @_query = CONCAT("%",_query,"%");
SET @_cfilter = _filter;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = "SELECT id_transfer, name, code, password, end_date,active,FN_GET_ARCHIVE_NUM_ON_TRANSFERS(id_transfer) as total_content, create_xml, register_date,
	FN_GET_ARCHIVE_LAST_FILENAME_ON_TRANSFER(id_transfer) as filename, 
	FN_GET_ARCHIVE_LAST_SECONDS_ON_TRANSFER(id_transfer) as seconds, FN_GET_ARCHIVE_LAST_TYPE_ON_TRANSFER(id_transfer) as is_clip 
	FROM archive_transfers "; 

CASE
WHEN _field = 1 THEN SET sqlcommand = CONCAT(sqlcommand," WHERE (name like ? or code like ? ) ");
WHEN _field = 2 THEN SET sqlcommand = CONCAT(sqlcommand," WHERE (name like ? ) ");
WHEN _field = 3 THEN SET sqlcommand = CONCAT(sqlcommand," WHERE (code like ? ) ");
WHEN _field = 4 THEN SET sqlcommand = CONCAT(sqlcommand," WHERE (active = ? ) ");
WHEN _field = 5 THEN SET sqlcommand = CONCAT(sqlcommand, " WHERE (id_transfer in (SELECT id_transfer FROM archive_transfers_videos_related WHERE id_video = ? )) ");
WHEN _field = 6 THEN SET sqlcommand = CONCAT(sqlcommand, " WHERE (id_transfer in (SELECT id_transfer FROM archive_transfers_clips_related WHERE id_clip = ? )) ");

ELSE SET sqlcommand = CONCAT(sqlcommand, " ");
END CASE;

SET sqlcommand = CONCAT(sqlcommand," ORDER BY name LIMIT ?,?");
SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
 
CASE
WHEN _field = 1 THEN
EXECUTE stmt USING @_query,@_query,@_limit_a,@_limit_b;
WHEN _field = 2 THEN
EXECUTE stmt USING @_query,@_limit_a,@_limit_b;
WHEN _field = 3 THEN
EXECUTE stmt USING @_query,@_limit_a,@_limit_b;
WHEN _field = 4 THEN
EXECUTE stmt USING @_cfilter,@_limit_a,@_limit_b;
WHEN _field = 5 THEN
EXECUTE stmt USING @_cfilter,@_limit_a,@_limit_b;
WHEN _field = 6 THEN
EXECUTE stmt USING @_cfilter,@_limit_a,@_limit_b;
ELSE 
EXECUTE stmt USING @_limit_a,@_limit_b;    
END CASE;    
        
COMMIT;

END;

