create
    definer = skoiypp@`%` procedure SP_GET_ARCHIVE_VIDEOS_COUNT(IN _room varchar(5), IN _id_user int(10),
                                                                IN _id_directory int, IN _field int(10),
                                                                IN _field_snd int(10), IN _field_trd int(10),
                                                                IN _query varchar(192), IN _filter varchar(192),
                                                                IN _filter_snd varchar(192),
                                                                IN _filter_trd varchar(192), IN _limit_sys_a bigint,
                                                                IN _limit_sys_b bigint)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;



START TRANSACTION;

SET @room = _room;
SET @id_user = _id_user;

SET @_name = CONCAT("%",_query,"%");
SET @_cfilter = _filter;
SET @_filter = CONCAT("%",_filter,"%");
SET @_filename = CONCAT("%",_filter_snd,"%");

SET @_tags_stripped = CONCAT("%",_query,"%");

SET @_tags_group = REPLACE(_filter_trd,'%','');

SET @id_video = _filter_snd;
SET @_room = _filter_snd;

SET @_limit_sys_a = _limit_sys_a;
SET @_limit_sys_b = _limit_sys_b;
SET @_id_directory = _id_directory;

SET @_year = year(_filter);
SET @_month = month(_filter);


IF(_id_directory = -1)
THEN
	SET sqlcommand = "SELECT count(1) as total FROM archive_videos v WHERE id_directory is null AND deleted = 0 ";
	IF (_room <> '')
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," AND FN_GET_ARCHIVE_VIDEO_IN_ROOM(id_video,@id_user,@room) = 1 ");
	END IF;

	SET @sqlcommand = sqlcommand;
	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt;
ELSE

	IF (_id_directory = 0) OR (SELECT count(1) FROM archive_videos_directories WHERE id_directory = _id_directory)
	THEN

	SET sqlcommand = "SELECT count(1) as total FROM archive_videos v WHERE deleted = 0 ";
	
	IF (_room <> '')
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," AND FN_GET_ARCHIVE_VIDEO_IN_ROOM(id_video,@id_user,@room) = 1 ");
	END IF;

	IF (_id_directory > 0 AND _field <> 14)
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," AND id_directory = @_id_directory ");
	END IF;
	IF (_field = 14)
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," AND 0=1 ");
	END IF;

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_video = @id_video ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_video in (SELECT distinct id_video FROM archive_clips) ) ");
			WHEN _field_snd = 102 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_video in (SELECT distinct id_video FROM archive_transfers_videos_related) ) ");
			WHEN _field_snd = 103 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_video in (SELECT distinct id_video FROM archive_videos_segment_tags_related) ) ");
			WHEN _field_snd = 104 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_video in (SELECT distinct id_video FROM archive_rooms_related) ) ");
			WHEN _field_snd = 105 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_video in (SELECT distinct id_video FROM archive_rooms_related AND room = @_room) ) ");			
			WHEN _field_snd = 106 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND filename like @_filename ");
		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;

	IF (_field_trd = 1000)
	THEN
		SET sqlcommand =  CONCAT(sqlcommand, " AND id_video in (SELECT id_video FROM archive_videos_tags_related WHERE FIND_IN_SET(id_tag,@_tags_group) ) ");  
	END IF;

	CASE
	WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (name like @_name OR ((SELECT count(1) FROM archive_tags vt, archive_videos_tags_related vvtr WHERE vt.id_tag = vvtr.id_tag AND vvtr.id_video = v.id_video AND name_stripped like @_tags_stripped) > 0)) ");
	WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND name like @_name ");
	WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = @_year AND month(register_date) = @_month) AND (name like @_name ) ");
	WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = @_year) AND (name like @_name) ");
	WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (state = @_cfilter) AND (name like @_name) ");
	WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (height like @_filter) AND (name like @_name) ");
	WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (ratio like @_filter) AND (name like @_name) ");
	WHEN _field = 7 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (mime_type like @_filter) AND (name like @_name) ");
	WHEN _field = 8 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (size BETWEEN @_limit_sys_a AND @_limit_sys_b) AND (name like @_name ) ");
	WHEN _field = 9 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (seconds BETWEEN @_limit_sys_a AND @_limit_sys_b) AND (name like @_name ) ");
	WHEN _field = 10 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (bitrate BETWEEN @_limit_sys_a AND @_limit_sys_b) AND (name like @_name ) ");

	WHEN _field = 11 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = @_year AND month(register_date) = @_month) AND day(register_date) = @_day) ");
	WHEN _field = 12 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = @_year AND month(register_date) = @_month) ");
	WHEN _field = 13 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(register_date) = @_year) ");

	ELSE SET sqlcommand = CONCAT(sqlcommand, " ");
	END CASE;

	SET @sqlcommand = sqlcommand;

	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt;
		
	ELSE
	    SELECT -2 as return_code;
	END IF;
END IF;        
COMMIT;

END;

