create
    definer = skoiypp@`%` procedure SP_GET_LIVE_STICKERS(IN _field int(10), IN _query varchar(192),
                                                         IN _filter varchar(192), IN _limit_a int, IN _limit_b int)
BEGIN

DECLARE sqlcommand text; 


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM video_stickers;
END IF;

SET @_name = CONCAT("%",_query,"%");
SET @_id_sticker = _filter;
SET @_id_composed = _filter;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = "SELECT id_sticker, name,name_stripped,FN_GET_VIDEO_STICKERS_TOTAL_ITEMS(id_sticker) as total_video,FN_GET_LIVE_STICKERS_TOTAL_ITEMS(id_sticker) as total_live, 0 as position FROM video_stickers pt ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE name like @_name ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_sticker like @_id_sticker ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_sticker in (SELECT id_sticker FROM video_stickers_related WHERE id_composed = @_id_composed) ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name LIMIT ?,?");
SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;    
        
COMMIT;

END;

