create
    definer = skoiypp@`%` procedure SP_GET_POSTS_DOSSIERS_ON_COLLECTION(IN _id_collection int(10), IN _field int(10),
                                                                        IN _query varchar(192), IN _filter varchar(192),
                                                                        IN _limit_a int(10), IN _limit_b int(10),
                                                                        IN _order int(10), IN _order_by int(10))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
  SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_id_collection = _id_collection;

IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM dossiers WHERE id_dossier in (SELECT id_dossier FROM dossiers_collections_related WHERE id_collection = @_id_collection);
END IF;

SET @_name = CONCAT("%",_query,"%");
SET @_id_dossier = _filter;
SET @_state = _filter;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;
    
    SET sqlcommand = "SELECT pcr.id_collection, pcr.id_dossier, p.management_name, p.publish_date,p.begin_date, p.end_date,pcr.position,FN_GET_POSTS_ON_DOSSIERS_NUM(pcr.id_dossier) as total,FN_GET_POSTS_IS_DOSSIERS_ON_COLLECTION(pcr.id_dossier) as on_collection, state,p.register_date,FN_GET_POSTS_L10N_ISO_GROUPED(2,pcr.id_dossier) as iso_grouped
	FROM dossiers_collections_related pcr, dossiers p WHERE p.id_dossier = pcr.id_dossier AND pcr.id_collection = @_id_collection ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND management_name like @_name ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND state = @_state AND management_name like @_name ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND FN_GET_POSTS_IS_DOSSIERS_ON_COLLECTION(pcr.id_dossier) = 1 AND management_name like @_name ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND FN_GET_POSTS_IS_DOSSIERS_ON_COLLECTION(pcr.id_dossier) = 0 AND management_name like @_name ");

WHEN _field = 11 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND pcr.id_dossier like @_id_dossier ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;


CASE
WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY management_name ASC");
WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY pcr.register_date ASC");
WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY total ASC");
WHEN _order_by = 11003 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY pcr.position ASC");

WHEN _order_by = 10000 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY management_name DESC");
WHEN _order_by = 10001 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY pcr.register_date DESC");
WHEN _order_by = 10002 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY pcr.total DESC");
WHEN _order_by = 10003 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY pcr.position ASC");

ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY pcr.position ASC");
END CASE;

SET sqlcommand = CONCAT(sqlcommand, " LIMIT ?,?");
SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;  
    
COMMIT;

END;

