create
    definer = skoiypp@`%` procedure SP_GET_POSTS_L10N_AUTHORS(IN _id_l10n INT)
BEGIN

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF EXISTS(SELECT id_l10n FROM posts_l10n WHERE id_l10n = _id_l10n)
THEN
	SELECT distinct id_l10n,pa.id_author,pa.id_author_l10n,public,name,email,iso_language,FN_GET_POSTS_L10N_ISO_GROUPED(4,pa.id_author) as iso_grouped,role,description,biography,image,'' as id_asset,'' as meta_id_asset,image_title,image_alter_text,meta_title,meta_description,meta_image,meta_url,meta_keywords,FN_GET_POSTS_AUTHORS_TOTAL_POSTS(pa.id_author) as total,pla.register_date FROM posts_authors_l10n pa, posts_l10n_authors pla
	WHERE pa.id_author = pla.id_author AND pla.id_l10n = _id_l10n GROUP by pa.id_author;
ELSE
    SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

