create
    definer = skoiypp@`%` procedure SP_GET_POSTS_ON_DOSSIERS(IN _id_dossier int(10), IN _field int(10),
                                                             IN _field_snd int(10), IN _field_trd int(10),
                                                             IN _query varchar(192), IN _filter varchar(192),
                                                             IN _filter_snd varchar(192), IN _filter_trd varchar(192),
                                                             IN _order int(10), IN _order_by int(10),
                                                             IN _limit_a int(10), IN _limit_b int(10))
BEGIN

DECLARE sqlcommand text;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF(_limit_b = -1)
THEN
	SELECT count(1) into _limit_b FROM posts_dossiers_related WHERE id_dossier = _id_dossier;
	SET @_limit_b = _limit_b;
END IF;

SET @_id_dossier = _id_dossier;
SET @_title = CONCAT("%",_query,"%");
SET @_description = CONCAT("%",_query,"%");
SET @_tags_stripped = CONCAT("%",_query,"%");

SET @_filename = CONCAT("%",_filter_snd,"%");
SET @id_album = _filter_snd;
SET @id_asset = _filter_snd;
SET @id_composed = _filter_snd;
SET @id_author = _filter_snd;
SET @id_post = _filter_snd;
SET @id_dossier = _filter_snd;
SET @state = _filter_snd;
SET @label = _filter_snd;
SET @id_label = _filter_snd;
SET @id_tag = _filter_snd;
SET @id_sticker = _filter_snd;

SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = " SELECT id_l10n,p.id_post,pln.draft,iso_language,FN_GET_POSTS_L10N_ISO_GROUPED(1,pln.id_post) as iso_grouped,FN_GET_POSTS_TAGS_GROUPED(pln.id_l10n,2) as tags_grouped,headline,title,description,image,image_align,'' as image_width, '' as image_height,0 as id_asset,0 as meta_id_asset,meta_url,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,meta_play_mark,color,publish_date,begin_date,end_date,pdr.position, 
p.register_date, state FROM posts p, posts_dossiers_related pdr, posts_l10n pln
 WHERE p.id_post = pdr.id_post AND pln.id_post = p.id_post AND pdr.id_dossier = @_id_dossier ";

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (p.id_post = @id_post ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_authors WHERE id_author = @id_author) ) ");
			WHEN _field_snd = 102 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_videos WHERE id_composed = @id_composed) ) ");
			WHEN _field_snd = 103 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND ((id_l10n in (SELECT id_l10n FROM posts_l10n_photos WHERE id_asset = @id_asset) ) OR (FN_GET_ASSETS_ID_BY_FILENAME(image) = @id_asset))");
			WHEN _field_snd = 104 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_albums WHERE id_album = @id_album) ) ");						
			WHEN _field_snd = 105 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (p.id_post in (SELECT id_post FROM posts_dossiers_related WHERE id_dossier = @id_dossier) ) ");
			WHEN _field_snd = 106 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND ((id_l10n in (SELECT id_l10n FROM posts_l10n_photos WHERE id_asset in (SELECT id_asset FROM assets WHERE filename like @_filename))) OR (image like @_filename))");
			WHEN _field_snd = 107 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_tags_related WHERE id_tag = @id_tag) ) ");
			WHEN _field_snd = 108 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_labels_related WHERE id_label = @id_label) ) ");

			WHEN _field_snd = 109 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_authors)) ");
			WHEN _field_snd = 110 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_videos)) ");
			WHEN _field_snd = 111 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_photos)) ");
			WHEN _field_snd = 112 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_albums)) ");						
			WHEN _field_snd = 113 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_tags_related)) ");						
			WHEN _field_snd = 114 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM posts_l10n_labels_related) ) ");
			WHEN _field_snd = 115 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (p.id_post in (SELECT id_post FROM posts_dossiers_related)) ");
			WHEN _field_snd = 117 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (p.id_post in (SELECT id_post FROM posts_stickers_related WHERE id_sticker = @id_sticker) ) ");
			WHEN _field_snd = 118 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (p.id_post in (SELECT id_post FROM posts_stickers_related)) ");

			WHEN _field_snd = 209 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n not in (SELECT id_l10n FROM posts_l10n_authors)) ");
			WHEN _field_snd = 210 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n not in (SELECT id_l10n FROM posts_l10n_videos)) ");
			WHEN _field_snd = 211 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n not in (SELECT id_l10n FROM posts_l10n_photos)) ");
			WHEN _field_snd = 212 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n not in (SELECT id_l10n FROM posts_l10n_albums)) ");						
			WHEN _field_snd = 213 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n not in (SELECT id_l10n FROM posts_l10n_tags_related)) ");						
			WHEN _field_snd = 214 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n not in (SELECT id_l10n FROM posts_l10n_labels_related) ) ");
			WHEN _field_snd = 215 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (p.id_post not in (SELECT id_post FROM posts_dossiers_related)) ");
			WHEN _field_snd = 216 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (p.id_post not in (SELECT id_post FROM posts_stickers_related)) ");

			WHEN _field_snd = 116 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (state = @state ) ");

		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;


CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (title like @_title OR description like @_description OR ((SELECT count(1) FROM posts_tags pt, posts_l10n_tags_related ptr WHERE pt.id_tag = ptr.id_tag AND ptr.id_l10n = pln.id_l10n AND name_stripped like @_tags_stripped) > 0)) ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND title like @_title ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND description like @_description ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND ((SELECT count(1) FROM posts_tags pt, posts_l10n_tags_related ptr WHERE pt.id_tag = ptr.id_tag AND ptr.id_l10n = pln.id_l10n AND name_stripped like @_tags_stripped) > 0) ");

ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
END CASE;

CASE
WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " GROUP BY p.id_post ORDER BY title ASC");
WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " GROUP BY p.id_post ORDER BY p.register_date ASC");
WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " GROUP BY p.id_post ORDER BY publish_date ASC");
WHEN _order_by = 11003 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " GROUP BY p.id_post ORDER BY pdr.position ASC");

WHEN _order_by = 11000 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " GROUP BY p.id_post ORDER BY title DESC");
WHEN _order_by = 11001 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " GROUP BY p.id_post ORDER BY p.register_date DESC");
WHEN _order_by = 11002 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " GROUP BY p.id_post ORDER BY publish_date DESC");
WHEN _order_by = 11003 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " GROUP BY p.id_post ORDER BY pdr.position DESC");

ELSE SET sqlcommand = CONCAT(sqlcommand, " GROUP BY p.id_post ORDER BY pdr.position ASC");
END CASE;

 SET sqlcommand = CONCAT(sqlcommand," LIMIT ?,?");

SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;  

COMMIT;

END;

