create
    definer = skoiypp@`%` procedure SP_GET_POSTS_ON_DOSSIERS(IN _id_dossier int(10), IN _field int(10),
                                                             IN _query varchar(192), IN _order int(10),
                                                             IN _order_by int(10), IN _limit_a int(10),
                                                             IN _limit_b int(10))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
	SELECT count(1) into _limit_b FROM posts_dossiers_related WHERE id_dossier = _id_dossier;
	SET @_limit_b = _limit_b;
END IF;

SET @_id_dossier = _id_dossier;
SET @_title = CONCAT("%",_query,"%");
SET @_description = CONCAT("%",_query,"%");
SET @_tags_stripped = CONCAT("%",_query,"%");
SET @_state = _query;
SET @_post = _query;

SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = " SELECT id_l10n,p.id_post,iso_language,FN_GET_POSTS_L10N_ISO_GROUPED(1,pln.id_post) as iso_grouped,FN_GET_POSTS_TAGS_GROUPED(pln.id_l10n,2) as tags_grouped,headline,title,description,image,image_align,'' as image_width, '' as image_height,0 as id_asset,0 as meta_id_asset,meta_url,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,meta_play_mark,color,publish_date,begin_date,end_date,pdr.position, 
p.register_date, state FROM posts p, posts_dossiers_related pdr, posts_l10n pln
 WHERE p.id_post = pdr.id_post AND pln.id_post = p.id_post AND pdr.id_dossier = @_id_dossier ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (title like @_title OR description like @_description OR ((SELECT count(1) FROM posts_tags pt, posts_l10n_tags_related ptr WHERE pt.id_tag = ptr.id_tag AND ptr.id_l10n = pln.id_l10n AND name_stripped like @_tags_stripped) > 0)) ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND title like @_title ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND description like @_description ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND ((SELECT count(1) FROM posts_tags pt, posts_l10n_tags_related ptr WHERE pt.id_tag = ptr.id_tag AND ptr.id_l10n = pln.id_l10n AND name_stripped like @_tags_stripped) > 0) ");
WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND state = @_state ");
WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND p.post = @_post ");
ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
END CASE;

CASE
WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " GROUP BY p.id_post ORDER BY title ASC");
WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " GROUP BY p.id_post ORDER BY p.register_date ASC");
WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " GROUP BY p.id_post ORDER BY publish_date ASC");
WHEN _order_by = 11003 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " GROUP BY p.id_post ORDER BY pdr.position ASC");

WHEN _order_by = 11000 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " GROUP BY p.id_post ORDER BY title DESC");
WHEN _order_by = 11001 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " GROUP BY p.id_post ORDER BY p.register_date DESC");
WHEN _order_by = 11002 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " GROUP BY p.id_post ORDER BY publish_date DESC");
WHEN _order_by = 11003 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " GROUP BY p.id_post ORDER BY pdr.position DESC");

ELSE SET sqlcommand = CONCAT(sqlcommand, " GROUP BY p.id_post ORDER BY pdr.position ASC");
END CASE;

 SET sqlcommand = CONCAT(sqlcommand," LIMIT ?,?");

SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;  

COMMIT;

END;

