create
    definer = skoiypp@`%` procedure SP_GET_POSTS_STICKERS(IN _field int(10), IN _id_group int(10),
                                                          IN _query varchar(192), IN _filter varchar(192),
                                                          IN _limit_a int(10), IN _limit_b int(10), IN _order int(10),
                                                          IN _order_by int(10))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM posts_stickers;
END IF;

SET @_name = CONCAT("%",_query,"%");
SET @_id_group = _id_group;
SET @_id_sticker = _filter;
SET @_id_type = _filter;
SET @_token = _filter;
SET @_id_asset = _filter;
SET @_id_post = _filter;
SET @_num_x = _filter;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = "SELECT id_sticker,id_group,(SELECT name FROM posts_stickers_groups  psg WHERE psg.id_group = ps.id_group) as group_name,(SELECT sticker_type FROM posts_stickers_groups  psg WHERE psg.id_group = ps.id_group) as sticker_type,id_type,position, name,name_stripped,token,image,image_align,maximum_items,number_of_rows,display_in,id_format, '' as format,'' as variant,link,auto_feed_enabled,auto_feed_source_type,auto_feed_sort,FN_GET_POSTS_STICKERS_AUTOFEED_SORT_SLUG(id_sticker) auto_feed_sort_slug,color,active,active as state,FN_GET_POSTS_STICKERS_TOTAL_ITEMS(id_sticker) as total,'' as id_asset,'' as image_width,'' as image_height,register_date FROM posts_stickers ps WHERE 1=1 ";

CASE 
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND name like @_name ");
WHEN _field = 11 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_sticker like @_id_sticker AND name like @_name ");
WHEN _field = 12 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND token like @_token AND name like @_name ");
WHEN _field = 13 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_type = @_id_type AND name like @_name ");
WHEN _field = 23 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (FN_GET_ASSETS_ID_BY_FILENAME(image) = @_id_asset) AND name like @_name ");
WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_sticker in (SELECT id_sticker FROM posts_stickers_related WHERE id_post = @_id_post) AND name like @_name ");
WHEN _field = 10 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (FN_GET_POSTS_STICKERS_TOTAL_ITEMS(id_sticker)) = @_num_x AND name like @_name ");


WHEN _field = 30 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_type = 1 AND name like @_name ");
WHEN _field = 31 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_type = 1 AND id_sticker like @_id_sticker AND name like @_name ");
WHEN _field = 32 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_type = 1 AND token like @_token AND name like @_name ");

ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

	IF (_id_group > 0)
	THEN
	   SET sqlcommand = CONCAT(sqlcommand," AND id_group = @_id_group ");
	END IF;

CASE
WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name ASC");
WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date ASC");
WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY total ASC");
WHEN _order_by = 11003 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY position ASC");

WHEN _order_by = 11000 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name DESC");
WHEN _order_by = 11001 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date DESC");
WHEN _order_by = 11002 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY total DESC");
WHEN _order_by = 11003 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY position DESC");

ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY position ASC");
END CASE;

SET sqlcommand = CONCAT(sqlcommand, " LIMIT ?,?");
SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;     
        
COMMIT;

END;

