create
    definer = skoiy@`%` procedure SP_GET_PUBLISH_ASSETS(IN _limit_a int(10), IN _limit_b int(10))
BEGIN



DECLARE _last_publish DATETIME;
DECLARE t1_a text;
DECLARE t1_b text;
DECLARE t1_c text;

DECLARE sqlcommand text;

DECLARE sqlcommand_stmt_new text;
DECLARE sqlcommand_create text;
DECLARE sqlcommand_new_assets text;
DECLARE sqlcommand_new_albums text;
DECLARE sqlcommand_new_galleries text;
DECLARE sqlcommand_new_directories text;
DECLARE sqlcommand_new_albums_directories text;
DECLARE sqlcommand_new_embeds text;

DECLARE sqlcommand_stmt_delete text;
DECLARE sqlcommand_delete text;
DECLARE sqlcommand_delete_assets text;
DECLARE sqlcommand_delete_albums text;
DECLARE sqlcommand_delete_galleries text;
DECLARE sqlcommand_delete_directories text;
DECLARE sqlcommand_delete_albums_directories text;
DECLARE sqlcommand_delete_embeds text;

DECLARE sqlcommand_stmt_update text;
DECLARE sqlcommand_update text;
DECLARE sqlcommand_update_assets text;
DECLARE sqlcommand_update_albums text;
DECLARE sqlcommand_update_galleries text;
DECLARE sqlcommand_update_directories text;
DECLARE sqlcommand_update_albums_directories text;
DECLARE sqlcommand_update_embeds text;


START TRANSACTION;


IF(SELECT count(1) FROM assets_publish_log WHERE date(end_publish_date) <> '0000-00-00')
THEN
	SELECT end_publish_date into _last_publish FROM assets_publish_log WHERE date(end_publish_date) <> '0000-00-00' ORDER by id_publish desc LIMIT 0,1;
ELSE
	SET _last_publish = '0000-00-00 00:00:00';
END IF;

SET @_last_publish = _last_publish;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;


DROP TEMPORARY TABLE IF EXISTS assets_publish_tmp_create;

SET t1_a = "CREATE TEMPORARY TABLE IF NOT EXISTS assets_publish_tmp_create ";


SET sqlcommand_new_assets = "SELECT 1 as type,1 as action_type,a.id_asset as id,0 as code, a.update_date, a.register_date FROM assets a WHERE register_date > @_last_publish AND a.deleted = 0" ;
SET sqlcommand_new_albums = "SELECT 2 as type,1 as action_type,id_album as id,0, update_date, register_date FROM albums WHERE register_date > @_last_publish  AND FN_GET_ASSETS_ALBUM_DIRECTORY_IS_DELETED(id_directory) = 0" ;
SET sqlcommand_new_galleries = "SELECT 3 as type,1 as action_type,id_gallery as id,0, update_date, register_date FROM galleries WHERE register_date > @_last_publish";
SET sqlcommand_new_directories = "SELECT 4 as type,1 as action_type,id_directory as id,0, update_date, register_date FROM assets_directories WHERE register_date > @_last_publish AND deleted = 0";
SET sqlcommand_new_albums_directories = "SELECT 5 as type,1 as action_type,id_directory as id,0, update_date, register_date FROM assets_albums_directories WHERE register_date > @_last_publish AND deleted = 0";
SET sqlcommand_new_embeds = "SELECT 10 as type,1 as action_type,id as id,code, update_date, register_date FROM assets_embeds WHERE register_date > @_last_publish";

SET sqlcommand_create = CONCAT(sqlcommand_new_assets," UNION ",sqlcommand_new_albums," UNION ",sqlcommand_new_galleries," UNION ",sqlcommand_new_directories," UNION ",sqlcommand_new_albums_directories," UNION ",sqlcommand_new_embeds);

SET @sqlcommand_stmt_new = CONCAT(t1_a,sqlcommand_create);

PREPARE stmt_create FROM @sqlcommand_stmt_new;
EXECUTE stmt_create;



 DROP TEMPORARY TABLE IF EXISTS assets_publish_tmp_update;
SET t1_c = "CREATE TEMPORARY TABLE IF NOT EXISTS assets_publish_tmp_update ";

SET sqlcommand_update_assets = "SELECT 1 as type,action_type,a.id_asset as id, 0 as code, a.update_date, a.register_date FROM assets a,assets_sync_updated psy WHERE psy.id_asset = a.id_asset AND a.deleted = 0";
SET sqlcommand_update_albums = "SELECT 2 as type,action_type,a.id_album as id, 0, a.update_date, a.register_date FROM albums a, assets_sync_updated psy WHERE psy.id_album = a.id_album AND FN_GET_ASSETS_ALBUM_DIRECTORY_IS_DELETED(a.id_directory) = 0";
SET sqlcommand_update_galleries = "SELECT 3 as type,action_type,g.id_gallery as id,0, g.update_date, g.register_date FROM galleries g, assets_sync_updated psy WHERE psy.id_gallery = g.id_gallery";
SET sqlcommand_update_directories = "SELECT 4 as type,action_type,ad.id_directory as id,0, ad.update_date, ad.register_date FROM assets_directories ad, assets_sync_updated psy WHERE psy.id_directory = ad.id_directory AND ad.deleted = 0";
SET sqlcommand_update_albums_directories = "SELECT 5 as type,action_type,aad.id_directory as id,0, aad.update_date, aad.register_date FROM assets_albums_directories aad, assets_sync_updated psy WHERE psy.id_album_directory = aad.id_directory AND aad.deleted = 0";
SET sqlcommand_update_embeds = "SELECT 10 as type,action_type,e.id as id,e.code, e.update_date, e.register_date FROM assets_embeds e, assets_sync_updated psy WHERE psy.id_embed = e.id";

SET sqlcommand_update = CONCAT(sqlcommand_update_assets," UNION ",sqlcommand_update_albums," UNION ",sqlcommand_update_galleries," UNION ",sqlcommand_update_directories," UNION ",sqlcommand_update_albums_directories," UNION ",sqlcommand_update_embeds);

SET @sqlcommand_stmt_update = CONCAT(t1_c,sqlcommand_update);

PREPARE stmt_update FROM @sqlcommand_stmt_update;
EXECUTE stmt_update;



DROP TEMPORARY TABLE IF EXISTS assets_publish_tmp_delete;
SET t1_b = "CREATE TEMPORARY TABLE IF NOT EXISTS assets_publish_tmp_delete ";


SET sqlcommand_delete_assets = "SELECT 1 as type,3 as action_type,id_asset as id,0 as code, '' as update_date,register_date FROM assets_sync_deleted WHERE register_date > @_last_publish AND id_asset > 0 AND last_sync_date = '0000-00-00 00:00:00'";
SET sqlcommand_delete_albums = "SELECT 2 as type,3 as action_type,id_album as id,0, '' as update_date,register_date FROM assets_sync_deleted WHERE register_date > @_last_publish AND id_album > 0 AND last_sync_date = '0000-00-00 00:00:00'";
SET sqlcommand_delete_galleries = "SELECT 3 as type,3 as action_type,id_gallery as id,0, '' as update_date,register_date FROM assets_sync_deleted WHERE register_date > @_last_publish AND id_gallery > 0 AND last_sync_date = '0000-00-00 00:00:00'";
SET sqlcommand_delete_directories = "SELECT 4 as type,3 as action_type,id_directory as id,0, '' as update_date,register_date FROM assets_sync_deleted WHERE register_date > @_last_publish AND id_directory > 0 AND last_sync_date = '0000-00-00 00:00:00'";
SET sqlcommand_delete_albums_directories = "SELECT 5 as type,3 as action_type,id_album_directory as id,0, '' as update_date,register_date FROM assets_sync_deleted WHERE register_date > @_last_publish AND id_album_directory > 0 AND last_sync_date = '0000-00-00 00:00:00'";
SET sqlcommand_delete_embeds = "SELECT 10 as type,3 as action_type,id_embed as id,0,'','' FROM assets_sync_deleted WHERE register_date > @_last_publish AND id_embed > 0 AND last_sync_date = '0000-00-00 00:00:00'";
             
SET sqlcommand_delete = CONCAT(sqlcommand_delete_assets," UNION ",sqlcommand_delete_albums," UNION ",sqlcommand_delete_galleries," UNION ",sqlcommand_delete_directories," UNION ",sqlcommand_delete_albums_directories," UNION ",sqlcommand_delete_embeds);

SET @sqlcommand_stmt_delete = CONCAT(t1_b,sqlcommand_delete);

PREPARE stmt_delete FROM @sqlcommand_stmt_delete;
EXECUTE stmt_delete;

SELECT count(1) into @total FROM(
SELECT * FROM assets_publish_tmp_create 
UNION
SELECT * FROM assets_publish_tmp_delete 
UNION
SELECT * FROM assets_publish_tmp_update) as tt;

SET sqlcommand ="
SELECT *,@total as total FROM(
SELECT * FROM assets_publish_tmp_create 
UNION
SELECT * FROM assets_publish_tmp_delete 
UNION
SELECT * FROM assets_publish_tmp_update) as tt LIMIT ?,?";

SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;

 

COMMIT;

END;

