create
    definer = skoiypp@`%` procedure SP_GET_PUBLISH_ASSETS()
BEGIN

DECLARE _last_publish DATETIME;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(SELECT count(1) FROM assets_publish_log WHERE date(end_publish_date) <> '0000-00-00')
THEN
	SELECT end_publish_date into _last_publish FROM assets_publish_log WHERE date(end_publish_date) <> '0000-00-00' ORDER by id_publish desc LIMIT 0,1;
ELSE
	SET _last_publish = '0000-00-00 00:00:00';
END IF;




SELECT 1 as type,1 as action_type,a.id_asset as id, id_sync,id_rev_sync, a.update_date, a.register_date FROM assets a WHERE id_sync = '' and a.deleted = 0
UNION 
SELECT 2 as type,1 as action_type,id_album as id, id_sync,id_rev_sync, update_date, register_date FROM albums WHERE id_sync = '' AND id_album in (SELECT id_album FROM albums_galleries_related)
UNION 
SELECT 3 as type,1 as action_type,id_gallery as id, id_sync,id_rev_sync, update_date, register_date FROM galleries WHERE id_sync = ''
UNION 
SELECT 4 as type,1 as action_type,id_directory as id, id_sync,id_rev_sync, update_date, register_date FROM assets_directories WHERE id_sync = '' AND deleted = 0




UNION 
SELECT 1 as type,3 as action_type,id_asset as id, id_sync,id_rev_sync,'','' FROM assets_sync_deleted WHERE register_date > _last_publish AND id_asset > 0 AND last_sync_date = '0000-00-00 00:00:00'
UNION 
SELECT 2 as type,3 as action_type,id_album as id, id_sync,id_rev_sync,'','' FROM assets_sync_deleted WHERE register_date > _last_publish AND id_album > 0 AND last_sync_date = '0000-00-00 00:00:00'
UNION 
SELECT 3 as type,3 as action_type,id_gallery as id, id_sync,id_rev_sync,'','' FROM assets_sync_deleted WHERE register_date > _last_publish AND id_gallery > 0 AND last_sync_date = '0000-00-00 00:00:00'
UNION 
SELECT 4 as type,3 as action_type,id_directory as id, id_sync,id_rev_sync,'','' FROM assets_sync_deleted WHERE register_date > _last_publish AND id_directory > 0 AND last_sync_date = '0000-00-00 00:00:00'
        


UNION
SELECT 1 as type,action_type,a.id_asset as id, a.id_sync,a.id_rev_sync, a.update_date, a.register_date FROM assets a,assets_sync_updated psy WHERE psy.id_asset = a.id_asset
UNION
SELECT 2 as type,action_type,a.id_album as id, a.id_sync,a.id_rev_sync, a.update_date, a.register_date FROM albums a, assets_sync_updated psy WHERE psy.id_album = a.id_album
UNION
SELECT 3 as type,action_type,g.id_gallery as id, g.id_sync,g.id_rev_sync, g.update_date, g.register_date FROM galleries g, assets_sync_updated psy WHERE psy.id_gallery = g.id_gallery
UNION
SELECT 4 as type,action_type,ad.id_directory as id, ad.id_sync,ad.id_rev_sync, ad.update_date, ad.register_date FROM assets_directories ad, assets_sync_updated psy WHERE psy.id_gallery = ad.id_directory;


DELETE FROM assets_sync_updated;

COMMIT;

END;

