create
    definer = skoiypp@`%` procedure SP_GET_PUBLISH_ASSETS_ALBUMS(IN _query varchar(192), IN _limit_a int, IN _limit_b int)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM albums;
END IF;

SET @_query = _query;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = "SELECT id_album, name, description, link, random,FN_GET_ASSETS_NUM_IMAGENS_ON_ALBUMS(id_album) as total_images, FN_GET_ASSETS_LAST_IMAGE_ON_ALBUM(id_album) as cover_image, register_date FROM albums "; 

IF(_query <> '')
THEN
   SET @_query = CONCAT("%",_query,"%");
   SET sqlcommand = CONCAT(sqlcommand," WHERE (name like ? or description like ? ) ");
END IF;

SET sqlcommand = CONCAT(sqlcommand," ORDER BY register_date desc LIMIT ?,?");
SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
 
CASE
WHEN _query = '' THEN
EXECUTE stmt USING @_limit_a,@_limit_b;
ELSE 
EXECUTE stmt USING @_query,@_query,@_limit_a,@_limit_b;    
END CASE;    
        
COMMIT;

END;

