create
    definer = skoiypp@`%` procedure SP_GET_PUBLISH_POSTS_LATEST(IN _id_collection INT, IN _id_dossier INT,
                                                                IN _iso_lang varchar(10), IN _limit_a INT,
                                                                IN _limit_b INT, IN _field INT, IN _filter VARCHAR(192))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1 OR _limit_b = 0)
THEN
	IF(_iso_lang = '')
	THEN
		SELECT count(1) into _limit_b FROM posts_l10n;
	ELSE
		SELECT count(1) into _limit_b FROM posts_l10n WHERE iso_language = _iso_lang;
	END IF;
END IF;

SET @_id_collection = _id_collection;
SET @_id_dossier = _id_dossier;
SET @_iso_lang = _iso_lang;

SET @_cfilter = _filter;

SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;


SET sqlcommand = "SELECT pl10n.id_post,id_l10n,pdr.id_dossier,iso_language,title,description,image,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,meta_play_mark,publish_date,begin_date,end_date,pl10n.register_date, state 
FROM posts_l10n pl10n, posts_dossiers_related pdr WHERE pl10n.id_post = pdr.id_post AND state = 5 ";

IF(_iso_lang <> '')
THEN
    SET sqlcommand = CONCAT(sqlcommand," AND iso_language = @_iso_lang ");
END IF;

IF(_id_collection <> -1)
THEN
    SET sqlcommand = CONCAT(sqlcommand," AND id_dossier in (SELECT id_dossier FROM dossiers_collections_related WHERE id_collection = @_id_collection) ");
END IF;

IF(_id_dossier <> -1)
THEN
    SET sqlcommand = CONCAT(sqlcommand," AND id_dossier = @_id_dossier ");
END IF;

IF(_field = 1)
THEN
    SET sqlcommand = CONCAT(sqlcommand," AND DATEDIFF(now(), publish_date) <= @_cfilter ");
END IF;

	SET sqlcommand = CONCAT(sqlcommand," GROUP by id_l10n ORDER BY publish_date desc, pl10n.register_date desc limit ?,?");

SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;


COMMIT;

END;

