create
    definer = skoiypp@`%` procedure SP_GET_PUBLISH_POSTS_MGO(IN _limit_a int(10), IN _limit_b int(10))
BEGIN

DECLARE _last_publish DATETIME;
DECLARE t1_a text;
DECLARE t1_b text;
DECLARE t1_c text;

DECLARE sqlcommand text;

DECLARE sqlcommand_stmt_new text;
DECLARE sqlcommand_create text;
DECLARE sqlcommand_new_posts text;
DECLARE sqlcommand_new_dossiers text;
DECLARE sqlcommand_new_collections text;
DECLARE sqlcommand_new_authors text;
DECLARE sqlcommand_new_stickers text;
DECLARE sqlcommand_new_stickers_groups text;

DECLARE sqlcommand_stmt_delete text;
DECLARE sqlcommand_delete text;
DECLARE sqlcommand_delete_posts text;
DECLARE sqlcommand_delete_dossiers text;
DECLARE sqlcommand_delete_collections text;
DECLARE sqlcommand_delete_authors text;
DECLARE sqlcommand_delete_stickers text;
DECLARE sqlcommand_delete_stickers_groups text;

DECLARE sqlcommand_stmt_update text;
DECLARE sqlcommand_update text;
DECLARE sqlcommand_update_posts text;
DECLARE sqlcommand_update_dossiers text;
DECLARE sqlcommand_update_collections text;
DECLARE sqlcommand_update_authors text;
DECLARE sqlcommand_update_stickers text;
DECLARE sqlcommand_update_stickers_groups text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(SELECT count(1) FROM posts_publish_log_2 WHERE date(end_publish_date) <> '0000-00-00')
THEN
	SELECT end_publish_date into _last_publish FROM posts_publish_log_2 WHERE date(end_publish_date) <> '0000-00-00' ORDER by id_publish desc LIMIT 0,1;
ELSE
	SET _last_publish = '0000-00-00 00:00:00';
END IF;

SET @_last_publish = _last_publish;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;


DROP TEMPORARY TABLE IF EXISTS posts_publish_tmp_create;

SET t1_a = "CREATE TEMPORARY TABLE IF NOT EXISTS posts_publish_tmp_create ";



SET sqlcommand_new_posts = "SELECT 1 as type,1 as action_type,vc.id_post as id, vc.update_date, vc.register_date FROM posts_l10n vc WHERE vc.register_date > @_last_publish AND state = 5" ;
SET sqlcommand_new_dossiers = "SELECT 2 as type,1 as action_type,d.id_dossier as id, d.update_date, d.register_date FROM dossiers d, dossiers_collections_related dcr WHERE d.id_dossier = dcr.id_dossier AND dcr.register_date > @_last_publish";
SET sqlcommand_new_collections = "SELECT 3 as type,1 as action_type,id_collection as id, update_date, register_date FROM collections WHERE register_date > @_last_publish AND state = 5";
SET sqlcommand_new_authors = "SELECT 4 as type,1 as action_type,vc.id_author as id, vc.update_date, vc.register_date FROM posts_authors_l10n vc WHERE vc.register_date > @_last_publish " ;
SET sqlcommand_new_stickers = "SELECT 5 as type,1 as action_type,vc.id_sticker as id, vc.update_date, vc.register_date FROM posts_stickers vc WHERE vc.register_date > @_last_publish " ;
SET sqlcommand_new_stickers_groups = "SELECT 6 as type,1 as action_type,vc.id_group as id, vc.update_date, vc.register_date FROM posts_stickers_groups vc WHERE vc.register_date > @_last_publish " ;


SET sqlcommand_create = CONCAT(sqlcommand_new_posts," UNION ",sqlcommand_new_dossiers," UNION ",sqlcommand_new_collections," UNION ",sqlcommand_new_authors," UNION ",sqlcommand_new_stickers," UNION ",sqlcommand_new_stickers_groups);

SET @sqlcommand_stmt_new = CONCAT(t1_a,sqlcommand_create);

PREPARE stmt_create FROM @sqlcommand_stmt_new;
EXECUTE stmt_create;




 DROP TEMPORARY TABLE IF EXISTS posts_publish_tmp_update;
SET t1_c = "CREATE TEMPORARY TABLE IF NOT EXISTS posts_publish_tmp_update ";

SET sqlcommand_update_posts = "SELECT 1 as type,action_type,vc.id_post as id, vc.update_date, vc.register_date FROM posts_l10n vc,posts_sync_updated_2 psy WHERE psy.id_post = vc.id_post";
SET sqlcommand_update_dossiers = "SELECT 2 as type,action_type,p.id_dossier as id, p.update_date, p.register_date FROM dossiers p, posts_sync_updated_2 psy WHERE psy.id_dossier = p.id_dossier";
SET sqlcommand_update_collections = "SELECT 3 as type,action_type,c.id_collection as id, c.update_date, c.register_date FROM collections c, posts_sync_updated_2 psy WHERE psy.id_collection = c.id_collection";
SET sqlcommand_update_authors = "SELECT 4 as type,action_type,vc.id_author as id, vc.update_date, vc.register_date FROM posts_authors_l10n vc,posts_sync_updated_2 psy WHERE psy.id_author = vc.id_author";
SET sqlcommand_update_stickers = "SELECT 5 as type,action_type,vc.id_sticker as id, vc.update_date, vc.register_date FROM posts_stickers vc,posts_sync_updated_2 psy WHERE psy.id_sticker = vc.id_sticker";
SET sqlcommand_update_stickers_groups = "SELECT 6 as type,action_type,vc.id_group as id, vc.update_date, vc.register_date FROM posts_stickers_groups vc,posts_sync_updated_2 psy WHERE psy.id_sticker_group = vc.id_group";


SET sqlcommand_update = CONCAT(sqlcommand_update_posts," UNION ",sqlcommand_update_dossiers," UNION ",sqlcommand_update_collections," UNION ",sqlcommand_update_authors," UNION ",sqlcommand_update_stickers," UNION ",sqlcommand_update_stickers_groups);

SET @sqlcommand_stmt_update = CONCAT(t1_c,sqlcommand_update);

PREPARE stmt_update FROM @sqlcommand_stmt_update;
EXECUTE stmt_update;




DROP TEMPORARY TABLE IF EXISTS posts_publish_tmp_delete;
SET t1_b = "CREATE TEMPORARY TABLE IF NOT EXISTS posts_publish_tmp_delete ";


SET sqlcommand_delete_posts = "SELECT 1 as type,3 as action_type,id_post as id,'' as update_date,register_date FROM posts_sync_deleted_2 WHERE register_date > @_last_publish AND id_post > 0 AND last_sync_date = '0000-00-00 00:00:00'";
SET sqlcommand_delete_dossiers = "SELECT 2 as type,3 as action_type,id_dossier as id,'','' FROM posts_sync_deleted_2 WHERE register_date > @_last_publish AND id_dossier > 0 AND last_sync_date = '0000-00-00 00:00:00'";
SET sqlcommand_delete_collections = "SELECT 3 as type,3 as action_type,id_collection as id,'','' FROM posts_sync_deleted_2 WHERE register_date > @_last_publish AND id_collection > 0 AND last_sync_date = '0000-00-00 00:00:00'";
SET sqlcommand_delete_authors = "SELECT 4 as type,3 as action_type,id_author as id,'' as update_date,register_date FROM posts_sync_deleted_2 WHERE register_date > @_last_publish AND id_author > 0 AND last_sync_date = '0000-00-00 00:00:00'";
SET sqlcommand_delete_stickers = "SELECT 5 as type,3 as action_type,id_sticker as id,'' as update_date,register_date FROM posts_sync_deleted_2 WHERE register_date > @_last_publish AND id_sticker > 0 AND last_sync_date = '0000-00-00 00:00:00'";
SET sqlcommand_delete_stickers_groups = "SELECT 6 as type,3 as action_type,id_sticker_group as id,'' as update_date,register_date FROM posts_sync_deleted_2 WHERE register_date > @_last_publish AND id_sticker_group > 0 AND last_sync_date = '0000-00-00 00:00:00'";


SET sqlcommand_delete = CONCAT(sqlcommand_delete_posts," UNION ",sqlcommand_delete_dossiers," UNION ",sqlcommand_delete_collections," UNION ",sqlcommand_delete_authors," UNION ",sqlcommand_delete_stickers," UNION ",sqlcommand_delete_stickers_groups);

SET @sqlcommand_stmt_delete = CONCAT(t1_b,sqlcommand_delete);

PREPARE stmt_delete FROM @sqlcommand_stmt_delete;
EXECUTE stmt_delete;

SELECT count(1) into @total FROM(
SELECT * FROM posts_publish_tmp_create 
UNION
SELECT * FROM posts_publish_tmp_delete 
UNION
SELECT * FROM posts_publish_tmp_update) as tt;

SET sqlcommand ="
SELECT *,@total as total FROM(
SELECT * FROM posts_publish_tmp_create 
UNION
SELECT * FROM posts_publish_tmp_delete 
UNION
SELECT * FROM posts_publish_tmp_update) as tt LIMIT ?,?";

SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;

COMMIT;

END;

