create
    definer = skoiypp@`%` procedure SP_GET_PUBLISH_POSTS_SEARCH(IN _id_collection int(10), IN _id_dossier int(10),
                                                                IN _field int(10), IN _query varchar(192),
                                                                IN _filter varchar(192), IN _iso_lang varchar(10),
                                                                IN _limit_a int, IN _limit_b int)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
	IF(_iso_lang = '')
	THEN
		SELECT count(1) into _limit_b FROM posts_l10n;
	ELSE
		SELECT count(1) into _limit_b FROM posts_l10n WHERE iso_language = _iso_lang;
	END IF;
END IF;

SET @_id_collection = _id_collection;
SET @_id_dossier = _id_dossier;

SET @_title = CONCAT("%",_query,"%");
SET @_description = CONCAT("%",_query,"%");
SET @_filter = CONCAT("%",_filter,"%");
SET @_cfilter = _filter;
SET @_tags_stripped = CONCAT("%",_query,"%");
SET @_iso_lang = _iso_lang;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET @_year = year(_filter);
SET @_month = month(_filter);

IF EXISTS(SELECT id_collection FROM collections WHERE id_collection = _id_collection)
THEN

	IF(_id_dossier = -1)
	THEN
		SET sqlcommand = "SELECT dcr.id_collection,pdr.id_dossier,id_l10n,pln.id_post,iso_language, title, description,image,meta_title,meta_url,meta_description,meta_image,image_title,image_alter_text,meta_keywords,meta_play_mark, publish_date,begin_date,end_date, 
pln.register_date, state, FN_GET_POSTS_TAGS_GROUPED(pln.id_l10n) as tags FROM posts_l10n pln, posts_dossiers_related pdr, dossiers_collections_related dcr
WHERE pdr.id_post = pln.id_post AND pdr.id_dossier = dcr.id_dossier AND dcr.id_collection = ? AND iso_language = ? AND state = 5 ";
	ELSE
		SET sqlcommand = "SELECT dcr.id_collection,pdr.id_dossier,id_l10n,pln.id_post,iso_language, title, description,image,meta_title,meta_url,meta_description,meta_image,image_title,image_alter_text,meta_keywords,meta_play_mark, publish_date,begin_date,end_date, 
pln.register_date, state, FN_GET_POSTS_TAGS_GROUPED(pln.id_l10n) as tags FROM posts_l10n pln, posts_dossiers_related pdr, dossiers_collections_related dcr
WHERE pdr.id_post = pln.id_post AND pdr.id_dossier = dcr.id_dossier AND dcr.id_collection = ? AND iso_language = ? AND dcr.id_dossier = ? AND state = 5 ";
	END IF;


	CASE
	WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (title like ? OR description like ? OR ((SELECT count(1) FROM posts_tags pt, posts_tags_related ptr WHERE pt.id_tag = ptr.id_tag AND ptr.id_l10n = pln.id_l10n AND name_stripped like ?) > 0)) GROUP BY pln.id_post ORDER BY publish_date desc, pln.register_date DESC,title LIMIT ?,?");
	WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND title like ? GROUP BY pln.id_post ORDER BY publish_date desc, pln.register_date DESC,title LIMIT ?,?");
	WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND description like ? GROUP BY pln.id_post ORDER BY publish_date desc, pln.register_date DESC,title LIMIT ?,?");
	WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (SELECT FN_GET_POSTS_TAGS_GROUPED(pln.id_l10n) like ?) AND (title like ? OR description like ?) ORDER BY publish_date desc, pln.register_date DESC,title LIMIT ?,?");
	WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(pln.register_date) = ? AND month(pln.register_date) = ?) AND (title like ? OR description like ?) GROUP BY pln.id_post ORDER BY publish_date desc, pln.register_date DESC,title LIMIT ?,?");
	WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (year(pln.register_date) = ?) AND (title like ? OR description like ?) GROUP BY pln.id_post ORDER BY publish_date desc, pln.register_date DESC,title LIMIT ?,?");
	WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (title like ? OR description like ?) GROUP BY pln.id_post ORDER BY publish_date desc, pln.register_date,title DESC LIMIT ?,?");
	WHEN _field = 7 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND pln.id_l10n in (SELECT id_l10n FROM posts_l10n_authors WHERE id_author = ?) AND (title like ? OR description like ?) ORDER BY publish_date desc, pln.register_date DESC,title LIMIT ?,?");
	ELSE SET sqlcommand = CONCAT(sqlcommand, " GROUP BY pln.id_post ORDER BY publish_date desc, pln.register_date DESC,title LIMIT ?,?");
	END CASE;

	SET @sqlcommand = sqlcommand;

	PREPARE stmt FROM @sqlcommand;

	IF(_id_dossier = -1)
	THEN
		CASE
		WHEN _field = 0 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_title,@_description,@_tags_stripped,@_limit_a,@_limit_b;
		WHEN _field = 1 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_title,@_limit_a,@_limit_b;
		WHEN _field = 2 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_description,@_limit_a,@_limit_b;
		WHEN _field = 3 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_filter,@_title,@_description,@_limit_a,@_limit_b;
		WHEN _field = 4 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_year,@_month,@_title,@_description,@_limit_a,@_limit_b;
		WHEN _field = 5 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_year,@_title,@_description,@_limit_a,@_limit_b;
		WHEN _field = 6 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_title,@_description,@_limit_a,@_limit_b;
		WHEN _field = 7 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_cfilter,@_title,@_description,@_limit_a,@_limit_b;
		ELSE 
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_limit_a,@_limit_b;    
		END CASE;    
	ELSE
		CASE
		WHEN _field = 0 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_id_dossier,@_title,@_description,@_tags_stripped,@_limit_a,@_limit_b;
		WHEN _field = 1 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_id_dossier,@_title,@_limit_a,@_limit_b;
		WHEN _field = 2 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_id_dossier,@_description,@_limit_a,@_limit_b;
		WHEN _field = 3 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_id_dossier,@_filter,@_title,@_description,@_limit_a,@_limit_b;
		WHEN _field = 4 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_id_dossier,@_year,@_month,@_title,@_description,@_limit_a,@_limit_b;
		WHEN _field = 5 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_id_dossier,@_year,@_title,@_description,@_limit_a,@_limit_b;
		WHEN _field = 6 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_id_dossier,@_title,@_description,@_limit_a,@_limit_b;
		WHEN _field = 7 THEN
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_id_dossier,@_cfilter,@_title,@_description,@_limit_a,@_limit_b;
		ELSE 
		EXECUTE stmt USING @_id_collection,@_iso_lang,@_id_dossier,@_limit_a,@_limit_b;    
		END CASE;  
	END IF;

ELSE
	SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

