create
    definer = skoiypp@`%` procedure SP_GET_PUBLISH_POSTS_TODAYS_LATEST(IN _id_collection INT, IN _id_dossier INT, IN _iso_lang varchar(10))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_id_collection = _id_collection;
SET @_id_dossier = _id_dossier;
SET @_iso_lang = _iso_lang;


SET sqlcommand = "SELECT pl10n.id_post,id_l10n,pdr.id_dossier,iso_language,title,description,image,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,meta_play_mark,publish_date,begin_date,end_date,pl10n.register_date, state 
FROM posts_l10n pl10n, posts_dossiers_related pdr WHERE pl10n.id_post = pdr.id_post AND state in (4,5) ";

IF(_iso_lang <> '')
THEN
    SET sqlcommand = CONCAT(sqlcommand," AND iso_language = ? ");
END IF;

IF(_id_collection <> -1)
THEN
    SET sqlcommand = CONCAT(sqlcommand," AND id_dossier in (SELECT id_dossier FROM dossiers_collections_related WHERE id_collection = ?) ");
END IF;

IF(_id_dossier <> -1)
THEN
    SET sqlcommand = CONCAT(sqlcommand," AND id_dossier = ? ");
END IF;

	SET sqlcommand = CONCAT(sqlcommand," AND date(pl10n.publish_date) = date(now()) OR date(pl10n.update_date) = date(now()) GROUP by id_l10n ORDER BY publish_date desc, pl10n.register_date desc");

SET @sqlcommand = sqlcommand;

PREPARE stmt FROM @sqlcommand;

IF(_iso_lang <> '')
THEN
    CASE
		WHEN _id_collection <> -1 AND _id_dossier = -1 THEN
		EXECUTE stmt USING @_iso_lang,@_id_collection;
		WHEN _id_collection = -1 AND _id_dossier <> -1 THEN
		EXECUTE stmt USING @_iso_lang,@_id_dossier;
		WHEN _id_collection <> -1 AND _id_dossier <> -1 THEN
		EXECUTE stmt USING @_iso_lang,@_id_collection,@_id_dossier;
		ELSE 
		EXECUTE stmt;    
	END CASE; 
ELSE
    CASE
		WHEN _id_collection <> -1 AND _id_dossier = -1 THEN
		EXECUTE stmt USING @_id_collection;
		WHEN _id_collection = -1 AND _id_dossier <> -1 THEN
		EXECUTE stmt USING @_id_dossier;
		WHEN _id_collection <> -1 AND _id_dossier <> -1 THEN
		EXECUTE stmt USING @_id_collection,@_id_dossier;
		ELSE 
		EXECUTE stmt;    
	END CASE; 
END IF;

COMMIT;

END;

