create
    definer = skoiypp@`%` procedure SP_GET_PUBLISH_VIDEO_SEARCH(IN _field int(10), IN _query varchar(255),
                                                                IN _iso_lang varchar(10))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_query = CONCAT("%",_query,"%");
SET @_iso_lang = _iso_lang;

IF(_field in(1,2,3))
THEN

	IF(_field = 1)
	THEN
	SET sqlcommand = "SELECT  vc.id_composed,vcpr.id_playlist, pcr.id_channel FROM video_composed vc, videos v, video_profiles vp, video_profiles_l10n vpl10n, video_composed_playlists_related vcpr, playlists_channels_related pcr, channels c 
	WHERE vc.id_video = v.id_video AND vpl10n.id_profile = vp.id_profile AND vc.id_profile = vpl10n.id_profile AND v.deleted = 0 AND vc.state = 5 AND vc.id_composed = vcpr.id_composed AND vcpr.id_playlist = pcr.id_playlist AND pcr.id_channel = c.id_channel 
	AND vpl10n.iso_language = @_iso_lang AND (
	FN_GET_VIDEO_SEARCH(vp.id_profile,'PROFILE',@_query) > 0 OR
	FN_GET_VIDEO_SEARCH(vp.id_profile,'PROFILE_BODY',@_query) > 0 OR
	FN_GET_VIDEO_SEARCH(vp.id_profile,'PROFILE_TAGS',@_query) > 0 OR
	FN_GET_VIDEO_SEARCH(v.id_video,'VIDEO',@_query) > 0
	) GROUP BY vc.id_composed ORDER BY vpl10n.title LIMIT 0,15";
	END IF;

	SET @sqlcommand = sqlcommand;

	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt;
ELSE
	SELECT -2 as return_code;
END IF;

COMMIT;

END;

