create
    definer = skoiypp@`%` procedure SP_GET_PUBLISH_VIDEO_TO_EXECUTE()
BEGIN

DECLARE _total_begin_date INT(10);
DECLARE _total_end_date INT(10);

DECLARE _total_playlist_begin_date INT(10);
DECLARE _total_playlist_end_date INT(10);

DECLARE _total_channel_begin_date INT(10);
DECLARE _total_channel_end_date INT(10);

DECLARE _total_sticker_begin_date INT(10);
DECLARE _total_sticker_end_date INT(10);

DECLARE _total_sync_updated INT(10);


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SELECT count(1) into _total_begin_date FROM video_composed a WHERE date(begin_date) <= date(now()) AND time(begin_date) <= time(now()) AND (date(end_date) >= date(now()) or date(end_date) = '0000-00-00') AND (date(end_date) >= date(now()) or date(end_date) = '0000-00-00' or time(end_date) >= time(now())) AND state = 4 
AND id_composed in (SELECT id_composed FROM video_composed_playlists_related b, playlists p WHERE p.id_playlist = b.id_playlist AND b.id_composed = a.id_composed AND p.state = 5);

SELECT count(1) into _total_end_date FROM video_composed vc, video_composed_playlists_related vcpr WHERE vc.id_composed = vcpr.id_composed AND ((date(end_date) < date(now())) OR (date(end_date) <= date(now()) AND time(end_date) < time(now()))) AND date(end_date) NOT IN ('0000-00-00');

SELECT count(1) into _total_playlist_begin_date FROM playlists WHERE begin_date > now();
SELECT count(1) into _total_playlist_end_date FROM playlists WHERE end_date < now() AND end_date <> '0000-00-00 00:00:00';

SELECT count(1) into _total_channel_begin_date FROM channels WHERE begin_date > now();
SELECT count(1) into _total_channel_end_date FROM channels WHERE end_date < now() AND end_date <> '0000-00-00 00:00:00';

SELECT count(1) into _total_sticker_begin_date FROM video_stickers_related WHERE begin_date > now();
SELECT count(1) into _total_sticker_end_date FROM video_stickers_related WHERE end_date < now() AND end_date <> '0000-00-00 00:00:00' AND state = 5;

SELECT count(1) into _total_sync_updated FROM video_sync_updated;


IF(_total_sync_updated > 0 OR _total_begin_date > 0 OR _total_end_date > 0 OR _total_playlist_begin_date > 0 OR _total_playlist_end_date > 0 OR _total_channel_begin_date > 0 OR _total_channel_end_date > 0 OR _total_sticker_begin_date > 0 OR _total_sticker_end_date > 0)
THEN
	SELECT 0 as return_code, 1 as publish;
ELSE
	SELECT 0 as return_code, 0 as publish;
END IF;

COMMIT;

END;

