create
    definer = skoiypp@`%` procedure SP_GET_USER_ACCOUNTS_COUNT(IN _id_user int(10), IN _field int(10),
                                                               IN _query varchar(192), IN _filter varchar(192))
BEGIN


DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS(SELECT id_user FROM users WHERE id_user = _id_user)
THEN

SET @_name = CONCAT("%",_query,"%");
SET @_id_account = _filter;
SET @_email = CONCAT("%",_filter,"%");
SET @_id_user = _id_user;

SET sqlcommand = "SELECT count(1) as total FROM accounts a, users_accounts ua, roles r 
  WHERE ua.id_account = a.id_account AND r.id_role = ua.id_role AND ua.id_user = @_id_user ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND company_name like @_name ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND a.id_account = @_id_account ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND email like @_email ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt;     

ELSE
	SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

