create
    definer = skoiypp@`%` procedure SP_GET_VIDEO_PROFILE_PLAYLISTS_RELATED(IN _id_profile int)
BEGIN


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS(SELECT id_profile FROM video_profiles WHERE id_profile = _id_profile)
THEN
	SELECT p.id_playlist, management_name, p.publish_date, p.begin_date, p.end_date,p.register_date, FN_GET_VIDEO_COMPOSES_ON_PLAYLISTS_NUM(p.id_playlist) as total,FN_GET_VIDEO_PLAYLIST_HAS_LIVE_CONTENT(p.id_playlist) as has_live,FN_GET_VIDEO_PLAYLIST_HAS_VIDEO_CONTENT(p.id_playlist) as has_vod,FN_GET_VIDEO_IS_PLAYLISTS_ON_CHANNEL(p.id_playlist) as on_channel,FN_GET_VIDEO_PLAYLIST_STATE(p.id_playlist) as state,vcpr.position
    FROM playlists p, video_composed vc, video_composed_playlists_related vcpr 
    WHERE p.id_playlist = vcpr.id_playlist AND vcpr.id_composed = vc.id_composed AND vc.id_profile = _id_profile;
ELSE
	SELECT -2 as return_code;
END IF;
			
COMMIT;

END;

