create
    definer = skoiypp@`%` procedure SP_GET_VIDEO_STRIPE_TO_PROCESS(IN _field int, IN _machine varchar(255))
BEGIN

DECLARE _id_queue INT;
DECLARE _id_account INT;
DECLARE _account_token varchar(255);
DECLARE _id_video INT;
DECLARE _command text;
DECLARE _video VARCHAR(255);
DECLARE _spritew INT;
DECLARE _spritespan INT;
DECLARE _spritecol INT;
DECLARE _aspect_ratio VARCHAR(255);



DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

 SELECT id_queue, id_account,account_token, id_video,video,spritew,spritespan,spritecol,aspect_ratio
 into _id_queue, _id_account,_account_token, _id_video,_video,_spritew,_spritespan,_spritecol,_aspect_ratio FROM 
 video_sprite_images_queue WHERE is_running = 0 LIMIT 0,1;
 
 UPDATE video_sprite_images_queue SET is_running = 1, start = now(), attempts = attempts+1 WHERE id_queue = _id_queue;
 UPDATE video_sprite_images_queue SET first_try = now() WHERE id_queue = _id_queue AND attempts = 1;
 UPDATE video_sprite_images_queue SET machine = _machine WHERE id_queue = _id_queue;

	IF(_id_queue > 0)
	THEN
		SELECT _id_queue as id_queue, _id_account as id_account, _account_token as account_token, _id_video as id_video,_video as video,_spritew as spritew,_spritespan as spritespan,_spritecol as spritecol,_aspect_ratio as aspect_ratio;
	ELSE
		SELECT -2 as return_code;
	END IF;
    	        
COMMIT;

END;

