create
    definer = skoiypp@`%` procedure SP_GET_VIDEO_TO_TRANSCODE(IN _field int, IN _machine varchar(255))
BEGIN

DECLARE _id_queue INT;
DECLARE _id_account INT;
DECLARE _account_token varchar(255);
DECLARE _id_video INT;
DECLARE _output_path varchar(255);
DECLARE _command text;
DECLARE _video VARCHAR(255);
DECLARE _versions varchar(255);
DECLARE _id_storage INT;
DECLARE _id_cdn INT;

DECLARE _total_running INT;
DECLARE _max_running INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET _max_running = 3;

SELECT count(1) into _total_running FROM video_transcoding_h264_queue WHERE is_running = 1 AND machine = _machine;

IF(_machine = "vrt-16")
THEN
	SELECT id_queue, id_storage, id_cdn, id_account, account_token, output_path, id_video, video,command,versions 
 		 into _id_queue, _id_storage, _id_cdn, _id_account, _account_token, _output_path, _id_video, _video,_command,_versions 
	FROM video_transcoding_h264_queue WHERE is_running = 0 AND deleted = 0 AND attempts < 4 AND _total_running < _max_running AND id_account in (245,259) ORDER BY attempts,first_try,position, register_date LIMIT 0,1;
ELSE
	SELECT id_queue, id_storage, id_cdn, id_account, account_token, output_path, id_video, video,command,versions 
 	 	 into _id_queue, _id_storage, _id_cdn, _id_account, _account_token, _output_path, _id_video, _video,_command,_versions 
	FROM video_transcoding_h264_queue WHERE is_running = 0 AND deleted = 0 AND attempts < 4 AND _total_running < 2  AND seconds < 1200 ORDER BY attempts,first_try,position, register_date LIMIT 0,1;
END IF;

 UPDATE video_transcoding_h264_queue SET is_running = 1, start = now(), attempts = attempts+1 WHERE id_queue = _id_queue;
 UPDATE video_transcoding_h264_queue SET first_try = now() WHERE id_queue = _id_queue AND attempts = 1;
 UPDATE video_transcoding_h264_queue SET machine = _machine WHERE id_queue = _id_queue;
 

	IF(_id_queue > 0)
	THEN
		SELECT _id_queue as id_queue, _id_storage as id_storage,_id_cdn as id_cdn,_id_account as id_account, _account_token as account_token, _output_path as output_path, _id_video as id_video, _video as video,_command as command,_versions as versions;
	ELSE
		SELECT -2 as return_code;
	END IF;   
 	        
COMMIT;

END;

