create
    definer = skoiypp@`%` procedure SP_GET_VIDEO_VIDEOS_SYSTEM_TAGS(IN _field int(10), IN _id_query int,
                                                                    IN _limit_a bigint, IN _limit_b bigint)
BEGIN


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_id_query = 1)
THEN
CASE
	WHEN _field = 1 THEN
		SELECT vc.state, count(1) as total FROM videos v, video_composed vc WHERE v.id_video = vc.id_video AND deleted = 0 GROUP BY vc.state ORDER BY vc.state; 
	WHEN _field = 2 THEN
		SELECT mime_type, count(1) as total FROM videos v, video_composed vc WHERE v.id_video = vc.id_video AND deleted = 0 GROUP BY mime_type ORDER BY mime_type;
	WHEN _field = 3 THEN
		SELECT height as resolution, count(1) as total FROM videos v, video_composed vc WHERE v.id_video = vc.id_video AND deleted = 0 GROUP BY height ORDER BY resolution;
	WHEN _field = 4 THEN
		SELECT count(1) as total FROM videos v, video_composed vc WHERE v.id_video = vc.id_video AND deleted = 0 AND size BETWEEN _limit_a AND _limit_b;
	WHEN _field = 5 THEN
		SELECT count(1) as total FROM videos v, video_composed vc WHERE v.id_video = vc.id_video AND deleted = 0 AND bitrate BETWEEN _limit_a AND _limit_b;
	WHEN _field = 6 THEN
		SELECT count(1) as total FROM videos v, video_composed vc WHERE v.id_video = vc.id_video AND deleted = 0 AND seconds BETWEEN _limit_a AND _limit_b;
	ELSE 
		SELECT vc.state, count(1) as total FROM videos v, video_composed vc WHERE v.id_video = vc.id_video AND deleted = 0 GROUP BY vc.state ORDER BY vc.state; 
	END CASE;
ELSE
CASE
	WHEN _field = 1 THEN
		SELECT state, count(1) as total FROM videos WHERE deleted = 0 GROUP BY state ORDER BY state; 
	WHEN _field = 2 THEN
		SELECT mime_type, count(1) as total FROM videos WHERE deleted = 0 GROUP BY mime_type ORDER BY mime_type;
	WHEN _field = 3 THEN
		SELECT height as resolution, count(1) as total FROM videos WHERE deleted = 0 GROUP BY height ORDER BY resolution;
	WHEN _field = 4 THEN
		SELECT count(1) as total FROM videos WHERE deleted = 0 AND size BETWEEN _limit_a AND _limit_b;
	WHEN _field = 5 THEN
		SELECT count(1) as total FROM videos WHERE deleted = 0 AND bitrate BETWEEN _limit_a AND _limit_b;
	WHEN _field = 6 THEN
		SELECT count(1) as total FROM videos WHERE deleted = 0 AND seconds BETWEEN _limit_a AND _limit_b;
	ELSE 
		SELECT state, count(1) as total FROM videos WHERE deleted = 0 GROUP BY state ORDER BY state; 
	END CASE;
END IF;
    
        
COMMIT;

END;

