create
    definer = skoiypp@`%` procedure SP_SET_ARCHIVE_CLIP(IN _id_clip INT, IN _id_directory INT, IN _id_video INT,
                                                        IN _name VARCHAR(192), IN _file_name VARCHAR(192),
                                                        IN _seconds FLOAT(10, 2), IN _extension VARCHAR(8),
                                                        IN _mime_type VARCHAR(192), IN _size BIGINT,
                                                        IN _codec VARCHAR(45), IN _bitrate BIGINT,
                                                        IN _audio_bitrate INT(10), IN _audio_codec VARCHAR(45),
                                                        IN _framerate INT(10), IN _framecount INT(10),
                                                        IN _width INT(10), IN _height INT(10), IN _ratio VARCHAR(8),
                                                        IN _id_storage int(10), IN _id_cdn int(10))
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
    SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF (_id_directory = 0 OR _id_directory = 1 OR _id_directory = -1)
THEN
	SET _id_directory = 1;
END IF;

IF NOT EXISTS (SELECT id_directory FROM archive_clips_directories WHERE id_directory = 1)
THEN
	INSERT INTO archive_clips_directories(id_directory,name,register_date) VALUES(1,'root',now());
END IF;

IF(_id_clip = 0 OR _id_clip = -1)
THEN
        INSERT into archive_clips(id_directory,id_storage,id_cdn,id_video,name,filename,duration,seconds,extension,mime_type,size,codec,bitrate,audio_bitrate,audio_codec,framerate,framecount,width,height,ratio,register_date) 
        VALUES(_id_directory,_id_storage,_id_cdn,_id_video,_name,_file_name,sec_to_time(_seconds),_seconds,_extension,_mime_type,_size,_codec,_bitrate,_audio_bitrate,_audio_codec,_framerate,_framecount,_width,_height,_ratio,now());        
        SET p_last_id = last_insert_id();
        SELECT id_clip,id_directory,id_storage,id_cdn,id_video,name,filename,seconds,extension,mime_type,size,codec,bitrate,audio_bitrate,audio_codec,framerate,framecount,width,height,ratio,state,register_date,FN_GET_ARCHIVE_CLIP_HAS_RELATED(id_video) as has_related_clips, FN_GET_ARCHIVE_CLIP_IN_TRANSFER(id_clip) as in_transfer,FN_GET_ARCHIVE_CLIP_HAS_PREVIEW(id_clip) has_preview, FN_GET_ARCHIVE_CLIP_THUMBNAIL(id_clip) as thumbnail FROM archive_clips WHERE id_clip = p_last_id; 
ELSE       
     IF EXISTS (SELECT id_clip FROM archive_clips WHERE id_clip = _id_clip)
     THEN
		IF(_size > 0)
		THEN
			UPDATE archive_clips SET name = _name, id_directory = _id_directory, size = _size, framecount = _framecount, framerate = _framerate, update_date = now() WHERE id_clip = _id_clip; 
		ELSE
			UPDATE archive_clips SET name = _name, id_directory = _id_directory, update_date = now() WHERE id_clip = _id_clip;
		END IF; 
        SELECT id_clip,id_directory,id_storage,id_cdn,id_video,name,filename,seconds,extension,mime_type,size,codec,bitrate,audio_bitrate,audio_codec,framerate,framecount,width,height,ratio,state,register_date,FN_GET_ARCHIVE_CLIP_HAS_RELATED(id_video) as has_related_clips, FN_GET_ARCHIVE_CLIP_IN_TRANSFER(id_clip) as in_transfer,FN_GET_ARCHIVE_CLIP_HAS_PREVIEW(id_clip) has_preview,FN_GET_ARCHIVE_CLIP_THUMBNAIL(id_clip) as thumbnail FROM archive_clips WHERE id_clip = _id_clip; 
     ELSE
        SELECT -2 as return_code;
     END IF;
END IF;
COMMIT;

END;

