create
    definer = skoiypp@`%` procedure SP_SET_ARCHIVE_PROJECT(IN _id_project INT, IN _name VARCHAR(192),
                                                           IN _code varchar(255), IN _password varchar(255),
                                                           IN _end_date datetime, IN _active tinyint(1))
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_id_project = 0 OR _id_project = -1)
THEN
	IF NOT EXISTS(SELECT id_project FROM archive_projects WHERE code = _code)
	THEN
	   INSERT INTO archive_projects(name,code,password,end_date,active,register_date) VALUES(_name,_code,_password,_end_date,_active,now());
	   SET p_last_id = last_insert_id();
    SELECT id_project, name, code, password, end_date,active,FN_GET_ARCHIVE_NUM_ON_PROJECTS(id_project) as total_content,register_date,
	FN_GET_ARCHIVE_LAST_FILENAME_ON_PROJECT(id_project) as filename, 
	FN_GET_ARCHIVE_LAST_SECONDS_ON_PROJECT(id_project) as seconds, FN_GET_ARCHIVE_LAST_TYPE_ON_PROJECT(id_project) as is_clip 
	FROM archive_projects WHERE id_project = p_last_id;
	ELSE
		SELECT -2 as return_code;
	END IF;
ELSE
	IF EXISTS (SELECT id_project FROM archive_projects WHERE id_project = _id_project)
	THEN	   
		UPDATE archive_projects SET name = _name, password = _password, end_date = _end_date, active = _active, update_date = now() WHERE id_project = _id_project;
    SELECT id_project, name, code, password, end_date,active,FN_GET_ARCHIVE_NUM_ON_PROJECTS(id_project) as total_content,register_date,
	FN_GET_ARCHIVE_LAST_FILENAME_ON_PROJECT(id_project) as filename, 
	FN_GET_ARCHIVE_LAST_SECONDS_ON_PROJECT(id_project) as seconds, FN_GET_ARCHIVE_LAST_TYPE_ON_PROJECT(id_project) as is_clip 
	FROM archive_projects WHERE id_project = _id_project;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;  
  
COMMIT;

END;

