create
    definer = skoiypp@`%` procedure SP_SET_ASSETS_GALLERIES(IN _id_gallery int, IN _name varchar(192), IN _default_id_album int)
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET p_last_id = 0;

IF(_id_gallery = 0 OR _id_gallery = -1)
THEN
   INSERT into galleries(name,default_id_album,register_date) VALUES(_name,_default_id_album,now());
   SET p_last_id = last_insert_id();
   SELECT id_gallery,name,default_id_album,position, register_date FROM galleries WHERE id_gallery = p_last_id;
ELSE
  IF EXISTS (SELECT id_gallery FROM galleries WHERE id_gallery = _id_gallery)
  THEN     
      SELECT FN_SP_SET_PUBLISH_ASSETS_SYNC_UPDATE(30,_id_gallery) into _empty;  
      UPDATE galleries SET name = _name,default_id_album = _default_id_album, update_date = now() WHERE id_gallery = _id_gallery;
      SELECT id_gallery,name,default_id_album,position, register_date FROM galleries WHERE id_gallery = _id_gallery;
  ELSE
    SELECT -2 as return_code;
  END IF;
END IF;  
  
COMMIT;

END;

