create
    definer = skoiypp@`%` procedure SP_SET_LIVE_PROFILE_CLONE_TO_VIDEO(IN _id_profile int)
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF (SELECT count(1) FROM video_profiles WHERE id_profile = _id_profile AND live_profile = 1)
THEN
    INSERT INTO video_profiles(register_date,live_profile) VALUES(now(),0);
    SET p_last_id = last_insert_id();

    INSERT into video_profiles_l10n(id_profile,iso_language,title,description,image,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,state,register_date)
        SELECT p_last_id,iso_language,title,description,image,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,2,now() FROM video_profiles_l10n WHERE id_profile = _id_profile; 

	 CALL SP_SET_VIDEO_PROFILE_CLONE_L10N(p_last_id,_id_profile);

    SELECT id_l10n,id_profile,title,description,image,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,state,update_date,register_date FROM video_profiles_l10n WHERE id_profile = p_last_id; 
ELSE
    SELECT -2 as return_code;
END IF;

COMMIT;

END;

