create
    definer = skoiypp@`%` procedure SP_SET_POSTS_AUTHORS_VARIANTS(IN _id_author_l10n INT(10), IN _id_key INT(10),
                                                                  IN _variant_value VARCHAR(255),
                                                                  IN _id_position INT(10))
BEGIN

DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_author_l10n FROM posts_authors_l10n WHERE id_author_l10n = _id_author_l10n) AND EXISTS (SELECT id_key FROM posts_authors_variants_keys WHERE id_key = _id_key)
THEN

    IF NOT EXISTS(SELECT id_author_l10n FROM posts_authors_variants_related WHERE id_author_l10n = _id_author_l10n AND id_key = _id_key)
    THEN
		     INSERT INTO posts_authors_variants_related(id_author_l10n,id_key,variant_value,position,register_date) VALUES(_id_author_l10n,_id_key,_variant_value,_id_position,now());
    ELSE
         UPDATE posts_authors_variants_related SET variant_value = _variant_value, position = _id_position, update_date = now() WHERE id_author_l10n = _id_author_l10n AND id_key = _id_key;
    END IF;
    
    SELECT id_variant, id_author_l10n,avk.id_key, name,name_stripped, variant_value,position, atvr.register_date FROM posts_authors_variants_related atvr, posts_authors_variants_keys avk
	WHERE atvr.id_key = avk.id_key AND atvr.id_author_l10n = _id_author_l10n AND avk.id_key = _id_key;     

ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

