create
    definer = skoiypp@`%` procedure SP_SET_POSTS_AUTHOR_L10N(IN _id_author_l10n int, IN _id_author int,
                                                             IN _iso_language varchar(10), IN _name varchar(255),
                                                             IN _email varchar(255), IN _description text,
                                                             IN _role varchar(255), IN _biography text,
                                                             IN _image varchar(255), IN _meta_title varchar(255),
                                                             IN _meta_description text, IN _meta_image varchar(255),
                                                             IN _meta_url varchar(255), IN _image_title varchar(255),
                                                             IN _image_alter_text varchar(255),
                                                             IN _meta_keywords varchar(255))
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
    SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_author FROM posts_authors WHERE id_author = _id_author)
THEN
	IF(_id_author_l10n = 0 OR _id_author_l10n = -1)
	THEN
		INSERT INTO posts_authors_l10n(id_author,iso_language,name,email,description,role,biography,image,meta_title,meta_description,meta_image,meta_url,image_title,image_alter_text,meta_keywords,register_date) 
		VALUES(_id_author,_iso_language,_name,_email,_description,_role,_biography,_image,_meta_title,_meta_description,_meta_image,_meta_url,_image_title,_image_alter_text,_meta_keywords,now());
		SET p_last_id = last_insert_id();
		SELECT id_author_l10n,id_author,iso_language,name,email,description,role,biography,image,meta_title,meta_description,meta_image,meta_url,image_title,image_alter_text,meta_keywords,FN_GET_POSTS_AUTHORS_TOTAL_POSTS(id_author) as total,register_date FROM posts_authors_l10n WHERE id_author_l10n = p_last_id; 
	ELSE       
	     IF EXISTS (SELECT id_author_l10n FROM posts_authors_l10n WHERE id_author_l10n = _id_author_l10n)
	     THEN
	        UPDATE posts_authors_l10n SET id_author = _id_author,iso_language = _iso_language,name = _name,email = _email,description = _description,role = _role,biography = _biography,image = _image,meta_title = _meta_title,meta_description = _meta_description,meta_image = _meta_image,meta_url = _meta_url,image_title = _image_title,image_alter_text = _image_alter_text,meta_keywords = _meta_keywords, update_date = now() WHERE id_author = _id_author AND id_author_l10n = _id_author_l10n;
			SELECT id_author_l10n,id_author,iso_language,name,email,description,role,biography,image,meta_title,meta_description,meta_image,meta_url,image_title,image_alter_text,meta_keywords,FN_GET_POSTS_AUTHORS_TOTAL_POSTS(id_author) as total,register_date FROM posts_authors_l10n WHERE id_author_l10n = _id_author_l10n; 
	     ELSE
	        SELECT -2 as return_code;
	     END IF;
	END IF;
ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

