create
    definer = skoiypp@`%` procedure SP_SET_POSTS_CLONE(IN _id_post INT)
BEGIN

DECLARE p_last_id INT UNSIGNED;

SET p_last_id = 0;

START TRANSACTION;

IF (SELECT count(1) FROM posts WHERE id_post = _id_post)
THEN
    INSERT INTO posts(id_type,register_date)
    SELECT id_type,now() FROM posts WHERE id_post = _id_post;
    
    SET p_last_id = last_insert_id();
    INSERT into posts_l10n(id_post,iso_language,draft,headline,title,description,image,image_caption,image_align,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,meta_play_mark,color,publish_date,begin_date,end_date,state,register_date)
        SELECT p_last_id,iso_language,draft,headline,CONCAT('Copy of ',title),description,image,image_caption,image_align,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,meta_play_mark,color,publish_date,begin_date,end_date,3,now() FROM posts_l10n WHERE id_post = _id_post; 

		CALL SP_SET_POSTS_CLONE_L10N(p_last_id,_id_post);

    SELECT id_l10n, FN_GET_POSTS_TYPE(id_post) as id_type,id_post,iso_language,draft,FN_GET_POSTS_L10N_ISO_GROUPED(1,id_post) as iso_grouped,FN_GET_POSTS_TAGS_GROUPED(id_l10n,2) as tags_grouped,headline,title,description,image,image_caption,image_align,FN_GET_ASSETS_ID_BY_FILENAME(image) as id_asset,'' as image_width, '' as image_height,meta_title,meta_description,meta_image,FN_GET_ASSETS_ID_BY_FILENAME(meta_image) as meta_id_asset,meta_url,image_title,image_alter_text,meta_keywords,meta_play_mark,color,publish_date,begin_date,end_date,state,register_date, 0 as position FROM posts_l10n WHERE id_post = p_last_id; 
ELSE
    SELECT -2 as return_code;
END IF;

COMMIT;

END;

