create
    definer = skoiypp@`%` procedure SP_SET_POSTS_DOSSIERS(IN _id_dossier INT, IN _management_name VARCHAR(192),
                                                          IN _name VARCHAR(192), IN _begin_date DATETIME,
                                                          IN _end_date DATETIME, IN _random TINYINT(1))
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_id_dossier = 0 OR _id_dossier = -1)
THEN
   INSERT INTO dossiers(management_name,name,begin_date,end_date,random,register_date) VALUES(_management_name,_name,_begin_date,_end_date,_random,now());
   SET p_last_id = last_insert_id();
   SELECT id_dossier,management_name, name, begin_date, end_date, random FROM dossiers WHERE id_dossier = p_last_id;
ELSE
	IF EXISTS (SELECT id_dossier FROM dossiers WHERE id_dossier = _id_dossier)
	THEN	   
		UPDATE dossiers SET management_name = _management_name, name = _name,begin_date = _begin_date, end_date = _end_date, random = _random, update_date = now() WHERE id_dossier = _id_dossier;
		SELECT FN_SP_SET_PUBLISH_POSTS_SYNC_UPDATE(11,_id_dossier) into _empty;
		SELECT id_dossier, management_name, name, begin_date, end_date, random FROM dossiers WHERE id_dossier = _id_dossier;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;  
  
COMMIT;

END;

