create
    definer = skoiypp@`%` procedure SP_SET_POSTS_DOSSIERS_TO_COLLECTIONS(IN _id_collection int, IN _id_dossier int, IN _position int)
BEGIN

DECLARE lastposition INT;
DECLARE _old_position INT;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;



START TRANSACTION;
    
IF EXISTS (SELECT id_collection FROM collections WHERE id_collection = _id_collection) AND EXISTS (SELECT id_dossier FROM dossiers WHERE id_dossier = _id_dossier)
  THEN

  SELECT count(1) into lastposition FROM dossiers_collections_related WHERE id_collection = _id_collection;
  SELECT position into _old_position FROM dossiers_collections_related WHERE id_dossier = _id_dossier AND id_collection = _id_collection;
 
  IF(_position = lastposition)
  THEN
    SET _position = _position+1;
  END IF;

		IF NOT EXISTS (SELECT id_collection FROM dossiers_collections_related WHERE id_collection = _id_collection AND id_dossier = _id_dossier)
		THEN
			INSERT INTO dossiers_collections_related(id_collection,id_dossier,position,update_date,register_date) VALUES(_id_collection,_id_dossier,_position,now(),now());
			UPDATE dossiers SET state = '4' WHERE id_dossier = _id_dossier AND state NOT IN ('5');
			
			
    ELSE
			UPDATE dossiers_collections_related SET position = _position, update_date = now() WHERE id_collection = _id_collection AND id_dossier = _id_dossier;
		END IF;

	IF(_position < _old_position)
	THEN
			SET @rownum=0;
			UPDATE dossiers_collections_related p, (SELECT @rownum:=@rownum+1 rownum, dossiers_collections_related.* FROM dossiers_collections_related WHERE id_collection = _id_collection ORDER BY position,update_date DESC) r 
			SET p.position = r.rownum
			WHERE (p.id_dossier = r.id_dossier);
	ELSE
			SET @rownum=0;
			UPDATE dossiers_collections_related p, (SELECT @rownum:=@rownum+1 rownum, dossiers_collections_related.* FROM dossiers_collections_related WHERE id_collection = _id_collection ORDER BY position,update_date ASC) r 
			SET p.position = r.rownum
			WHERE (p.id_dossier = r.id_dossier);
	END IF;
    
        
        
    SELECT 0 as return_code;
    
ELSE
  SELECT -2 as return_code;
END IF;    

COMMIT;

END;

