create
    definer = skoiypp@`%` procedure SP_SET_POSTS_DOSSIER_CLONE(IN _id_dossier INT(10))
BEGIN

DECLARE _position INT;
DECLARE p_last_id INT UNSIGNED;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

SET p_last_id = 0;

START TRANSACTION;

IF (SELECT count(1) FROM dossiers WHERE id_dossier = _id_dossier)
THEN
    
    INSERT into dossiers(management_name, publish_date,begin_date, end_date,register_date)
        SELECT CONCAT('Copy of ',management_name), publish_date,begin_date, end_date,now() FROM dossiers WHERE id_dossier = _id_dossier; 
    SET p_last_id = last_insert_id();

	INSERT into posts_dossiers_related(id_post,id_dossier,position,register_date) 
		 SELECT id_post,p_last_id,position,now() FROM posts_dossiers_related WHERE id_dossier = _id_dossier;

	INSERT into dossiers_l10n(id_dossier,iso_language,name,description,image,image_align,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,meta_watermark_image,register_date)
		 SELECT p_last_id,iso_language,name,description,image,image_align,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,meta_watermark_image,now() FROM dossiers_l10n WHERE id_dossier = _id_dossier;
                
   CALL SP_SET_POSTS_DOSSIER_CLONE_L10N(p_last_id,_id_dossier);

  SELECT id_dossier, management_name, publish_date, begin_date, end_date, register_date, FN_GET_POSTS_ON_DOSSIERS_NUM(id_dossier) as total,FN_GET_POSTS_IS_DOSSIERS_ON_COLLECTION(id_dossier) as on_collection, state,FN_GET_POSTS_L10N_ISO_GROUPED(2,id_dossier) as iso_grouped 
  FROM dossiers WHERE id_dossier = p_last_id;

ELSE
    SELECT -2 as return_code;
END IF;

COMMIT;

END;

