create
    definer = skoiypp@`%` procedure SP_SET_POSTS_L10N_VARIANTS(IN _id_l10n int(10), IN _id_key int(10),
                                                               IN _headline varchar(255), IN _title varchar(255),
                                                               IN _description text, IN _image varchar(255),
                                                               IN _image_title varchar(255),
                                                               IN _image_alter_text varchar(255),
                                                               IN _meta_title varchar(255), IN _meta_description text,
                                                               IN _meta_image varchar(255),
                                                               IN _meta_keywords varchar(255),
                                                               IN _meta_play_mark tinyint(1), IN _id_position int(10))
BEGIN

DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_post FROM posts_l10n WHERE id_l10n = _id_l10n)
THEN

    IF EXISTS (SELECT id_l10n FROM posts_l10n WHERE id_l10n = _id_l10n) AND EXISTS (SELECT id_key FROM posts_l10n_variants_keys WHERE id_key = _id_key)
    THEN

        IF NOT EXISTS(SELECT id_l10n FROM posts_l10n_variants_related WHERE id_l10n = _id_l10n AND id_key = _id_key)
        THEN
    		     INSERT INTO posts_l10n_variants_related(id_l10n,id_l10n,id_key,headline,title,description,image,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,meta_play_mark,position,register_date) VALUES(_id_l10n,_id_l10n,_id_key,_headline,_title,_description,_image,_meta_title,_meta_description,_meta_image,_image_title,_image_alter_text,_meta_keywords,_meta_play_mark,_id_position,now());
        ELSE
             UPDATE posts_l10n_variants_related SET headline = _headline,title = _title, description = _description, image = _image,meta_title = _meta_title,meta_description = _meta_description,meta_image = _meta_image,image_title = _image_title,image_alter_text = _image_alter_text,meta_keywords = _meta_keywords, meta_play_mark = _meta_play_mark, position = _id_position, update_date = now() WHERE id_l10n = _id_l10n AND id_key = _id_key;
        END IF;
        
        SELECT id_variant, atvr.id_l10n,avk.id_key, name,name_stripped, headline,title,description,image,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,meta_play_mark,position, atvr.register_date FROM posts_l10n_variants_related atvr, posts_l10n_variants_keys avk
    	  WHERE atvr.id_key = avk.id_key AND atvr.id_l10n = _id_l10n AND avk.id_key = _id_key;     

    ELSE
        SELECT -2 as return_code;
    END IF;

ELSE
    SELECT -2 as return_code;
END IF;

COMMIT;

END;

