create
    definer = skoiypp@`%` procedure SP_SET_POSTS_STICKER(IN _id_sticker INT(10), IN _id_group INT(10),
                                                         IN _position INT(10), IN _name VARCHAR(192),
                                                         IN _name_stripped VARCHAR(192), IN _token VARCHAR(192),
                                                         IN _image VARCHAR(255), IN _image_align VARCHAR(255),
                                                         IN _maximum_items INT(10), IN _number_of_rows INT(10),
                                                         IN _display_in VARCHAR(255), IN _id_format INT(10),
                                                         IN _link VARCHAR(255), IN _auto_feed tinyint(1),
                                                         IN _auto_feed_order VARCHAR(255), IN _auto_feed_type INT(10),
                                                         IN _color VARCHAR(255), IN _active tinyint(1))
BEGIN

DECLARE lastposition INT;
DECLARE currentposition INT;
DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF EXISTS(SELECT id_group FROM posts_stickers_groups WHERE id_group = _id_group)
THEN


SET p_last_id = 0;

  SELECT count(1) into lastposition FROM posts_stickers WHERE id_group = _id_group;

IF(_id_sticker = 0 OR _id_sticker = -1)
THEN

IF(_position = 0 OR _position = -1)
  THEN
    SET _position = lastposition+1;
  END IF;

SELECT SUBSTRING(MD5(RAND()) from 1 for 10) into _token;
WHILE NOT EXISTS(SELECT count(1) FROM posts_stickers_groups WHERE token = _token)
DO
	SELECT SUBSTRING(MD5(RAND()) from 1 for 10) into _token;
END WHILE;

        INSERT into posts_stickers(id_group,position,name,name_stripped,token,image,image_align,maximum_items,number_of_rows,display_in,id_format,link,auto_feed,auto_feed_order,auto_feed_type,color,active,update_date,register_date) VALUES(_id_group,_position,_name,_name_stripped,_token,_image,_image_align,_maximum_items,_number_of_rows,_display_in,_id_format,_link,_auto_feed,_auto_feed_order,_auto_feed_type,_color,_active,now(),now());        
        SET p_last_id = last_insert_id();

        SET @rownum=0;
        UPDATE posts_stickers c, (SELECT @rownum:=@rownum+1 rownum, posts_stickers.* FROM posts_stickers WHERE id_group = _id_group ORDER BY position) r 
        SET c.position = r.rownum
        WHERE (c.id_sticker = r.id_sticker) AND c.id_group = _id_group;
        SELECT FN_SP_SET_PUBLISH_POSTS_SYNC_UPDATE(73,_id_group) into _empty; 

		SELECT id_sticker,id_group,position, name,name_stripped,token,image,image_align,maximum_items,number_of_rows,display_in,id_format,link,auto_feed,auto_feed_order,auto_feed_type,color,active, active as state,FN_GET_POSTS_STICKERS_TOTAL_ITEMS(id_sticker) as total,FN_GET_ASSETS_ID_BY_FILENAME(image) as id_asset,FN_GET_ASSETS_WIDTH_HEIGHT_BY_ID(1,FN_GET_ASSETS_ID_BY_FILENAME(image)) as image_width,FN_GET_ASSETS_WIDTH_HEIGHT_BY_ID(2,FN_GET_ASSETS_ID_BY_FILENAME(image)) as image_height,register_date FROM posts_stickers WHERE id_sticker = p_last_id; 
ELSE       

     IF EXISTS (SELECT id_sticker FROM posts_stickers WHERE id_sticker = _id_sticker)
     THEN

        SELECT position into currentposition FROM posts_stickers WHERE id_sticker = _id_sticker AND id_group = _id_group;
		UPDATE posts_stickers SET position = _position,name = _name,name_stripped = _name_stripped,image = _image,image_align = _image_align,maximum_items = _maximum_items,number_of_rows = _number_of_rows,display_in = _display_in,id_format = _id_format,link = _link,auto_feed = _auto_feed,auto_feed_order = _auto_feed_order,auto_feed_type = _auto_feed_type,color = _color,active = _active, update_date = now() WHERE id_sticker = _id_sticker;
		
		 IF(_position < currentposition)
		 THEN   
			SET @rownum=0;
			UPDATE posts_stickers c, (SELECT @rownum:=@rownum+1 rownum, posts_stickers.* FROM posts_stickers WHERE id_group = _id_group ORDER BY position,update_date desc) r 
			SET c.position = r.rownum
			WHERE (c.id_sticker = r.id_sticker) AND c.id_group = _id_group;
			SELECT FN_SP_SET_PUBLISH_POSTS_SYNC_UPDATE(73,_id_group) into _empty; 
		 ELSE
			SET @rownum=0;
			UPDATE posts_stickers c, (SELECT @rownum:=@rownum+1 rownum, posts_stickers.* FROM posts_stickers WHERE id_group = _id_group ORDER BY position,update_date asc) r 
			SET c.position = r.rownum
			WHERE (c.id_sticker = r.id_sticker) AND c.id_group = _id_group;
			SELECT FN_SP_SET_PUBLISH_POSTS_SYNC_UPDATE(73,_id_group) into _empty; 
		 END IF;   

        SELECT id_sticker,id_group,position, name,name_stripped,token,image,image_align,maximum_items,number_of_rows,display_in,id_format,link,auto_feed,auto_feed_order,auto_feed_type,color,active,active as state, FN_GET_POSTS_STICKERS_TOTAL_ITEMS(id_sticker) as total,FN_GET_ASSETS_ID_BY_FILENAME(image) as id_asset,FN_GET_ASSETS_WIDTH_HEIGHT_BY_ID(1,FN_GET_ASSETS_ID_BY_FILENAME(image)) as image_width,FN_GET_ASSETS_WIDTH_HEIGHT_BY_ID(2,FN_GET_ASSETS_ID_BY_FILENAME(image)) as image_height,register_date FROM posts_stickers WHERE id_sticker = _id_sticker; 
    
    ELSE
        SELECT -2 as return_code;
     END IF;
     
END IF;

     ELSE
        SELECT -2 as return_code;
     END IF;
COMMIT;

END;

