create
    definer = skoiypp@`%` procedure SP_SET_POSTS_TAGS(IN _id_tag INT, IN _id_group INT, IN _name VARCHAR(192),
                                                      IN _name_stripped VARCHAR(192), IN _public TINYINT(1))
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF (_id_group = 0 OR _id_group = -1)
THEN
    SET _id_group = 1;
END IF;

IF NOT EXISTS (SELECT id_group FROM posts_tags_groups WHERE id_group = 1)
THEN
    INSERT INTO posts_tags_groups(id_group,name,register_date) VALUES(1,'root',now());
END IF;

IF(_id_tag = 0 OR _id_tag = -1)
THEN
        INSERT into posts_tags(id_group,name,name_stripped,public,register_date) VALUES(_id_group,_name,_name_stripped,_public,now());        
        SET p_last_id = last_insert_id();
        SELECT id_tag,id_group,name,name_stripped,FN_GET_POSTS_TAGS_TOTAL_POSTS(id_tag) as total,FN_GET_POSTS_TAGS_KEYS_GROUPED(id_tag) as tag_keys,FN_GET_POSTS_TAGS_VARIANTS_GROUPED(id_tag) as tag_variants,public,register_date FROM posts_tags WHERE id_tag = p_last_id; 
ELSE       
     IF EXISTS (SELECT id_tag FROM posts_tags WHERE id_tag = _id_tag)
     THEN
		SELECT FN_SP_SET_PUBLISH_POSTS_SYNC_UPDATE(50,_id_tag) into _empty;
		UPDATE posts_tags SET id_group = _id_group,name = _name,name_stripped = _name_stripped,public = _public, update_date = now() WHERE id_tag = _id_tag;
		SELECT id_tag,id_group,name,name_stripped,FN_GET_POSTS_TAGS_TOTAL_POSTS(id_tag) as total,FN_GET_POSTS_TAGS_KEYS_GROUPED(id_tag) as tag_keys,FN_GET_POSTS_TAGS_VARIANTS_GROUPED(id_tag) as tag_variants,public,register_date FROM posts_tags WHERE id_tag = _id_tag; 
     ELSE
        SELECT -2 as return_code;
     END IF;
END IF;
COMMIT;

END;

