create
    definer = skoiypp@`%` procedure SP_SET_PUBLISH_POSTS_DOSSIERS_TO_OFFLINE()
BEGIN

DECLARE no_more_rows INT DEFAULT FALSE;
DECLARE num_rows INT DEFAULT 0;
DECLARE c_id_dossier INT;
DECLARE _empty INT;

DECLARE cursor_id_dossier CURSOR FOR SELECT id_dossier FROM dossiers WHERE end_date < now() AND date(end_date) NOT IN ('0000-00-00') AND id_dossier in (SELECT id_dossier FROM dossiers_collections_related);
DECLARE CONTINUE HANDLER FOR NOT FOUND SET no_more_rows = TRUE;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

 
   
    OPEN cursor_id_dossier;
    SELECT FOUND_ROWS() into num_rows;
    
      read_loop: LOOP
        FETCH cursor_id_dossier INTO c_id_dossier;
    
        IF no_more_rows THEN
          LEAVE read_loop;
        END IF;
      
	
 
		SELECT FN_SP_SET_PUBLISH_POSTS_SYNC_UPDATE(31,c_id_dossier) into _empty;

       UPDATE posts_l10n SET state = 4 WHERE id_post in (select id_post FROM posts_dossiers_related WHERE id_dossier = c_id_dossier);           
       DELETE FROM dossiers_collections_related WHERE id_dossier = c_id_dossier;
     
	
    
      END LOOP read_loop;

    CLOSE cursor_id_dossier;
 

	SELECT 0 as return_code;

COMMIT;

END;

