create
    definer = skoiypp@`%` procedure SP_SET_PUBLISH_POSTS_TO_SCHEDULE_ON_IDLE_DOSSIERS()
BEGIN

DECLARE no_more_rows INT DEFAULT FALSE;
DECLARE num_rows INT DEFAULT 0;
DECLARE c_id_dossier INT;

DECLARE cursor_id_dossier_idle CURSOR FOR SELECT id_dossier FROM dossiers WHERE id_dossier not in (SELECT id_dossier FROM dossiers_collections_related);
DECLARE CONTINUE HANDLER FOR NOT FOUND SET no_more_rows = TRUE;



DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

 
   
    OPEN cursor_id_dossier_idle;
    SELECT FOUND_ROWS() into num_rows;
    
      read_loop: LOOP
        FETCH cursor_id_dossier_idle INTO c_id_dossier;
    
        IF no_more_rows THEN
          LEAVE read_loop;
        END IF;
      
	
		
       UPDATE posts_l10n SET state = 4 WHERE id_post in (select id_post FROM posts_dossiers_related WHERE id_dossier = c_id_dossier) AND 
		(SELECT FN_GET_POSTS_IS_POSTS_ON_DOSSIER(id_post)) = 1;
		           
	
    
      END LOOP read_loop;

    CLOSE cursor_id_dossier_idle;
 

	SELECT 0 as return_code;

COMMIT;

END;

