create
    definer = skoiypp@`%` procedure SP_SET_PUBLISH_VIDEO_SYNC(IN _id int, IN _id_sync varchar(255),
                                                              IN _id_rev_sync varchar(255), IN _type tinyint(1))
BEGIN


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_type = 1)
THEN
	IF (SELECT count(1) FROM video_composed WHERE id_composed = _id)
	THEN
		UPDATE video_composed SET id_sync = _id_sync, id_rev_sync = _id_rev_sync, update_date = now() WHERE id_composed = _id ;
		SELECT id_composed,id_sync,id_rev_sync,register_date FROM video_composed WHERE id_composed = _id;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;

IF(_type = 10)
THEN
	IF (SELECT count(1) FROM video_composed WHERE id_composed = _id)
	THEN
		UPDATE video_composed SET id_sync_player = _id_sync, id_rev_sync_player = _id_rev_sync, update_date = now() WHERE id_composed = _id;
		SELECT id_composed,id_sync_player,id_rev_sync_player,register_date FROM video_composed WHERE id_composed = _id;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;

IF(_type = 2)
THEN
	IF (SELECT count(1) FROM playlists WHERE id_playlist = _id)
	THEN
		UPDATE playlists SET id_sync = _id_sync, id_rev_sync = _id_rev_sync WHERE id_playlist = _id;
		SELECT id_playlist,id_sync,id_rev_sync,register_date FROM playlists WHERE id_playlist = _id;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;

IF(_type = 3)
THEN
	IF (SELECT count(1) FROM channels WHERE id_channel = _id)
	THEN
		UPDATE channels SET id_sync = _id_sync, id_rev_sync = _id_rev_sync WHERE id_channel = _id;
		SELECT id_channel,id_sync,id_rev_sync,register_date FROM channels WHERE id_channel = _id;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;


IF(_type not in(1,2,3,10))
THEN
	SELECT -3 as return_code;
END IF;

COMMIT;

END;

