create
    definer = skoiypp@`%` procedure SP_SET_VIDEO_CHANNELS(IN _id_channel int, IN _management_name varchar(192),
                                                          IN _publish_date datetime, IN _begin_date datetime,
                                                          IN _end_date datetime, IN _domain varchar(192),
                                                          IN _default_id_playlist int, IN _position int)
BEGIN

DECLARE lastposition INT;
DECLARE currentposition INT;
DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET p_last_id = 0;

  SELECT count(1) into lastposition FROM channels;
  IF(_position = lastposition)
  THEN
    SET _position = _position+1;
  END IF;


IF(_id_channel = 0 OR _id_channel = -1)
THEN
   INSERT into channels(management_name,publish_date,begin_date,end_date,domain,default_id_playlist,update_date,register_date) VALUES(_management_name,_publish_date,_begin_date,_end_date,_domain,_default_id_playlist,now(),now());
   SET p_last_id = last_insert_id();
    
    SET @rownum=0;
    UPDATE channels c, (SELECT @rownum:=@rownum+1 rownum, channels.* FROM channels ORDER BY position,update_date desc) r 
    SET c.position = r.rownum
    WHERE (c.id_channel = r.id_channel);

   SELECT id_channel,management_name,publish_date,begin_date,end_date,domain,default_id_playlist, position,state, register_date FROM channels WHERE id_channel = p_last_id;
ELSE
  IF EXISTS (SELECT id_channel FROM channels WHERE id_channel = _id_channel)
  THEN     
  
  SELECT position into currentposition FROM channels WHERE id_channel = _id_channel;
	SELECT FN_SP_SET_PUBLISH_VIDEO_SYNC_UPDATE(14,_id_channel) into _empty;

	UPDATE channels SET management_name = _management_name, publish_date = _publish_date,begin_date = _begin_date, end_date = _end_date,domain = _domain,default_id_playlist = _default_id_playlist, position = _position, update_date = now() WHERE id_channel = _id_channel;
	  
 IF(currentposition <> _position)
 THEN   
    SET @rownum=0;
    UPDATE channels c, (SELECT @rownum:=@rownum+1 rownum, channels.* FROM channels ORDER BY position,update_date desc) r 
    SET c.position = r.rownum
    WHERE (c.id_channel = r.id_channel);
    SELECT FN_SP_SET_PUBLISH_VIDEO_SYNC_UPDATE(60,-1) into _empty; 
 END IF;   

  SELECT id_channel,management_name,publish_date,begin_date,end_date,domain,default_id_playlist, position,state, register_date FROM channels WHERE id_channel = _id_channel;
  ELSE
    SELECT -2 as return_code;
  END IF;
END IF;  
  
COMMIT;

END;

