create
    definer = skoiypp@`%` procedure SP_SET_VIDEO_EMBED(IN _id int(10), IN _source_type int(1), IN _source_id int(1),
                                                       IN _format varchar(255), IN _type varchar(10),
                                                       IN _variant varchar(10), IN _name varchar(255),
                                                       IN _active tinyint(1))
BEGIN


DECLARE sqlcommand text;
DECLARE p_last_id INT UNSIGNED;

DECLARE _code VARCHAR(192);
DECLARE _prefix VARCHAR(255);
DECLARE _numbers INT(10);
DECLARE _lowercase INT(10);
DECLARE _uppercase INT(10);
DECLARE _length INT(10);


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_id = 0 OR _id = -1)
THEN

SET _prefix = '';
SET _numbers = 1;
SET _lowercase = 0;
SET _uppercase = 0;
SET _length = 10;

			SELECT FN_GENERATE_RANDOM_CODE(_prefix,_numbers,_lowercase,_uppercase,_length) into _code;
			WHILE NOT EXISTS(SELECT count(1) FROM video_embeds WHERE code = _code)
			DO
				SELECT FN_GENERATE_RANDOM_CODE(_prefix,_numbers,_lowercase,_uppercase,_length) into _code;
			END WHILE;

			INSERT into video_embeds(code,source_type,source_id,format,type,variant,name,active,register_date)
			VALUES(_code,_source_type,_source_id,_format,_type,_variant,_name,_active,now());
			SET p_last_id = last_insert_id();
            
            
            
            IF EXISTS( SELECT id_option FROM video_embeds_options_types_variants_related WHERE type = _type AND variant = _variant)
            THEN
					INSERT into video_embeds_options_related(id,id_option,option_value,register_date)
                    SELECT p_last_id,id_option,default_option_value,now() FROM video_embeds_options_types_variants_related WHERE type = _type AND variant = _variant; 
            END IF;
            
            
			SELECT id,code,source_type,source_id,format,type,variant,name,active,update_date,register_date FROM video_embeds WHERE id = p_last_id;

ELSE
     IF EXISTS (SELECT id FROM video_embeds WHERE id = _id)
     THEN
     		UPDATE video_embeds SET name = _name, active = _active, update_date = now() WHERE id = _id;
     		SELECT id,code,source_type,source_id,format,type,variant,name,active,update_date,register_date FROM video_embeds WHERE id = _id;
     ELSE
				SELECT -2 as return_code;
     END IF;
END IF;

COMMIT;

END;

