create
    definer = skoiypp@`%` procedure SP_SET_VIDEO_EMBED_VIDEO_COMPOSED_RELATED(IN _id int(10), IN _id_composed int(10),
                                                                              IN _position int(10),
                                                                              IN _headline varchar(255),
                                                                              IN _title varchar(255),
                                                                              IN _description varchar(255),
                                                                              IN _action_name varchar(255),
                                                                              IN _link varchar(255))
BEGIN


DECLARE sqlcommand text;
DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id FROM video_embeds WHERE id = _id) AND EXISTS (SELECT id_composed FROM video_composed WHERE id_composed = _id_composed)
THEN
	IF EXISTS (SELECT id FROM video_embeds_video_composed_related WHERE id = _id AND id_composed = _id_composed)
	THEN
		UPDATE video_embeds_video_composed_related SET position = _position,headline = _headline,title = _title,description = _description,action_name = _action_name,link = _link, update_date = now() WHERE id = _id AND id_composed = _id_composed;
	ELSE
		INSERT into video_embeds_video_composed_related(id,id_composed,position,headline,title,description,action_name,link,register_date)
		VALUES(_id,_id_composed,_position,_headline,_title,_description,_action_name,_link,now());
	END IF;
	SELECT id,id_composed,position,headline,title,description,action_name,link,register_date FROM video_embeds_video_composed_related WHERE id = _id AND id_composed = _id_composed;
ELSE
	SELECT -2 as return_code;
END IF;

COMMIT;

END;

